@ echo off

call "%~dp0\setCommonEnv.bat"

setlocal
set DB_USERNAME=postgres
set CACL_CMD="%SystemRoot%\system32\icacls.exe"
set DB_PASSWORD=%1
set DATA_DIR="%DB_HOME%\data"
set IS_INITDB_REQUIRED=false

echo "%DB_HOME%"

mkdir  "%DB_HOME%\tmp"
IF (%DB_PASSWORD%) == () (GOTO BEGIN) ELSE (GOTO SET_AUTHMODE)

:SET_AUTHMODE
	echo %DB_PASSWORD%>"%DB_HOME%\tmp\pwd.txt"
	echo "Authentication mode set to MD5 for Postgres"
	set DB_AUTHMODE=--pwfile "%DB_HOME%\tmp\pwd.txt" -A md5

:BEGIN
	echo "Creating data directory"
	if EXIST %DATA_DIR% (GOTO CHANGEPERMISSION) ELSE (GOTO CREATE_DATADIR)

:CREATE_DATADIR
	set IS_INITDB_REQUIRED=true
	mkdir %DATA_DIR%

:CHANGEPERMISSION
	rem icacls.exe will be present in the %SystemRoot%\system32 directory.	
	IF NOT EXIST "%SystemRoot%\system32\icacls.exe" GOTO CHANGEPERMISSION_USING_CACL
	echo "Grant privileges for data directory using %CACL_CMD% ..."
	%CACL_CMD% %DATA_DIR% /grant *S-1-5-11:(NP)(RX)
	%CACL_CMD% %DATA_DIR% /T /grant:r *S-1-5-11:(OI)(CI)F
	%CACL_CMD% %DATA_DIR% /T /C /grant *S-1-5-11:(OI)(CI)(F)
	GOTO TRY_INITDB

:CHANGEPERMISSION_USING_CACL
	rem In windows xp 32-bit, we need to use cacls.exe instead of cacls.exe
	set CACL_CMD="%SystemRoot%\system32\cacls.exe"
	set SID=S-1-5-11
	echo Getting ACCOUNT_NAME for SID - %SID%
	"%SERVER_HOME%\bin\ConvertSIDTOAccountName.exe" > "%DB_HOME%\tmp\accName.txt"
	IF %ERRORLEVEL% NEQ 0 GOTO SidLookUpErrorMsg
	set /p ACCOUNT_NAME= < "%DB_HOME%\tmp\accName.txt"
	echo ACCOUNT_NAME sid ::: %ACCOUNT_NAME%
	echo "Grant privileges for data directory using %CACL_CMD% ..."
	%CACL_CMD% %DATA_DIR% /E /G "%ACCOUNT_NAME%":R
	%CACL_CMD% %DATA_DIR% /E /T /C /G "%ACCOUNT_NAME%":F

:TRY_INITDB
	echo "IS_INITDB_REQUIRED ::: %IS_INITDB_REQUIRED%"
	IF "%IS_INITDB_REQUIRED%" == "true" (GOTO RUN_INITDB) ELSE (GOTO SET_LOCALTIMEZONE)

:SET_LOCALTIMEZONE
	echo "Data directory already initialized. Hence setting local environment time zone"
	"%SERVER_HOME%\tools\postgres\bin\gettimezone.exe" "%DB_HOME%/share/" %DATA_DIR%\postgresql.conf
	GOTO PROCEED

:RUN_INITDB
	echo "Running Postgres initdb..."
	"%DB_HOME%\bin\initdb.exe" -U %DB_USERNAME% -D %DATA_DIR% --no-locale -E UTF8 %DB_AUTHMODE%

:PROCEED
	IF %ERRORLEVEL% == 0 GOTO Success
	IF %ERRORLEVEL% NEQ 0 GOTO PrintErrorMsg

:Success

	echo initDB process successfull.
	goto End

:SidLookUpErrorMsg
	echo Problem while lookup SID account name.
	set /p RETURNED_MSG= < "%DB_HOME%\tmp\accName.txt"
	echo Error message returned :: %RETURNED_MSG%

:PrintErrorMsg
	echo Problem while initializing DB.

:End
	if EXIST "%DB_HOME%\tmp" (rmdir /S /Q "%DB_HOME%\tmp")

endlocal
