@ echo off
rem ### ====================================================================== ###
rem ##                                                                          ##
rem ## change_datadir_perm.bat  <path-to-data-directory>
rem ##                                                                          ##
rem ### ====================================================================== ###
rem Script file to change PostgreSQL datadirectory permission in Windows.

call "%~dp0\setCommonEnv.bat"

setlocal
set DB_USERNAME=postgres
set CACL_CMD="%SystemRoot%\system32\icacls.exe"
set DATA_DIR="%DB_HOME%\data"
set SCRIPT_ARG=%1

IF (%SCRIPT_ARG%) == () (GOTO CHANGEPERMISSION) ELSE (GOTO SET_DATA_DIR_PATH)

:SET_DATA_DIR_PATH
	echo DATA_DIR = %SCRIPT_ARG%
	set DATA_DIR=%SCRIPT_ARG%
	set DB_HOME="%DATA_DIR%\..\"
	GOTO CHANGEPERMISSION
	
:CHANGEPERMISSION
	
	rem icacls.exe will be present in the %SystemRoot%\system32 directory.	
	IF NOT EXIST "%SystemRoot%\system32\icacls.exe" GOTO CHANGEPERMISSION_USING_CACL
	echo "Grant privileges for data directory using %CACL_CMD% ..."
	%CACL_CMD% %DATA_DIR% /grant *S-1-5-11:(NP)(RX)
	%CACL_CMD% %DATA_DIR% /T /grant:r *S-1-5-11:(OI)(CI)F
	%CACL_CMD% %DATA_DIR% /T /C /grant *S-1-5-11:(OI)(CI)(F)
	GOTO PROCEED

:CHANGEPERMISSION_USING_CACL
	rem In windows xp 32-bit, we need to use cacls.exe instead of cacls.exe
	set TMP_DIR="%DB_HOME%\..\tmp"
	mkdir %TMP_DIR%
	set CACL_CMD="%SystemRoot%\system32\cacls.exe"
	set SID=S-1-5-11
	echo 	"%SERVER_HOME%\bin\ConvertSIDTOAccountName.exe"
	echo Getting ACCOUNT_NAME for SID - %SID%
	"%SERVER_HOME%\bin\ConvertSIDTOAccountName.exe" > %TMP_DIR%\accName.txt
	IF %ERRORLEVEL% NEQ 0 GOTO SidLookUpErrorMsg
	set /p ACCOUNT_NAME= < %TMP_DIR%\accName.txt
	echo ACCOUNT_NAME sid ::: %ACCOUNT_NAME%
	echo "Grant privileges for data directory using %CACL_CMD% ..."
	%CACL_CMD% %DATA_DIR% /E /G "%ACCOUNT_NAME%":R
	%CACL_CMD% %DATA_DIR% /E /T /C /G "%ACCOUNT_NAME%":F

:PROCEED
	IF %ERRORLEVEL% == 0 GOTO SUCCESS
	IF %ERRORLEVEL% NEQ 0 GOTO PrintErrorMsg

:SUCCESS
	echo Permissions changed sucessfully.
	goto End

:SidLookUpErrorMsg
        echo Problem while lookup SID account name.
        set /p RETURNED_MSG= < "%DB_HOME%\tmp\accName.txt"
        echo Error message returned :: %RETURNED_MSG%

:PrintErrorMsg
        echo Problem while setting permissions.

:End
        if EXIST "%TMP_DIR%" (rmdir /S /Q "%TMP_DIR%")


endlocal
