
function validateEmailAddress(email)
{
    var emailStr = email;
    var emailPat = /^(.+)@(.+)$/;
    var matchArray = emailStr.match(emailPat);

    if (matchArray == null)
    {
        return false;
    }
    return true;
}
function getI18NwithParams(i18nkey,paramsarray){
    var value =  Ember.I18n.t(i18nkey,this);
    if(paramsarray !== undefined ){
        var arrayLength = paramsarray.length;
        for (var i = 0; i < arrayLength; i++) {
            value = value.replace("{"+i+"}",paramsarray[i]);
        }
    }
    return value;
}
function isSpecialCharacter(dnsname)
{
    for (i=0; i<dnsname.length; i++)
    {
        var ipChar = dnsname.charCodeAt(i);
        if ((ipChar < 48 && ipChar != 45 && ipChar != 46) || (ipChar > 57 && ipChar < 65) || (ipChar > 90 && ipChar != 95 && ipChar < 97 ) || (ipChar > 122 && ipChar <= 125) || ipChar == 126)
        {
            return true;
        }
    }
	return false;
}
function isNumber(str)
{ 
	str = trimAll(str);
	if(str.length==0){ return false;}
	numdecs = 0; 
	for (i = 0; i < str.length; i++) 
	{
		mychar = str.charAt(i); 
		if ((mychar >= "0" && mychar <= "9") || mychar == "." )
		{ 
		if (mychar == "."){ 
		numdecs++; }
		} 
		else{ return false; }
	} 
		if (numdecs > 1){return false;} 
		return true; 
}
var valueSpChars = "?&%'\"_`\\+";//NO I18N

function invalidCharsExist(str)
{
	for(var i=0;i<valueSpChars.length;i++)
	{
		for(var j=0;j<str.length;j++)
		{
			if(str.charAt(j)==valueSpChars.charAt(i))
			{
				return true;
			}
		}
	}
	return false;
}
function showRouterImportCSVInfo()
{
    window.open("/html/routerInputCSVFormat.html");
}

function moveFromSelToAvailAndWiseVersa(listFlag) {
    var sourceList = document.getElementById("availableReport");
    var destList = document.getElementById("selectedReport");
    var opt,i=0;
    var listlen = sourceList.length;
    if(listFlag === 'SEL_RPT') {
        listlen = destList.length;
    }
    var tempLen = listlen;
    var isExist = false;
    var moveListArray = new Array();
    var arrIndex = 0;
    while(listlen > 0) {
        if(listFlag == 'SEL_RPT') {
            opt = destList.options[i++];
            if(opt.selected && (opt.index >= 0)) {
                isExist = isElementExist(opt.value,sourceList);
                if(isExist) {
                    var option = document.createElement("option");
                    option.text = opt.text;
                    option.value = opt.value;
                    option.title = opt.text;
                    sourceList.add(option);
                    moveListArray[arrIndex++] = opt.index;
                }
            }
        } else {
            opt = sourceList.options[i++];
            if(opt.selected && (opt.index >= 0)) {
                isExist = isElementExist(opt.value,destList);
                if(isExist) {
                    option = document.createElement("option");
                    option.text = opt.text;
                    option.value = opt.value;
                    option.title = opt.text;
                    destList.add(option);
                    moveListArray[arrIndex++] = opt.index;
                }
            }
        }
        listlen--;
    }
    if(listFlag == 'SEL_RPT') {
        removeAfterMove(tempLen,moveListArray,destList);
        opt = destList.options[0];
        
    } else {
        removeAfterMove(tempLen,moveListArray,sourceList);
        opt = sourceList.options[0];
    }
    if(opt) {
        opt.selected = true;
    }
}
function removeAfterMove(tempLen,moveListArray,sourceList) {
    while(tempLen >= 0 ) {
        for(var j=0; j <= moveListArray.length;j++) {
            if(moveListArray[j] == tempLen) {
                sourceList.options[tempLen] = null;
            }
        }
        tempLen--
    }
}

function isElementExist(val,destList) {
    var selectedColList = destList.length;
    for(i = 0; i < selectedColList; i++) {
        if(destList.options[i].value == val) {
            return false;
        }
    }
    return true;
}

function checkRecurrenceValues()
{
	var scheduleType = OpUtilsClient.ReportsController.scheduleReportType;
        var hourVal = $("#"+scheduleType+"Hour").val();
        var minutesVal = $("#"+scheduleType+"Minutes").val();
        if(!isHour(hourVal))
        {
            alert(Ember.I18n.t("opu.common.PLEASE_ENTER_A_SUITABLE_VALUE_FOR_HOUR",this));// No I18N
            $("#"+scheduleType+"Hour").focus();
            return false;
        }
        if(!isMinute(minutesVal))
        {
            alert(Ember.I18n.t("opu.common.PLEASE_ENTER_A_SUITABLE_VALUE_FOR_MIN",this));// No I18N
            $("#"+scheduleType+"Minutes").focus();
            return false;
        }
	if(scheduleType == 'Weekly')
	{  
            var daysOfWeekCheck=false;
            var weeklyDays = document.getElementsByName("WEEKLY_DAYS");
            var len = weeklyDays.length;
            for(var j=0;j<len;j++)
            {
                if(weeklyDays[j].checked == true)
                {
                    daysOfWeekCheck=true;
                }
            }
            if(daysOfWeekCheck == false)
            {
                alert(Ember.I18n.t("opu.common.PLEASE_SELECT_A_DAY",this));// No I18N
                return false;
            }
	}
	else if(scheduleType == 'Monthly')
	{     
            var monthlyMonthsCheck=false;
            var monthlyMonths = document.getElementsByName("MONTHLY_MONTHS");
            var len = monthlyMonths.length;
            for(var j=0;j<len;j++)
            {
                if(monthlyMonths[j].checked == true)
                {
                    monthlyMonthsCheck=true;
                }
            }
            if(monthlyMonthsCheck == false)
            {
                alert(Ember.I18n.t("opu.common.PLEASE_SELECT_A_MONTH",this));// No I18N
                return false;
            }
	}
	return true;
}

function isHour(str){
        str = trimAll(str);
        if(str==""){
                return false;
        }
        var regEx = /^[0-9]+$/;
        if(regEx.test(str)){
                if(str <= 23){
                        return true;
                }
        }
        return false;
}

function isMinute(str){
        str = trimAll(str);
        if(str==""){
                return false;
        }
        var regEx = /^[0-9]+$/;
        if(regEx.test(str)){
                if(str <= 59){
                        return true;
                }
        }
        return false;
}

function deviceStatusIcon(cellValue, options, rowdata, action)
{
    if(cellValue === "1" || cellValue == 1){//NO I18N
        return "<div><img src='/images/statusUp.gif' >&nbsp;<span style='vertical-align: top;'>"+Ember.I18n.t('opu.common.UP',this)+"</span></div>";//NO I18N
    }else{
        return "<div><img src='/images/statusDown.gif' >&nbsp;<span style='vertical-align: top;'>"+Ember.I18n.t('opu.common.DOWN',this)+"</span></div>";//NO I18N 
    }
}
function SeverityStatusIcon(cellValue, options, rowdata, action)
{
    if(cellValue === "1" || cellValue === 1 ){//NO I18N
        return "<div><img src='/images/warning.gif' >&nbsp;<span style='vertical-align: top;'>"+Ember.I18n.t('opu.common.WARNING',this)+"</span></div>";//NO I18N
    }else if(cellValue == "2" || cellValue === 2){
        return "<div><img src='/images/major.gif' >&nbsp;<span style='vertical-align: top;'>"+Ember.I18n.t('opu.common.MAJOR',this)+"</span></div>";//NO I18N 
    }else{
        return "<div><img src='/images/critical.gif' >&nbsp;<span style='vertical-align: top;'>"+Ember.I18n.t('opu.common.CRITICAL',this)+"</span></div>";//NO I18N 
    }
}
function addPercentageSymble(cellValue, options, rowdata, action)
{
    return cellValue+" %";//NO I18N
}

//This Handlebars used for replace string in i18n value.
//How to use this handlebar
/*
 * i18n key(.js) : 'opu.common.value_lessthen':'your value less then rp0',
 * usage in .handlebars : {{top opu.common.value_lessthen rp0=66666 }}
 */
Handlebars.registerHelper('top', function(key, options) {//No I18N
    var attrs, context;
    context = this;
    attrs = options.hash;
    var textHtml = Handlebars.helpers.t(key ,options);
    var text = textHtml.toString();
    var i=0;
    Em.keys(attrs).forEach(function(property) {
        if(text.indexOf("rp"+i) !== -1){
            text = text.replace(property, attrs[property]);
        }
        i++;
    });
    return new Handlebars.SafeString(text);
});
Handlebars.registerHelper('opstaticval', function(key, options) {//No I18N
    var attrs, context;
    context = this;
    attrs = options.hash;
    var textHtml = Handlebars.helpers.t(key ,options);
    var text = textHtml.toString();
    var i=0;
    Em.keys(attrs).forEach(function(property) {
        text = text.replace("{"+i+"}", getOpUtilsStaticValue(attrs[property]));
        i++;
    });
    return new Handlebars.SafeString(text);
});
function setExpiryValue()
{
    document.getElementById('keyExpiryTimeVal').value = -1;
    //        document.getElementById('keyExpiryTimeVal_Display').value = "";
}
function modKeyUserIPAM(){
    
    var userName = window.oputilsUserName;
    var domainName = window.domainName;
    if(domainName.length >0){
        userName = domainName + "\\" + userName;
    }
//    var date=null;
//    if(!document.getElementById('expiry').checked && !document.getElementById('never').checked){
//        alert(I18nUtil.getMsg("opu.common.CHOOSE_AN_OPTION_TO_GENERATE_API")); 
//        return false;
//    }
//    if(document.getElementById('expiry').checked){
//        date=document.getElementById('updateDate').value;
//        if(date==""){
//            alert(I18nUtil.getMsg("opu.common.PLEASE_ENTER_A_VALID_EXPIRY_DATE")); 
//            return false;
//        }
//    }
//    document.getElementById('apiform').style.display='none';
//    document.getElementById('apikey').style.display='';
//    document.getElementById("keyGen").style.display='none';
//    document.getElementById("dynamicKeyGen").style.display='';
//    document.getElementById('dynamicKeyGen').value=I18nUtil.getMsg("opu.common.REGENERATE_API_KEY"); 
//    var myAnonFunction = function(response,reqOptions)
//    {
//        var resPart=AjaxUtils.extractFromResponse(response.responseText,"STATUS_MESSAGE");  //NO I18N
//        document.getElementById("apiKeyVal").innerHTML=resPart;
//    };
//    AjaxAPI.sendRequest({
//        URL:CONTEXT_PATH+"/commonaction.do?actionFrom=genApiKey&expiryDate="+date+"&userName="+userName, //NO I18N 
//        ONSUCCESSFUNC:myAnonFunction
//    });
}
function showApiDiv(){
    document.getElementById('apiform').style.display='block';
    document.getElementById('apikey').style.display='none';
    document.getElementById("keyGen").style.display='block';
    document.getElementById("keyGen").style.width='95px';
    document.getElementById("dynamicKeyGen").style.display='none';
}
function getOpUtilsStaticValue(key){
    if(key === "SupportedDB"){
        return oputilsDBSupportedForDBM(oputilsStaticValues.DBName)//No I18N
    }else{
        return oputilsStaticValues[key]
    }
}
function oputilsDBSupportedForDBM(currentDB){
    currentDB = currentDB.toLowerCase();
    if (window.isWindows) {
        if (currentDB === "firebird") {//No I18N
            return "PostGres/MS SQL";//No I18N
        } else if (currentDB === "postgres") {//No I18N
            return "MS SQL";//No I18N
        }
    } else {
        if (currentDB === "firebird") {//No I18N
            return "PostGres";//No I18N
        }
    }
    return "";//No I18N
}

function checkPublishLocation(val) {
    var isDisplayWarningMessage = document.getElementById('isDisplayWarningMessage').value;
    if(val == '1') { // this is default location
        document.getElementById('defaultDirID').style.display = "block";
        document.getElementById('userSpecifyDirID').style.display = "none";
        document.getElementById('histLocationFlag').value= "1";// Default location, if user changed the location, it will set as 2
        document.getElementById('DefaultLocation').checked = true;
        if(document.getElementById('publishLocationType').value==1 && isDisplayWarningMessage == 0){
            document.getElementById('warningMessage').style.visibility = "hidden";
        }
        else{
            document.getElementById('warningMessage').style.visibility = "visible";
        }
    } else {
        document.getElementById('userSpecifyDirID').style.display = "block";
        document.getElementById('defaultDirID').style.display = "none";
        document.getElementById('histLocationFlag').value= "2";
        document.getElementById('SpecifyLocation').checked = true;
        if(document.getElementById('publishLocationType').value == 2 && isDisplayWarningMessage == 0){
            document.getElementById('warningMessage').style.visibility = "hidden";
        }
        else{
            document.getElementById('warningMessage').style.visibility = "visible";
        }
    }
}
function checkSPMPublishReportBy()
{
    if(document.getElementById("maintainLastScan").checked){
        document.getElementById("SPMPublishReportByDiv").style.display = "none";
    }else{
        document.getElementById("SPMPublishReportByDiv").style.display = "block";
    }
}
function checkIpamPublishLocation(val) {
    var isDisplayWarningMessage = document.getElementById('isDisplayWarningMessage').value;
   if(val == '1') { // this is default location
        document.getElementById('defaultDirID').style.display = "block";
        document.getElementById('userSpecifyDirID').style.display = "none";
        document.getElementById('histLocationFlag').value= "1";// Default location, if user changed the location, it will set as 2
        document.getElementById('DefaultLocation').checked = true;
        if(document.getElementById('publishLocationType').value==1 && isDisplayWarningMessage == 0){
            document.getElementById('warningMessage').style.visibility = "hidden";
        }
        else{
            document.getElementById('warningMessage').style.visibility = "visible";
        }
   } else {
       document.getElementById('userSpecifyDirID').style.display = "block";
       document.getElementById('defaultDirID').style.display = "none";
       document.getElementById('histLocationFlag').value= "2";
       document.getElementById('SpecifyLocation').checked = true;
        if(document.getElementById('publishLocationType').value==2 && isDisplayWarningMessage == 0){
            document.getElementById('warningMessage').style.visibility = "hidden";
        }
        else{
            document.getElementById('warningMessage').style.visibility = "visible";
        }
      }
}



 function chkChange(item){
     if(item.checked && item.id.indexOf("MAIL_")!=-1){
         document.getElementById("mailRelated").style.display="";
//	 callResize();
     }else if(item.checked && item.id.indexOf("SYS_")!=-1){
         document.getElementById("sysRelated").style.display="";
//	 callResize();
     }else if(!item.checked){
         initialSettingsForIPAM();
     }
}

function initialSettingsForIPAM()
{
    var inputs = document.getElementsByTagName("input");
    var flag=0;
    for(var i = 0; i < inputs.length; i++) {
        if(inputs[i].type == "checkbox" && inputs[i].name.indexOf("MAIL_") == 0 && inputs[i].checked) {
            document.getElementById("mailRelated").style.display="";
            flag=1;
//	    callResize();
            break;
        }
    }
    if(flag==0){
    document.getElementById("mailRelated").style.display="none";
//    callResize();
    }
    flag=0;
    for(i = 0; i < inputs.length; i++) {
        if(inputs[i].type == "checkbox" && inputs[i].name.indexOf("SYS_") == 0 && inputs[i].checked) {
            document.getElementById("sysRelated").style.display="";
//	    callResize();
            flag=1;
            break;
        }
    }
    if(flag==0){
        document.getElementById("sysRelated").style.display="none";
//	callResize();
    }
}

function selectAll(type,id){
    var select = document.getElementById(id).value;
    document.getElementById(id).value= (select=="true")?"false":"true";
    var inputs = document.getElementsByTagName("input");
    for(var i = 0; i < inputs.length; i++) {
        if(inputs[i].type == "checkbox" && inputs[i].name.indexOf(type) == 0) {
            inputs[i].checked = (select=="true")?true:false;
        }
    }
    initialSettingsForIPAM();
}
 function checkFileSettings() {
    if(document.getElementById('alertHisOption').checked) {
        document.getElementById("NUMBEROFLINES").disabled = false;
        document.getElementById("MAINTAIN_NUMBER_OF_FILE").disabled = false;
    } else {
        document.getElementById("NUMBEROFLINES").disabled = true;
        document.getElementById("MAINTAIN_NUMBER_OF_FILE").disabled = true;
    }
}
function checkEnableField() {
    val = document.getElementById('checkClickStatus').checked;
    var mailID = document.getElementById('mailID');
    var normalAlert = document.getElementById('normalAlert');
    var warningAlert = document.getElementById('warningAlert');
    var criticalAlert = document.getElementById('criticalAlert');
    if(val) {
        mailID.disabled = false;
        normalAlert.disabled = false;
        warningAlert.disabled = false;
        criticalAlert.disabled = false;
    } else {
        mailID.disabled = true;
        normalAlert.disabled = true;
        warningAlert.disabled = true;
        criticalAlert.disabled = true;
        normalAlert.checked = false;
        warningAlert.checked = false;
        criticalAlert.checked = false;
    }
}

function checkEscalationEnabled() {
    val = document.getElementById('EnaEscalID').checked;
    if(val) {
       document.getElementById('polExceedWarning').disabled = false; 
       document.getElementById('EscaltoAdd').disabled = false; 
    } else {
        document.getElementById('polExceedWarning').disabled = true; 
        document.getElementById('EscaltoAdd').value = "";
        document.getElementById('EscaltoAdd').disabled = true; 
    }
}

//BandWidthMonitor Alert view   
function compareCriteriaValues(warVal,majVal,criVal) {
    if(parseInt(criVal) >= parseInt(majVal)) {
        if(parseInt(criVal) < parseInt(warVal)) {
            alert(Ember.I18n.t('opu.nwm.CRITICAL_CRITERIA_MUST_BE_GREATER_THAN_WARNING_VAL',this));//No I18N
            return false;
        }
    } else {
        alert(Ember.I18n.t('opu.nwm.CRITICAL_CRITERIA_MUST_BE_GREATER_THAN_MAJOR_VAL',this));//No I18N
        return false;
    }
    if(parseInt(majVal) < parseInt(warVal)) {
        alert(Ember.I18n.t('opu.nwm.MAJOR_CRITERIA_MUST_BE_GREATER_THAN_WARNING_VAL',this));//No I18N
        return false;
    } 
    return true;
}
function validateAlertHistory() {
    var alertCount = trimAll($("#COUNT").val());
    var MAINTAIN_NUMBER_OF_FILE = trimAll($("#MAINTAIN_NUMBER_OF_FILE").val());
    var NUMBEROFLINES = trimAll($("#NUMBEROFLINES").val());
     if(alertCount.length == 0 || !isNumber(alertCount)) {
         alert(Ember.I18n.t('opu.common.ALERT_COUNT_SHOULD_BE_INTEGER',this));//NO I18N
         $("#COUNT").focus();
         return false;         
     }
     if(NUMBEROFLINES < 5000 || NUMBEROFLINES > 50000 || !isNumber(NUMBEROFLINES)) {
        alert(Ember.I18n.t('opu.common.ALERT_FILE_NO_OF_LINE_CANNOT_EXCEED_50000',this));//NO I18N
        $("#NUMBEROFLINES").focus();
        return false;
     }
     if(MAINTAIN_NUMBER_OF_FILE > 50 || !isNumber(MAINTAIN_NUMBER_OF_FILE)) {
        alert(Ember.I18n.t('opu.common.ALERT_NO_OF_FILE_CANNOT_EXCEED_50',this));//NO I18N
        $("#MAINTAIN_NUMBER_OF_FILE").focus();
        return false;
     }
    return true;
}

function validateAlertConfigBWMonitor(view) {
//    var action = document.alertConfigForm.actionFrom.value
//    document.alertConfigForm.actionFrom.value=action;
    if(view === "alertConfigValue") {
            var warVal = trimAll($("#warningThreshold").val());
            if(!validateNumber($("#warningThreshold") , warVal , "warning" )) {
                return false;
            }
            var majVal = trimAll($("#majorThreshold").val());
            if(!validateNumber($("#majorThreshold") , majVal , "Major" )) {
                return false;
            }
            var criVal = trimAll($("#criticalThreshold").val());
            if(!validateNumber($("#criticalThreshold") , criVal , "Critical")) {
                return false;
            }
            if(!compareCriteriaValues(warVal , majVal , criVal )) {
                return false;
            }
            if($("#checkClickStatus").prop("checked") === true) {
                var address = trimAll($("#mailID").val());
                if(address.length == 0) {
                    alert(Ember.I18n.t('opu.mail.PLEASE_ENTER_YOUR_EMAIL_ADDRESS',this));//No I18N
                    $("#mailID").focus();
                    return false;
                }
                if(!validateEmailAddress(address)) {
                    alert(Ember.I18n.t('opu.mail.PLEASE_ENTER_YOUR_EMAIL_ADDRESS',this));//No I18N
                    $("#mailID").focus();
                    return false;
                }
            }
            if($("#alertHostName").val() === "Global") {
                if(!confirm(Ember.I18n.t('opu.nwm.OVERWRITE_ALL_DEVICE_LEVEL_CONFIGURATION',this))) {//No I18N
                    return false;
                }
            }
       }
       return true;
}
function validateNumber(textField,warVal,message) {
        if(warVal.length == 0) {
            alert(getI18NwithParams('opu.nwm.THRESHOLD_CRITERIA_MUST_BE_EQUAL_OR_LESS_THAN_100',[message]));// No I18N
            textField.focus();
            return false;
        }
        if(warVal < 0) {
            alert(getI18NwithParams('opu.nwm.THRESHOLD_CRITERIA_MUST_BE_EQUAL_OR_LESS_THAN_100',[message]));// No I18N
            textField.focus();
            return false;
        }
        if(!isNumber(warVal)) {
            alert(getI18NwithParams('opu.nwm.THRESHOLD_CRITERIA_MUST_BE_EQUAL_OR_LESS_THAN_100',[message]));// No I18N
            textField.focus();
            return false;
        }

        if(warVal.indexOf(".") !== -1) {
            alert(getI18NwithParams('opu.nwm.THRESHOLD_CRITERIA_MUST_BE_EQUAL_OR_LESS_THAN_100',[message]));// No I18N
            textField.focus();
            return false;
        }
        if(parseInt(warVal) > 100) {
            alert(getI18NwithParams('opu.nwm.THRESHOLD_CRITERIA_MUST_BE_EQUAL_OR_LESS_THAN_100',[message]));// No I18N
            textField.focus();
            return false;
        }
        return true;
}
function validateNWMAlertConfigInputs() {
            
    var missedPoll = trimAll($("#specifyPoll").val());
    if(missedPoll.length == 0 || missedPoll.length < 0) {
        alert(Ember.I18n.t('opu.common.EnterAnInt',this));//NO I18N
        $("#specifyPoll").focus();
        return false
    }
    var warVal = trimAll($("#warningRTThreshold").val());
    if(warVal.length === 0 || !isNumber(warVal) || warVal < 0 || warVal.indexOf(".") != -1) {
        alert(Ember.I18n.t('opu.nwm.RESPONSE_TIME_FOR_THIS_CRITERIA_MUST_BE_INTEGER',this));//NO I18N
        $("#warningRTThreshold").focus();
        return false;
    }

    if($("#checkClickStatus").prop("checked")) {
        var normalAlert = $("#normalAlert").prop("checked");
        var warningAlert = $("#warningAlert").prop("checked");
        var criticalAlert = $("#criticalAlert").prop("checked");
        if(!normalAlert && !warningAlert && !criticalAlert) {
            alert(Ember.I18n.t('opu.nwm.PLEASE_CHECK_ANY_ONE_ALERT_CRITERIA',this));//NO I18N
            return false;
        }
        var toaddr = trimAll($("#mailID").val());
        if(toaddr.length === 0 || !validateEmailAddress(toaddr)){
            alert(Ember.I18n.t('opu.mail.PLEASE_ENTER_YOUR_EMAIL_ADDRESS',this));//No I18N
            $("#mailID").focus();
            return false;
        }
    }

    var esEnabled = $("#EnaEscalID").prop("checked");

    if(esEnabled) {
        var polExceedWarning = trimAll($("#polExceedWarning").val());
        if(polExceedWarning.length == 0 || polExceedWarning.length < 0 || !isNumber(polExceedWarning)) {
            alert(Ember.I18n.t('opu.common.EnterAnInt',this));//NO I18N
            $("#polExceedWarning").focus();
            return false;
        }
        var esAddress = trimAll($('#EscaltoAdd').val());
        if(esAddress.length === 0 || !validateEmailAddress(esAddress)){
            alert(Ember.I18n.t('opu.mail.PLEASE_ENTER_YOUR_EMAIL_ADDRESS',this));//No I18N
            $("#EscaltoAdd").focus();
            return false;
        }
    }

    if($("#alertHostName").val() == "Global") {
        if(!confirm(Ember.I18n.t('opu.nwm.OVERWRITE_ALL_DEVICE_LEVEL_CONFIGURATION',this))) {
            return false;
        }
    }
    return true;
}
function validateNewSchedulerGroupConfig(tool)
{
    var groupName = trimAll($("#GROUP_NAME").val());
    if(groupName === undefined || groupName.length === 0)
    {
        alert(Ember.I18n.t("opu.common.SpecifyNameForGroup",this));//No I18N
        $("#GROUP_NAME").focus();
        return false;
    }
    if(invalidCharsExist(groupName))
    {
        alert(getI18NwithParams("opu.common.ENTER_VALUE_WITHOUT_SPL_CHARS",[groupName]));//NO I18N
        $("#GROUP_NAME").focus();
        return false;
    }
    var selectedItemsLen = $('#selectedReport option').length;
    if(selectedItemsLen === 0){
        if(tool === "IPAM"){
            if(!confirm(Ember.I18n.t('opu.ipam.CONFIRMATION_NO_SUBNETS_HAS_BEEN_SELECTED',this))) {
                return false;
            }
        }else{
            if(!confirm(Ember.I18n.t('opu.spm.CREATE_GROUP_WITHOUT_SWITCHES_IN_THE_GROUP',this))) {
                return false;
            }
        }
    }
    
    return true;
}
function changeNewValue(obj){
    $("#"+obj.id).val(obj.value);
}

function validateSpmGeneralSettings()
{
       var stackedPortCount =trimAll($("#stackedPortCount").val());
       if(stackedPortCount.length == 0)
       {
            alert(Ember.I18n.t('opu.spm.PLEASE_ENTER_NO_OF_STACK_PORT_CLASSIFICATION_COUNT',this));//NO I18N
            $("#stackedPortCount").focus();
            return false;
       }else if(!isNumber(stackedPortCount))
       {
            alert(Ember.I18n.t('opu.common.EnterAnInt'));//NO I18N
            $("#stackedPortCount").focus();
            return false;
       }else if(parseInt(stackedPortCount) == 0 || parseInt(stackedPortCount) < 1 )
       {
            alert(Ember.I18n.t('opu.spm.NO_OF_STACK_PORT_CLASSIFICAATION_SHOULD_BE_GREATER_THEN_ZERO',this));//NO I18N
            $("#stackedPortCount").focus();
            return false;
       }else if(parseInt(stackedPortCount) > 25){
            alert(Ember.I18n.t('opu.spm.MAXIMUM_STRUNK_PORT_COUNT',this));//NO I18N
            $("#stackedPortCount").focus();
            return false;
       }

       var noOfthread =trimAll($("#noOfThread").val());
       if(noOfthread.length == 0 || noOfthread < 3 || noOfthread > 25 || !isNumber(noOfthread))
       {
            alert(Ember.I18n.t('opu.spm.NO_OF_THREAD_COUNT_BETWEEN'));//NO I18N
            $("#noOfThread").focus();
            return false;
       }
       
       var auditDir = trimAll($("#auditDir").val());
	if(auditDir === "" || auditDir === undefined)
	{
            alert(Ember.I18n.t("opu.common.SPECIFY_PUBLISH_DIRECTORY",this));//NO I18N
            $("#auditDir").focus();
            return false;
	}
       var portHistoryDir = trimAll($("#portDir").val());
	if(portHistoryDir === "" || portHistoryDir === undefined)
	{
            alert(Ember.I18n.t("opu.common.SPECIFY_PUBLISH_DIRECTORY",this));//NO I18N
            $("#portDir").focus();
            return false;
	}
        return true;
}


//removed this from inventoryModel and added here.
$(document).ready(function()
{
    $("body").on('click', function(evt) 
    {
//        if(evt.target.id === "inputString")
//        {
//                $("#inputString").css('color','');
//                $("#inputString").val("");
//        }
//        else
//        {
//                $("#inputString").css('color','#878787');
//                $("#inputString").val(Ember.I18n.t('webclient.devices.globalsearch.apiclient',this));
//        }
    $("#logoutDrpDwnDiv").mouseleave(function() {
        $("#logoutDrpDwnDiv").hide();		
    });
    
    if(evt.target.id !== "ActionIcon"){
         $("#dropDownDiv").hide();	
    }
 
    $("#dropDownDiv").mouseleave(function() {
        $("#dropDownDiv").hide();		
    });
    
    });
});
function CloseExecutingDIV(divObj){
   if(divObj !== undefined){
        var id = divObj.id;
        if(id === "widgetOverlay"){
            $("#widgetOverlay").hide();
            $("#loadingDiv").hide();
        }
   }
}
function getIPAddressFrmLong(ipLongVal){
    // Taken this code from http://javascript.about.com/library/blipconvert.htm
    var ipAddr = "";//No I18N
   if(ipLongVal !== undefined){
        ipAddr = ipLongVal%256;
        for (var i = 3; i > 0; i--) { 
            ipLongVal = Math.floor(ipLongVal/256);
            ipAddr = ipLongVal%256 + '.' + ipAddr;//No I18N
        }
   }
   return ipAddr;
}
function convertLongToIPAddress(cellValue, options, rowdata, action)
{
    return getIPAddressFrmLong(cellValue);
}
function checkDisable(id , sizeid, isTypeChange)
    {
	    document.getElementById("CFSizeTR").style.display = '';
	    document.getElementById("CFDefValTR").style.display = '';
	        
        if(trimAll(document.getElementById(id).value).match("INTEGER") == "INTEGER" )
        {
            document.getElementById(sizeid).value = 4;
            document.getElementById(sizeid).readOnly = true;
        }
        else if(trimAll(document.getElementById(id).value).match("STRING") == "STRING" )
        {
            document.getElementById(sizeid).value = 50;
            document.getElementById(sizeid).readOnly = false;
        }
        else if(trimAll(document.getElementById(id).value).match("BOOLEAN") == "BOOLEAN" )
        {
            var elementTemp = "<select class=formSelectSmall size=1 name=defaultValue id=defaultValue  >";//NO I18N
            elementTemp += "<option value=true> "+Ember.I18n.t("opu.common.TRUE",this)+" </option>";//NO I18N
            elementTemp += "<option value=false> "+Ember.I18n.t("opu.common.FALSE",this)+" </option>";//NO I18N
            elementTemp +="</select>";//NO I18N
            document.getElementById("defaultTDID").innerHTML = elementTemp;//NO I18N
            document.getElementById(sizeid).value = "1";
            document.getElementById(sizeid).readOnly = true;
            return;
            
        }        
        else if(trimAll(document.getElementById(id).value).match("FILE") == "FILE" )
        {
	        document.getElementById("CFSizeTR").style.display = 'none';
	        document.getElementById("CFDefValTR").style.display = 'none';
                return;
        }
        
        document.getElementById("defaultTDID").innerHTML = "<input name=defaultValue id=defaultValue type=text class=formInput size=25  >";//NO I18N
        /*else
        {
            var valueTemp = (document.getElementById(id).value).split(",");
            var tdValue = "<img src=/images/plus_icon.png  align=abcmiddle>&nbsp;<a  href=javascript:addDatatype(); class=linktxt>"+I18nUtil.getMsg("opu.common.CUSTOM_DATA_TYPE")+"</a><br> &nbsp;<img src=/images/edit_tool.png align=abcmiddle> <a  href=javascript:modifyDatatype() class=linktxt>"+I18nUtil.getMsg("opu.common.EDIT")+"&nbsp'"+valueTemp[0]+"'</a>&nbsp; "; //No I18n
            if(document.getElementById("editTD"))
            {
            	document.getElementById("editTD").innerHTML = tdValue;
        	}
        	getDataTypeDetails(isTypeChange);
            return;
        }
        var tdValue1 = "<img src=/images/plus_icon.png>&nbsp;<a  href=javascript:addDatatype(); class=linktxt>"+I18nUtil.getMsg("opu.common.CUSTOM_DATA_TYPE")+"</a> &nbsp;";
		if(document.getElementById("editTD"))
        {
	      	document.getElementById("editTD").innerHTML = tdValue1;
        }

         
         */
    }
function executeActionURLinPost(url,dataParams){
    $.ajax({
            url: url, //No I18N
            type: 'POST', //No I18N
            data: dataParams,//No I18N
            dataType:'json', //No I18N
            success: function(response){
                if (response.status === "Failure")
                {
                    opu_showFailureResponseTextOnDiv(response.message);
                }else if (response.status === "Success")//NO I18N
                {
                    window.location.reload();
                }
            }
    });
    
}
