
/* Bandwidth Monitor Models */

OpUtilsClient.BWMonitor = Ember.Object.extend({});
var devicesSummayList = OpUtilsClient.BWMonitor.create();
var bwmAlertsCount = OpUtilsClient.IPAM.create();
OpUtilsClient.BWMonitor.reopenClass({
    getInterfacesCount: function()
    {
        $.ajax({		
             url: getOpUtilsBWMAPIURL() + "&operation=GET_BWM_INTERFACE_COUNT",//NO I18N
             type: 'GET', //No I18N		
             dataType:'json', //No I18N
             async: false,//No I18N
             success: function(bwmInterfaceCounts)		
             {
                OpUtilsClient.BWMController.bwmInterfacesCount = bwmInterfaceCounts.result.interfacecount;
                OpUtilsClient.BWMController.bwmTotalAlertsCount = bwmInterfaceCounts.result.alertcount;
             }
         })
    },listBWMonitorSummary: function(){
        var colNamesList = [Ember.I18n.t('opu.views.DNS_NAME',this), Ember.I18n.t('opu.views.IFINDEX',this), Ember.I18n.t('opu.views.IFNAME',this),Ember.I18n.t('opu.views.STATUS',this), Ember.I18n.t('opu.views.SPEED',this), Ember.I18n.t('opu.views.VOLUME_IN',this), Ember.I18n.t('opu.views.VOLUME_OUT',this), Ember.I18n.t('opu.views.SPEED_IN',this), Ember.I18n.t('opu.views.SPEED_OUT',this) ,Ember.I18n.t('opu.views.UTILIZ_PER_IN',this),Ember.I18n.t('opu.views.UTILIZ_PER_OUT',this), Ember.I18n.t('opu.views.UNICAST_IN',this),Ember.I18n.t('opu.views.UNICAST_OUT',this), Ember.I18n.t('opu.views.NON_UNICAST_IN',this) ,Ember.I18n.t('opu.views.NON_UNICAST_OUT',this),Ember.I18n.t('opu.views.LAST_POLL_TIME',this)]; //No I18N
        var colModelList = [
            {name: 'host-name', index: 'host-name', classes: "pointer", sortable: true, sorttype: 'text'}, //No I18N
            {name: 'if-index', index: 'if-index',width:width100, sortable: true, sorttype: 'int'}, //No I18N
            {name: 'if-name', index: 'if-name', sortable: true, sorttype: 'text'}, //No I18N
            {name: 'if-status-int', index: 'if-status-int',width:width70,formatter:deviceStatusIcon, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'if-speed', index: 'if-speed',width:width100, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'in-volume', index: 'in-volume',width:width100, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'out-volume', index: 'out-volume',width:width100, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'in-relative', index: 'in-relative',width:width100, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'out-relative', index: 'out-relative',width:width100, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'in-util', index: 'in-util',width:width100, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'out-util', index: 'out-util',width:width100, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'in-unicast', index: 'in-unicast', sortable: true, sorttype: 'text'}, //No I18N
            {name: 'out-unicast', index: 'out-unicast', sortable: true, sorttype: 'text'}, //No I18N
            {name: 'in-broadcast', index: 'in-broadcast', sortable: true, sorttype: 'text'}, //No I18N
            {name: 'out-broadcast', index: 'out-broadcast', sortable: true, sorttype: 'text'}, //No I18N
            {name: 'last-scan-time', index: 'last-scan-time', sortable: true, sorttype: 'text'}, //No I18N
        ];
        var allIpsAPIUrl = getOpUtilsBWMAPIURL() + "&operation=GET_BWM_INTERFACES";//NO I18N
        var defaultOptions = {"sortName": "host-name", "sortOrder": "asc"};//No I18N
        $.getJSON(allIpsAPIUrl, function(resp) {
            loadJQgridWithData("#BWMSummaryList", resp.result, colNamesList, colModelList, "", "#DevicePager", "BWMSummaryList", defaultOptions); //No I18N
            $("#BWMSummaryList").setGridWidth(colModelList.length*130,true);
            var differentLen =(colModelList.length*120) - ($("#col3").width())
            if(differentLen > 20){
                $("#gview_BWMSummaryList").css({width:$("#col3").width(),"overflow-x":"auto", "border-right": "1px solid #F7F9F9"}); //No I18N
            }
            $("#DevicePager").css({width:$("#col3").width()}); //No I18N
        });
        
        return devicesSummayList;
    },listBWMonitorAlerts: function(){
//        $.ajax({		
//                url: getOpUtilsBWMAPIURL() + "&operation=GET_BWM_ALERT_COUNT",//NO I18N
//                type: 'GET', //No I18N		
//                dataType:'json', //No I18N
//                async: false,//No I18N
//                success: function(bwmAlertsCounts)		
//                {
////                   var menuLinkArray = ipamTreeGroups.INTOTAL;
//                   console.log("ffffff ffffff "+bwmAlertsCounts);
//                   console.log("ffffff ffffff "+bwmAlertsCounts.INTOTAL);
//                   var jsonObj = {
//                            "alertscount": bwmAlertsCounts.INTOTAL, //No I18N
//                        }
////                   bwmAlertsCount.setProperties(jsonObj);
////                   OpUtilsClient.BWMController.set("bwmAlertsCount", jsonObj); //No I18N
////                   console.log("sssssss dddddd "+OpUtilsClient.BWMController.bwmAlertsCount.alertscount);
//                }
//            })
     
        
        var colNamesList = [Ember.I18n.t('opu.views.DNS_NAME',this), Ember.I18n.t('opu.views.IFNAME',this),Ember.I18n.t('opu.views.TRAFFIC_TYPE',this), Ember.I18n.t('opu.views.SEVERITY',this), Ember.I18n.t('opu.views.ALERT_GENERATED_TIME',this)]; //No I18N
        var colModelList = [
            {name: 'host-name', index: 'host-name', classes: "pointer", sortable: true, sorttype: 'text'}, //No I18N
            {name: 'if-name', index: 'if-name', sortable: true, sorttype: 'text'}, //No I18N
            {name: 'traffic-type', index: 'traffic-type', sortable: true, sorttype: 'text'}, //No I18N
            {name: 'alert-type-int', index: 'alert-type-int',width:width100,formatter:SeverityStatusIcon, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'alert-generated-time', index: 'alert-generated-time', sortable: true, sorttype: 'date'}, //No I18N
        ];
        var allIpsAPIUrl = getOpUtilsBWMAPIURL() + "&operation=GET_BWM_ALERTS";//NO I18N
        var defaultOptions = {"sortName": "host-name", "sortOrder": "asc"};//No I18N
        $.getJSON(allIpsAPIUrl, function(resp) {
            loadJQgridWithData("#BWMAlertsList", resp.result, colNamesList, colModelList, "", "#DevicePager", "BWMAlertsList", defaultOptions); //No I18N
            
        });
        
        return devicesSummayList;
    }
});




