
/* IPAM Models */

OpUtilsClient.IPAM = Ember.Object.extend({});
var ipamNetworkTabs = OpUtilsClient.IPAM.create();
var deviceList = OpUtilsClient.IPAM.create();
var allInventory = OpUtilsClient.IPAM.create();
var deviceBasicDetails = OpUtilsClient.IPAM.create();
var ipamTreeGroupsEmber = OpUtilsClient.IPAM.create();
//var ipamTreeGroups = OpUtilsClient.IPAM.create();
var ipamGroupCaption = OpUtilsClient.IPAM.create();
var ipamSnapshotPage = OpUtilsClient.IPAM.create();
var ipAddressDetails = OpUtilsClient.IPAM.create();
var ipamDashboard = OpUtilsClient.IPAM.create();

var cidrNotation = {'notation':{'255.255.255.0':'24','255.255.255.128':'25','255.255.255.192' : '26','255.255.255.224' : '27','255.255.255.240' : '28','255.255.255.248' : '29','255.255.255.252': '30','255.255.255.254' : '31','255.255.0.0' : '16','255.255.128.0' : '17','255.255.192.0' : '18','255.255.224.0' : '19','255.255.240.0' :'20','255.255.248.0' : '21','255.255.252.0' : '22','255.255.254.0' : '23','255.0.0.0' : '8','255.128.0.0' : '9','255.192.0.0' : '10','255.224.0.0' : '11','255.240.0.0' : '12','255.248.0.0' : '13','255.252.0.0' : '14','255.254.0.0' : '15'}}; //No I18N
var notSupportWidgetList = ["Real Time Bandwidth Utilization","Real Time CPU Utilization","Real Time Memory Utilization","Real Time Graph for a Monitor","Real Time Traffic","Backup Details Snapshot","Configuration Conflict Summary","End-of-life Status Report","Last 5 Devices with Configuration Changes","Policy Compliance Snapshot","Compliance Policy Violations","Floor Details","Rack Asset Details","Rack Capacity","Rack Details","Data Collection Details","Data Collection Success Percentage","Top N Failure Percentage"]; //No I18n

var dashDisplayNames = {"top10": Ember.I18n.t('opu.common.TOP10',this),  //No I18N
		};

OpUtilsClient.IPAM.reopenClass({
    listIPAMTab: function()
    {
//         List all folders ( tree ) ..
        $.ajax({		
                url: getOpUtilsAPIURL() + "&operation=GET_IPAM_GROUPS",//NO I18N
                type: 'GET', //No I18N		
                dataType:'json', //No I18N
                async: false,//No I18N
                success: function(ipamTreeGroups)		
                {
                   var menuLinkArray = ipamTreeGroups.result.ipv4Nodes;
                   var totalSubnetCount = menuLinkArray[0]["subnet-count"];//Total Subneta count
                    var allSubnetGPCaption = "All Subnets("+totalSubnetCount+")";//NO I18N
                    var allIPsCount = menuLinkArray[1].totalIPs;
                    var allIPsGPCaption = "All IPs("+allIPsCount+")";//NO I18N
                    var ipamTreeGroupJsonObj = {"groups":{'AllSubnets':allSubnetGPCaption,'AllIPs':allIPsGPCaption}};//No I18N
                    menuLinkArray.splice(0,2);//removed "Total Subnets" and "AllIPs" group from Array..
        
                    for(i=0; i<menuLinkArray.length; i++)
                    {
                        menuLinkArray[i].url=window.apiclientUrl+ "IPAM/Group/"+menuLinkArray[i]["group-id"]+"/SubnetList";//No I18N
                        ipamTreeGroupJsonObj.groups[menuLinkArray[i]["group-id"]] = menuLinkArray[i]["group-name"]+"("+menuLinkArray[i]["subnet-count"]+")";//No I18N
                    }
                    var jsonObj = {
                            "menuLinks": menuLinkArray, //No I18N
                            "TotalSubnet": totalSubnetCount, //No I18N
                            "AllIPs": allIPsCount, //No I18N
                            "AlarmsCount": ipamTreeGroups.result.AlertsCount[0].count //No I18N
                        }
                    ipamGroupCaption.setProperties(ipamTreeGroupJsonObj);
                    ipamTreeGroupsEmber.setProperties(jsonObj);
                    OpUtilsClient.IPAMSubnetController.set("ipamGroupCapationObjects", ipamGroupCaption); //No I18N
                    OpUtilsClient.IPAMSubnetController.set("ipamTreeGroups", ipamTreeGroupsEmber); //No I18N
                }
            })
        return ipamNetworkTabs;
    },
    IPV4ListAllIps: function() {
        var colNamesList = [Ember.I18n.t('opu.views.IP_ADDRESS',this), Ember.I18n.t('opu.views.MAC_ADDRESS',this), Ember.I18n.t('opu.views.IP_TO_DNS',this),Ember.I18n.t('opu.views.DNS_TO_IP',this), Ember.I18n.t('opu.views.DNS_STATUS',this), Ember.I18n.t('opu.views.STATUS',this), Ember.I18n.t('opu.views.DEVICE_TYPE',this), Ember.I18n.t('opu.views.CONNECTED_SWITCH',this)]; //No I18N
        var colModelList = [{name: 'ipaddress-in-long', index: 'ipaddress-in-long',search: false, formatter: actionForIPAddress, classes: "pointer",width:ipaddress_width,sortable: true,sorttype:'int'}, //No I18N
            {name: 'mac-address', index: 'mac-address',width:width100,sortable: true,sorttype:'text'}, //No I18N
            {name: 'ip-to-dns', index: 'ip-to-dns',sortable: true,sorttype:'text'}, //No I18N
            {name: 'dns-to-ip', index: 'dns-to-ip', width: ipaddress_width,sortable: true,sorttype:'text'}, //No I18N
            {name: 'dns-status', index: 'dns-status', width: status_width,sortable: true,sorttype:'text'}, //No I18N
            {name: 'status', index: 'status', width: status_width,sortable: true,sorttype:'text'}, //No I18N
            {name: 'device-type', index: 'device-type',sortable: true,sorttype:'text'}, //No I18N
            {name: 'connected-switch', index: 'connected-switch',sortable: true,sorttype:'text'}, //No I18N
        ];
        var allIpsAPIUrl = getOpUtilsAPIURL() + "&operation=GET_ALL_IP_ADDRESSES&startIndex=0&numOfObjects=500";//NO I18N
        var defaultOptions = {"sortName": "ip-address", "sortOrder": "asc","minRowsPerPage":"500","searchOption":true};//No I18N
        $.getJSON(allIpsAPIUrl, function(resp) { //No I18N
            loadJQgridWithData("#ipamSummaryList", resp.result, colNamesList, colModelList, "", "#DevicePager", "ipamSummaryList", defaultOptions); //No I18N
        });
        OpUtilsClient.IPAMController.appendIPAddrInAllIPs = true;
        setTimeout(function () {appendRowsInIPAMIPList(500)},2000);
        return allInventory;
    },
    IPV4SubnetList: function(groupid) {
        var colNamesList1 = [Ember.I18n.t('opu.views.SUBNET_ADDRESS',this), Ember.I18n.t('opu.views.NAME',this), Ember.I18n.t('opu.views.SIZE',this), Ember.I18n.t('opu.common.USAGE',this),Ember.I18n.t('opu.views.STATUS',this), Ember.I18n.t('opu.views.USED',this), Ember.I18n.t('opu.views.AVAILABLE',this), Ember.I18n.t('opu.views.TRANSIENT',this),  Ember.I18n.t('opu.views.LAST_SCAN_TIME',this),Ember.I18n.t('opu.views.ACTIONS',this),'subnetid']; //No I18N
        var colModelList1 = [
            {name: 'ipaddress-in-long', index: 'ipaddress-in-long', formatter: actionForSubnet1, classes: "pointer",sortable: true,sorttype:'text',search:false, width: width100}, //No I18N
            {name: 'subnet-name', index: 'subnet-name', width: width120,sortable: true,sorttype:'text'}, //No I18N
            {name: 'subnet-size', index: 'subnet-size',width: width50,sortable: true,sorttype:'int'}, //No I18N
            {name: 'usedPercentage', index: 'usedPercentage', formatter: subnetUsageImg,sortable: true,sorttype:'int', width: width120}, //No I18N
            {name: 'scan-status', index: 'scan-status',width: width50,sortable: true,sorttype:'text'}, //No I18N
            {name: 'usedCount', index: 'usedCount', width: width80, sortable: true, sorttype: 'int',hidden: false}, //No I18N
            {name: 'availableCount', index: 'availableCount', width: width80, sortable: true, sorttype: 'int', hidden: false}, //No I18N
            {name: 'transientCount', index: 'transientCount', width: width80, sortable: true, sorttype: 'int', hidden: false}, //No I18N
            {name: 'last-scan-time', index: 'last-scan-time',sortable: true, sorttype: 'date', width: width120}, //No I18N
            {name: 'Action', index: 'Action',hidden:false,formatter:ipamSubnetEditAndDelete, width: width50,hidden:!(OpUtilsClient.ApplicationController.isAdminRole)}, //No I18N
            {name: 'subnetid', index: 'subnetid',hidden:true}, //No I18N

        ];
        var summaryAPIUrl = getOpUtilsAPIURL() + "&operation=GET_ALL_SUBNETS_SUMMARY";//NO I18N
        if(groupid != null){
            OpUtilsClient.IPAMController.selectedIPAMGroupID=groupid
            summaryAPIUrl = summaryAPIUrl+"&groupId="+groupid;//NO I18N
        }

        var defaultOptions = {"sortName": "subnet-address", "sortOrder": "asc","multiselect": true,"searchOption":true};//No I18N
        $.getJSON(summaryAPIUrl, function(resp) { //No I18N
            loadJQgridWithData("#ipamSummaryList", resp.result, colNamesList1, colModelList1, "", "#DevicePager", "ipamSummaryList", defaultOptions); //No I18N
//            $("#ipamSummaryList").setGridWidth(colModelList1.length*120,true);
//            var differentLen =(colModelList1.length*120) - ($("#col3").width())
//            if(differentLen > 20){
//                $("#gview_ipamSummaryList").css({width:$("#col3").width(),"overflow-x":"auto", "border-right": "1px solid #F7F9F9"}); //No I18N
//            }
//            $("#DevicePager").css({width:$("#col3").width()}); //No I18N
        });
        return allInventory;
    },
    IPV4SubnetSummary: function(subnetAddr)
    {
        var menuLinkArray = getSubnetAddressTabLinks("Summary",subnetAddr);//No I18N
        var jsonObj = {			
            "menuLinks": menuLinkArray //No I18N
        }

        $.ajax({		
                url: getOpUtilsAPIURL() + "&operation=GET_SUBNET_SUMMARY&subnetAddress="+subnetAddr,//NO I18N
                type: 'GET', //No I18N		
                dataType:'json', //No I18N
                async: false,//No I18N
                success: function(subnetsummary)		
                {
                    OpUtilsClient.IPAMSubnetController.set("subnetSummaryObj", OpUtilsClient.IPAM.create().setProperties(subnetsummary)); //No I18N
                }
            })
        deviceBasicDetails.setProperties(jsonObj);
        OpUtilsClient.IPAMSubnetController.set("ipamSubnetMenuLinks", deviceBasicDetails); //No I18N
        
        return deviceList;
    },IPAMAllAlerts: function()
    {
        var alertURL = getOpUtilsAPIURL()+"&operation=GET_ALL_IPAM_ALERTS";//No I18N
  
        var colNamesList = [Ember.I18n.t('opu.views.IP_ADDRESS',this), Ember.I18n.t('opu.views.ALERT_GENERATED_TIME',this), Ember.I18n.t('opu.views.ALERT_TYPE',this),Ember.I18n.t('opu.views.DNS_NAME',this), Ember.I18n.t('opu.views.REMARKS',this),"alertid"]; //No I18N
        var colModelList = [{name: 'ipaddress-in-long', index: 'ipaddress-in-long', width: ipaddress_width,sortable: true,sorttype:'long',formatter: convertLongToIPAddress,search:false}, //No I18N
            {name: 'generated-time', index: 'generated-time', width: ipaddress_width, sortable: true,sorttype:'date'}, //No I18N
            {name: 'alert-type', index: 'alert-type', width: ipaddress_width,sortable: true,sorttype:'text'}, //No I18N
            {name: 'ip-to-dns', index: 'ip-to-dns', sortable: true,sorttype:'text'}, //No I18N
            {name: 'remark', index: 'remark',sortable: true,sorttype:'text'}, //No I18N
            {name: 'alertid', index: 'alertid',hidden:true} //No I18N
        ];
        var defaultOptions = {"sortName": "ipaddress-in-long", "sortOrder": "asc","multiselect": true,"searchOption":true};//No I18N
        $.getJSON(alertURL, function(resp) { //No I18N
            loadJQgridWithData("#IPAMAllAlerts", resp.result, colNamesList, colModelList, "", "#DevicePager", "IPAMAllAlerts", defaultOptions); //No I18N
        });
        
        return switchalertview;
    },
    IPV4IPAddressOfSubnet: function(subnetAddr)
    {

        var colNamesList1 = [Ember.I18n.t('opu.views.IP_ADDRESS',this), Ember.I18n.t('opu.views.MAC_ADDRESS',this), Ember.I18n.t('opu.views.IP_TO_DNS',this),Ember.I18n.t('opu.views.DNS_TO_IP',this), Ember.I18n.t('opu.views.DNS_STATUS',this), Ember.I18n.t('opu.views.STATUS',this), Ember.I18n.t('opu.views.DEVICE_TYPE',this), Ember.I18n.t('opu.views.CONNECTED_SWITCH',this)]; //No I18N
        var colModelList1 = [{name: 'ipaddress-in-long', index: 'ipaddress-in-long', formatter: actionForIPAddress, classes: "pointer",width:ipaddress_width,sortable: true,sorttype:'text'}, //No I18N
            {name: 'mac-address', index: 'mac-address',width:width100,sortable: true,sorttype:'text'}, //No I18N
            {name: 'ip-to-dns', index: 'ip-to-dns',sortable: true,sorttype:'text'}, //No I18N
            {name: 'dns-to-ip', index: 'dns-to-ip', width: ipaddress_width,sortable: true,sorttype:'text'}, //No I18N
            {name: 'dns-status', index: 'dns-status', width: status_width,sortable: true,sorttype:'text'}, //No I18N
            {name: 'status', index: 'status', width: status_width,sortable: true,sorttype:'text'}, //No I18N
            {name: 'device-type', index: 'device-type'}, //No I18N
            {name: 'connected-switch', index: 'connected-switch',sortable: true,sorttype:'text'}, //No I18N
        ];
        
        var menuLinkArray = getSubnetAddressTabLinks("IPs",subnetAddr);//No I18N
        var jsonObj = {			
            "menuLinks": menuLinkArray //No I18N
        }

        deviceBasicDetails.setProperties(jsonObj);
        OpUtilsClient.IPAMSubnetController.set("ipamSubnetMenuLinks", deviceBasicDetails); //No I18N
        var defaultOptions = {"sortName": "ipaddress-in-long", "sortOrder": "asc","searchOption":true};//No I18N
        var subnetIPaddrUrl = getOpUtilsAPIURL() + "&operation=GET_SUBNET_DETAIL&subnetAddress=" + OpUtilsClient.IPAMController.selectedSubnet;//No I18N
        $.getJSON(subnetIPaddrUrl, function(resp) { //No I18N
            loadJQgridWithData("#DevicesList", resp.result, colNamesList1, colModelList1, "", "#DevicePager", "deviceList",defaultOptions); //No I18N
        });
        return deviceList;
    },
    IPV4HistoryOfSubnet: function(subnetAddr)
    {
        var colNamesList1 = [Ember.I18n.t('opu.views.IP_ADDRESS',this), Ember.I18n.t('opu.views.DETECTED_TIME',this), Ember.I18n.t('opu.views.DNS_NAME',this), Ember.I18n.t('opu.views.MAC_ADDRESS',this), Ember.I18n.t('opu.views.SYS_DESCR',this)]; //No I18N
        var colModelList1 = [{name: 'ipaddress-in-long', index: 'ipaddress-in-long', width: ipaddress_width,sortable: true,sorttype:'long',formatter:convertLongToIPAddress}, //No I18N
            {name: 'generated-time', index: 'generated-time', width: status_width, sortable: true,sorttype:'text'}, //No I18N
            {name: 'dns-name', index: 'dns-name', width: ipaddress_width, sortable: true,sorttype:'text'}, //No I18N
            {name: 'mac-address', index: 'mac-address',width:width100, sortable: true,sorttype:'text'}, //No I18N
            {name: 'system-description', index: 'system-description', width: deviceCate_width,sortable: true,sorttype:'text'}//No I18N
        ];

        var menuLinkArray = getSubnetAddressTabLinks("History",subnetAddr);//No I18N
        var jsonObj = {			
            "menuLinks": menuLinkArray //No I18N
        }

        deviceBasicDetails.setProperties(jsonObj);
        OpUtilsClient.IPAMSubnetController.set("ipamSubnetMenuLinks", deviceBasicDetails); //No I18N
        
        var subnetIPaddrUrl = getOpUtilsAPIURL() + "&operation=GET_IPAM_HISTORY&subnetAddress=" + OpUtilsClient.IPAMController.selectedSubnet;//No I18N
        $.getJSON(subnetIPaddrUrl, function(resp) { //No I18N
            loadJQgridWithData("#DevicesList", resp.result, colNamesList1, colModelList1, "", "#DevicePager", "deviceList"); //No I18N
        });
        return deviceList;
    },
    IPV4AlertsOfSubnet: function(subnetAddr)
    {
        var colNamesList1 = [Ember.I18n.t('opu.views.IP_ADDRESS',this), Ember.I18n.t('opu.views.ALERT_GENERATED_TIME',this), Ember.I18n.t('opu.views.ALERT_TYPE',this), Ember.I18n.t('opu.views.REMARKS',this)]; //No I18N
        var colModelList1 = [{name: 'ipaddress-in-long', index: 'ipaddress-in-long', width: ipaddress_width,sortable: true,sorttype:'long',formatter: convertLongToIPAddress}, //No I18N
            {name: 'generated-time', index: 'generated-time', width: status_width, classes: "pointer",sortable: true,sorttype:'date'}, //No I18N
            {name: 'alert-type', index: 'alert-type', width: ipaddress_width, classes: "pointer",sortable: true,sorttype:'text'}, //No I18N
            {name: 'remark', index: 'remark', width: ipaddress_width, classes: "pointer",sortable: true,sorttype:'text'} //No I18N
        ];

        var menuLinkArray = getSubnetAddressTabLinks("Alerts",subnetAddr);//No I18N
        var jsonObj = {			
            "menuLinks": menuLinkArray //No I18N
        }

        deviceBasicDetails.setProperties(jsonObj);
        OpUtilsClient.IPAMSubnetController.set("ipamSubnetMenuLinks", deviceBasicDetails); //No I18N
        
        var subnetIPaddrUrl = getOpUtilsAPIURL() + "&operation=GET_IPAM_ALERTS&subnetAddress=" + OpUtilsClient.IPAMController.selectedSubnet;//No I18N
        $.getJSON(subnetIPaddrUrl, function(resp) { //No I18N
            loadJQgridWithData("#DevicesList", resp.result, colNamesList1, colModelList1, "", "#DevicePager", "deviceList"); //No I18N
        });
        return deviceList;
    },
    IPV4IPAddressSummary: function(ipAddr)
    {
        var menuLinkArray = getIPAddressTabLinks("Summary",ipAddr);//No I18N
        var jsonObj = {			
            "menuLinks": menuLinkArray //No I18N
        }
        OpUtilsClient.IPAMController.selectedIPAddress = ipAddr;
        ipamSnapshotPage.setProperties(jsonObj);
        OpUtilsClient.IPAMSubnetController.set("ipamIPAddressMenuLinks", ipamSnapshotPage); //No I18N

        var ipsummaryURL = getOpUtilsAPIURL() + "&operation=GET_IP_DETAILS&ipAddress=" + ipAddr;//No I18N
        $.getJSON(ipsummaryURL, function(resp) { //No I18N
            OpUtilsClient.IPAMSubnetController.set("ipAddressDetails", resp); //No I18N
        });
        return deviceList;
    },
    IPV4IPAddressHistory: function(ipAddr)
    {
       var colNamesList1 = [Ember.I18n.t('opu.views.IP_ADDRESS',this), Ember.I18n.t('opu.views.DETECTED_TIME',this), Ember.I18n.t('opu.views.DNS_NAME',this), Ember.I18n.t('opu.views.MAC_ADDRESS',this), Ember.I18n.t('opu.views.SYS_DESCR',this)]; //No I18N
        var colModelList1 = [{name: 'ipaddress-in-long', index: 'ipaddress-in-long', width: ipaddress_width, hidden: true,sortable: true,sorttype:'long',formatter:convertLongToIPAddress}, //No I18N
            {name: 'generated-time', index: 'generated-time', width: status_width ,sortable: true,sorttype:'text'}, //No I18N
            {name: 'dns-name', index: 'dns-name', width: ipaddress_width,sortable: true,sorttype:'text'}, //No I18N
            {name: 'mac-address', index: 'mac-address',width:width100, sortable: true,sorttype:'text'}, //No I18N
            {name: 'system-description', index: 'system-description', width: deviceCate_width, sortable: true,sorttype:'text'}//No I18N
        ];

        var menuLinkArray = getIPAddressTabLinks("History",ipAddr);//No I18N
        var jsonObj = {			
            "menuLinks": menuLinkArray //No I18N
        }
        OpUtilsClient.IPAMController.selectedIPAddress = ipAddr;
        ipamSnapshotPage.setProperties(jsonObj);
        OpUtilsClient.IPAMSubnetController.set("ipamIPAddressMenuLinks", ipamSnapshotPage); //No I18N
        
        var iPaddrHistoryUrl = getOpUtilsAPIURL() + "&operation=GET_IP_HISTORY&ipAddress=" + ipAddr;//No I18N
        $.getJSON(iPaddrHistoryUrl, function(resp) { //No I18N
            loadJQgridWithData("#DevicesList", resp.result, colNamesList1, colModelList1, "", "#DevicePager", "deviceList"); //No I18N
        });
        return deviceList;
    },
    IPV4IPAddressAlerts: function(ipAddr)
    {
        var colNamesList1 = [Ember.I18n.t('opu.views.IP_ADDRESS',this), Ember.I18n.t('opu.views.ALERT_GENERATED_TIME',this), Ember.I18n.t('opu.views.ALERT_TYPE',this), Ember.I18n.t('opu.views.REMARKS',this)]; //No I18N
        var colModelList1 = [{name: 'ipaddress-in-long', index: 'ipaddress-in-long', width: ipaddress_width,hidden:true,sortable: true,sorttype:'long',formatter:convertLongToIPAddress}, //No I18N
            {name: 'generated-time', index: 'generated-time', width: status_width ,sortable: true,sorttype:'text'}, //No I18N
            {name: 'alert-type', index: 'alert-type', width: ipaddress_width ,sortable: true,sorttype:'text'}, //No I18N
            {name: 'remark', index: 'remark', width: ipaddress_width ,sortable: true,sorttype:'text'} //No I18N
        ];

        var menuLinkArray = getIPAddressTabLinks("Alerts",ipAddr);//No I18N
        var jsonObj = {			
            "menuLinks": menuLinkArray //No I18N
        }
        OpUtilsClient.IPAMController.selectedIPAddress = ipAddr;
        ipamSnapshotPage.setProperties(jsonObj);
        OpUtilsClient.IPAMSubnetController.set("ipamIPAddressMenuLinks", ipamSnapshotPage); //No I18N
        
        var iPaddrAlertsUrl = getOpUtilsAPIURL() + "&operation=GET_IP_ALERTS&ipAddress=" + ipAddr;//No I18N
        $.getJSON(iPaddrAlertsUrl, function(resp) { //No I18N
            loadJQgridWithData("#DevicesList", resp.result, colNamesList1, colModelList1, "", "#DevicePager", "deviceList"); //No I18N
        });
        return deviceList;
    },
    
    
    getDashboardDetails: function(tool,dashName,id)
    {
        var showDashboarDelete = true;
        var hideEditDash = false;
      ipamDashboard = [];
//        var iPaddrAlertsUrl = getOpUtilsAPIURL() + "&operation=GET_IP_ALERTS&ipAddress=192.168.49.1" ;//No I18N
//         $.ajax({
//		url: iPaddrAlertsUrl, //No I18N
//		type: 'GET', //No I18N
//		async:false,
//		success: function(jsonData)
//		{
            //Will remove below line later...
            
            var jsonData = {"widgetList":[{"id":"1","desc":"Top10 Subnets with Occupied IPs","name":"Top10 Subnets with Occupied IPs","colID":"1"},{"id":"2","desc":"Top10 Subnets with Free IPs","name":"Top10 Subnets with Free IPs","colID":"2"},{"id":"3","desc":"Top 10 Subnets by DNS resolution","name":"Top 10 Subnets by DNS resolution","colID":"1"},{"id":"4","desc":"Top 10 Subnets by IPs-in-Domain","name":"Top 10 Subnets by IPs-in-Domain","colID":"2"},{"id":"6","desc":"Top10 Groups with occupied IPs","name":"Top10 Groups with occupied IPs","colID":"1"},{"id":"7","desc":"Top10 Groups with Free IPs","name":"Top10 Groups with Free IPs","colID":"2"}],"dashDesc":"","dashboardID":"302","noOfCols":"2","dashName":"new","colWidths":[{"colID":"1","colWidth":"50"},{"colID":"2","colWidth":"50"}]}//No I18N
            if(tool !== undefined && tool === "SPM"){
                jsonData = {"widgetList":[{"id":"1","desc":"Top Ten Switches With Occupied Ports","name":"Top Ten Switches With Occupied Ports","colID":"1"},{"id":"2","desc":"Top Ten Switches With Free Ports","name":"Top Ten Switches With Free Ports","colID":"2"},{"id":"3","desc":"Top10 groups with Occupied Ports","name":"Top10 groups with Occupied Ports","colID":"1"},{"id":"4","desc":"Top10 groups with Free Ports","name":"Top10 groups with Free Ports","colID":"2"}],"dashDesc":"","dashboardID":"302","noOfCols":"2","dashName":"new","colWidths":[{"colID":"1","colWidth":"50"},{"colID":"2","colWidth":"50"}]}//No I18N
            }

            var showContent = false;
            var dashDispName = dashDisplayNames[dashName];
            if (!checkIfAValIsValid(dashDispName, 'string'))
            {
                dashDispName = dashName;
            }
            OpUtilsClient.IPAMDashboardDetailsController.dashboardName = dashName;
            OpUtilsClient.IPAMDashboardDetailsController.dashboardObj.dashboardId = id;

            if (dashName === "dashboard.name.audit")
            {
                hideEditDash = true;
            }
            var row = {"showContentByRow": false, "data": []};//No I18N
            var newJsonObj = {"dashBoardName": dashName, "dashDisplayName": dashDispName, "cols": []} //No I18N
            var col1 = {"showContent": showContent, "data": [], "colsId": "col_1"};//No I18N
            var col2 = {"showContent": showContent, "data": [], "colsId": "col_2"};//No I18N
            var col3 = {"showContent": showContent, "data": [], "colsId": "col_3"};//No I18N
            var col4 = {"showContent": showContent, "data": [], "colsId": "col_4"};//No I18N
//            var row = {"showContentByRow": false, "data": []};//No I18N

            $.each(jsonData.widgetList, function(i, val) {

                var dispName = val.name;//Ember.I18n.t(val.name, this);//widgetDisplayNames[val.name]; ..........check this line..
                if (!checkIfAValIsValid(dispName, 'string') || (dispName).indexOf("Missing translation:") !== -1)
                {
                    dispName = val.name;
                }
//                if (notSupportWidgetList.indexOf(val.desc) === -1)
//                {
                    var newArray = {"uniqueId": "widget" + val.id, "id": val.id, "DispName": dispName, "desc": val.desc, "name": val.name, "colId": val.colID,"toolname":tool};	 //No I18N

                    if (val.desc === "Top Call Performance by Location")
                    {
                        row.data.push(newArray);
                        row.showContentByRow = true;
                    }
                    else
                    {
                        if (parseInt(val.colID) === 1)
                        {
                            col1.showContent = true; //No I18N
                            col1.data.push(newArray);	//No I18N
                        }
                        if (parseInt(val.colID) === 2)
                        {
                            col2.showContent = true; //No I18N
                            col2.data.push(newArray);	//No I18N
                        }
                        if (parseInt(val.colID) === 3)
                        {
                            col3.showContent = true; //No I18N
                            col3.data.push(newArray);	//No I18N
                        }
                        if (parseInt(val.colID) === 4)
                        {
                            col4.showContent = true; //No I18N
                            col4.data.push(newArray);	//No I18N
                        }
                    }
//                }
            });

            if (jsonData.noOfCols === "1")
            {
                col1.colsWid = Math.round(jsonData.colWidths[0].colWidth) - 6;
            }
            if (jsonData.noOfCols === "2")
            {
                col1.colsWid = Math.round(jsonData.colWidths[0].colWidth) - 3;
                col2.colsWid = Math.round(jsonData.colWidths[1].colWidth) - 3;
            }
            if (jsonData.noOfCols === "3")
            {
                col1.colsWid = Math.round(jsonData.colWidths[0].colWidth) - 2;
                col2.colsWid = Math.round(jsonData.colWidths[1].colWidth) - 2;
                col3.colsWid = Math.round(jsonData.colWidths[2].colWidth) - 2;
            }
            if (jsonData.noOfCols === "4")
            {
                col1.colsWid = Math.round(jsonData.colWidths[0].colWidth) - 2;
                col2.colsWid = Math.round(jsonData.colWidths[1].colWidth) - 2;
                col3.colsWid = Math.round(jsonData.colWidths[2].colWidth) - 2;
                col4.colsWid = Math.round(jsonData.colWidths[3].colWidth) - 2;
            }


            newJsonObj.cols.push(col1); //No I18N
            newJsonObj.cols.push(col2); //No I18N
            newJsonObj.cols.push(col3); //No I18N
            newJsonObj.cols.push(col4); //No I18N	
            
            ipamDashboard.setProperties(newJsonObj);
            ipamDashboard.setProperties(row);
            ipamDashboard.setProperties({showDashboarDelete: showDashboarDelete});
            ipamDashboard.setProperties({hideEditDash: hideEditDash});
//                }
//        });
        return ipamDashboard;
    }

});

function getSubnetAddressTabLinks(selectedTab,subnet)
{
    var sumSelected = false;
    var alertSelected = false;
    var historySelected = false;
    var ips = false;

    if (selectedTab === "Summary") {
        sumSelected = true;
    }
    if (selectedTab === "Alerts") {
        alertSelected = true;
    }
    if (selectedTab === "History") {
        historySelected = true;
    }
    if (selectedTab === "IPs") {
        ips = true;
    }
    var baseurl = getIPAMGroupURL()+"/Subnet/" + subnet+"/";//No I18N
    var menuLinkArray = [
        {"Name": 'Summary', "url": baseurl + "Summary", "title": "Summary", "isSelected": sumSelected}, //No I18N
        {"Name": ' IPs ', "url": baseurl + "IPs", "title": "IP Address", "isSelected": ips}, //No I18N
        {"Name": 'History', "url": baseurl + "History", "title": "History", "isSelected": historySelected}, //No I18N
        {"Name": 'Alerts', "url": baseurl + "Alerts", "title": "Alerts", "isSelected": alertSelected}, //No I18N
    ];

    return menuLinkArray;
}

function getIPAddressTabLinks(selectedTab,ipaddress)
{
    var sumSelected = false;
    var alertSelected = false;
    var historySelected = false;

    if (selectedTab === "Summary") {
        sumSelected = true;
    }
    if (selectedTab === "Alerts") {
        alertSelected = true;
    }
    if (selectedTab === "History") {
        historySelected = true;
    }
    var baseurl = window.apiclientUrl+"IPAM/IPAddress/" + ipaddress+"/";//No I18N
    var menuLinkArray = [
        {"Name": 'Summary', "url": baseurl + "Summary", "title": "Summary", "isSelected": sumSelected}, //No I18N
        {"Name": 'History', "url": baseurl + "History", "title": "History", "isSelected": historySelected}, //No I18N
        {"Name": 'Alerts', "url": baseurl + "Alerts", "title": "Alerts", "isSelected": alertSelected}, //No I18N
    ];

    return menuLinkArray;
}

function actionForSubnet(cellValue, options, rowdata, action)
{
    var subnet = getIPAddressFrmLong(cellValue);
    return "<a href='" +getIPAMGroupURL()+"/Subnet/" + subnet + "/Summary' >" + subnet+"/"+getCIDRNotation(rowdata['subnet-size']) + "</a>"; //No I18N
}
function actionForSubnet1(cellValue, options, rowdata, action)
{
    var subnet = getIPAddressFrmLong((cellValue-1));
    return "<a href='" +getIPAMGroupURL()+"/Subnet/" + subnet + "/Summary' >" + subnet+"/"+getCIDRNotation(rowdata['subnet-size']) + "</a>"; //No I18N
}
function actionForIPAddress(cellValue, options, rowdata, action)
{
    var ip = getIPAddressFrmLong(cellValue);
    return "<a href='" +window.apiclientUrl+"IPAM/IPAddress/" + ip + "/Summary' >" + ip + "</a>"; //No I18N
}
function subnetUsageImg(cellValue, options, rowdata, action)
{
    var ipUtilization = Math.round(cellValue);
    var lowUtil = 20;
    var highUtil = 80;
    var bgUtil = Math.round((cellValue * 80) / 100);
    var usageColor = "url(/images/green_bar.jpg)";//No I18N
//            var d = new Double(ipUtilization);
    if (ipUtilization > lowUtil && ipUtilization <= highUtil) {
        usageColor = "url(/images/yellow_bar.jpg)";//No I18N
    } else if (ipUtilization > highUtil) {
        usageColor = "url(/images/red_bar.jpg)";//No I18N
    }
    var perClass = (ipUtilization == 100) ? "redtxt" : "txt"; //No I18N
    var renderString = "<div nowrap style='float:left'><div class=\"barbg\" style='float:left'><div style=\"background:" + usageColor + "; width:" + bgUtil + "px;height:10px;float:left;\"> </div></div><span class=" + perClass + " nowrap style='float:left'>&nbsp;" + ipUtilization + "% </span></div>"; //No I18N
    return renderString;
}
function setIPAMSelectedGroup(groupid)
{
    if(groupid === null){
        groupid = "AllSubnets";//No I18N
    }
    OpUtilsClient.IPAMController.selectedIPAMGroupName=OpUtilsClient.IPAMSubnetController.ipamGroupCapationObjects.groups[groupid]
}
function getIPAMGroupURL(){
    return window.apiclientUrl + "IPAM/Group/"+OpUtilsClient.IPAMController.selectedIPAMGroupID;//No I18N
}
function linkToDevicesListPage(cellValue, options, rowdata, action)
{
	//var Rs = ["#1f77b4", "#ff7f0e", "#2ca02c", "#d62728", "#9467bd", "#8c564b", "#e377c2", "#7f7f7f", "#bcbd22", "#17becf"];
	var config = d3.scale.category10();
	var k =options.rowId-1;
	return '<svg height=24><g><rect x="0" y="10" width="8" height="8" style="fill:url(#grad'+ k +');"></rect><text x="20" y="14" dy=".35em" >'+cellValue+'</text></g></svg>';//No I18N
}



function loadWidgets(widgetElement, tableElement, tableId, widgetId, widgetName, widgetUniqueId,oputilstool)
{
    if ($("#" + tableId + " tr").length > 1)
    {
        $("#" + tableId).jqGrid("GridUnload");
    }
    else
    {
        $("#" + tableId).html("");	//No I18n
    }
    var baseOpUtilsURL = getOpUtilsAPIURL();
    if(oputilstool === "SPM"){
        baseOpUtilsURL = getOpUtilsSPMAPIURL();
    }
    $(widgetElement).html(""); //No I18N
    $.getJSON(baseOpUtilsURL +'&operation=GET_TOP_TEN_DATA&widgetId='+widgetId, function(jsonData)  //No I18N
    {
//        if (jsonData.message === undefined)
    if(jsonData.WidgetDetails !== undefined)
        {
//			showWidgetDeviceLink(widgetId,jsonData.WidgetDetails);
            var Name = jsonData.WidgetDetails.Name;
            var wName = Ember.I18n.t(Name, this); //No I18n

            if (true)
            {
                
                var top10Obj = null;
                var top10Data = [];

                var trimLen = 20;
                var defCriticalVal = 80;
                var defAttentionVal = 60;
                var criticalVal = defCriticalVal;
                var attentionVal = defAttentionVal;
                if (jsonData.WidgetDetails !== undefined && jsonData.WidgetDetails.WidgetAdditionalData !== undefined && jsonData.WidgetDetails.WidgetAdditionalData !== null && jsonData.WidgetDetails.WidgetAdditionalData.criticalValue !== undefined && jsonData.WidgetDetails.WidgetAdditionalData.criticalValue !== "") //No I18N
                {
                    criticalVal = jsonData.WidgetDetails.WidgetAdditionalData.criticalValue;
                }
                if (jsonData.WidgetDetails !== undefined && jsonData.WidgetDetails.WidgetAdditionalData !== undefined && jsonData.WidgetDetails.WidgetAdditionalData !== null && jsonData.WidgetDetails.WidgetAdditionalData.attentionValue !== undefined && jsonData.WidgetDetails.WidgetAdditionalData.attentionValue !== "") //No I18N
                {
                    attentionVal = jsonData.WidgetDetails.WidgetAdditionalData.attentionValue;
                }

                if (criticalVal === NaN || criticalVal === 0)
                {
                    criticalVal = defCriticalVal;
                }
                if (attentionVal === NaN)
                {
                    attentionVal = defAttentionVal;
                }

                var noDataWidth = 450;
                var noDataHeight = 50;

                var count = 0;

                if (jsonData.WidgetDetails === undefined)
                {
                    jsonData.WidgetDetails = {};
                    jsonData.WidgetDetails.WidgetData = {};
                }
                $.each(jsonData.WidgetDetails.WidgetData, function(seriesKey, value)
                {
                    top10Obj = {};
                    count = count + 1;
//                    var deviceNameVal = value[0];  //No I18N
//                    var trimmedDeviceNameVal = deviceNameVal;  //No I18N
//                    if (deviceNameVal !== undefined && deviceNameVal.length > trimLen)
//                    {
//                        var deviceNameValLen = deviceNameVal.length;
//                        trimmedDeviceNameVal = deviceNameVal.substring(0, (trimLen - 3)) + "..." + deviceNameVal.substring(deviceNameValLen - 3, deviceNameValLen); //No I18N
//                    }
//                    top10Obj.trimmedDeviceName = trimmedDeviceNameVal;  //No I18N
//                    top10Obj.deviceDispName = deviceNameVal;  //No I18N
//                    top10Obj.deviceName = deviceName; //No I18N
                    top10Obj.count = count;  //No I18N
                    if (Name === "opu.api.top10subnetswithoccupied" || Name === "opu.api.top10subnetswithfreeips" || Name === "opu.api.top10subnetswithdnsresolutionsuccess" || Name === "opu.api.top10subnetsinAd") //No I18N
                    {
                        top10Obj.trimmedDeviceName = value["subnet-address"];//No I18N
                        top10Obj.deviceDispName=value["subnet-address"];//No I18N
                        top10Obj.deviceName=value["subnet-address"].split("/")[0];//No I18N
                    }else if(Name === "opu.api.top10groupswithfreeips" || Name === "opu.api.top10groupswithoccupiedips" || Name === "opu.api.top10groupswithfreeports" || Name === "opu.api.top10groupswithoccupiedport" || Name === "opu.api.top10groupswithoccupiedports"){//No I18N
                        
                        top10Obj.trimmedDeviceName = value["group-name"];//No I18N
                        top10Obj.deviceDispName=value["group-name"];//No I18N
                        top10Obj.deviceName=value["group-name"];//No I18N
                        top10Obj.groupid=value["group-id"];//NO I18N
                    }else if(Name === "opu.api.top10switcheswithoccupied" || Name === "opu.api.top10switcheswithfreeips"){//No I18N
                        var switchname = value["switch-name"];//No I18N
                        top10Obj.trimmedDeviceName = switchname;
                        top10Obj.deviceDispName=switchname;
                        top10Obj.deviceName=switchname
                    }
                    if (Name === "opu.api.top10subnetswithoccupied" || Name === "opu.api.top10groupswithoccupiedips" || Name === "opu.api.top10switcheswithoccupied" || Name === "opu.api.top10groupswithoccupiedports") //No I18N
                    {
                        top10Obj.value = value.usedPercentage;//No I18N
                    }else if (Name === "opu.api.top10subnetswithfreeips" || Name === "opu.api.top10groupswithfreeips" || Name === "opu.api.top10switcheswithfreeips" || Name === "opu.api.top10groupswithfreeports") //No I18N
                    {
                        top10Obj.value = value.availablePercentage;
                    }
                    else if (Name === "opu.api.top10subnetswithdnsresolutionsuccess") //No I18N
                    {
                        top10Obj.value = value.dnsPercentage;
                    }
                    else if (Name === "opu.api.top10subnetsinAd") //No I18N
                    {
                        top10Obj.value = value["ip-in-ad-count"];//No I18N
                    }
                    
                    top10Data.push(top10Obj);
                });
                var chartWidth = 450;
                var vbarMaxW = 270;
                var vbarMaxH = 20;
                var captionWidth = 150;
                var gap = 8;
                if (top10Data.length > 0)
                {
                    var chartHeight = (vbarMaxH + 2 * gap) * top10Data.length; //No I18N

                    var chart2 = d3.select(widgetElement)
                            .append("svg") //No I18N
                            .attr("class", "d3chart") //No I18N
                            .attr("width", chartWidth + 10) //No I18N
                            .attr("height", chartHeight + 10);  //No I18N

                    var x = d3.scale.linear().domain([0, 100]).rangeRound([0, vbarMaxW]);   //No I18N
                    if (wName === Ember.I18n.t('widget.name.top10traf', this) || wName === Ember.I18n.t('widget.name.top10errdis', this)) //No I18N
                    {
                        x = d3.scale.linear().domain([0, d3.max(top10Data.map(function(d) {
                                return d.value;
                            }))]).rangeRound([0, vbarMaxW]);   //No I18N
                    }
                    var y = d3.scale.ordinal().domain(top10Data.map(function(d) {
                        return d.count;
                    })).rangeBands([0, chartHeight]);

                    chart2.selectAll("rect") //No I18N
                            .data(top10Data)
                            .enter().append("rect") //No I18N
                            .attr("x", captionWidth) //No I18N
                            .attr("y", function(d) {//No I18N
                                return y(d.count) + gap;
                            }) //No I18N
                            .transition().delay(function(d, i) {
                        return i * 200;
                    }).duration(800)
                            .attr("width", function(d) {//No I18N
                                return x(d.value);
                            }) //No I18N
                            .attr("height", vbarMaxH) //No I18N
                            /*.attr("fill",function(d)  //No I18N
                             {  //No I18N
                             var fillColor = "#ff495b"; //No I18N
                             if (d.value >= criticalVal)
                             {
                             fillColor = "#ff495b"; //No I18N
                             }
                             else if (d.value >= attentionVal)
                             {
                             fillColor = "#f6f400"; //No I18N
                             }
                             else
                             {
                             fillColor = "#4cd1a0"; //No I18N
                             }
                             return fillColor; //No I18N
                             }) //No I18N*/
                            //.attr("fill","url(#gradient)")
                            .attr("class", "pointer"); //No I18N
                    chart2.selectAll("rect").attr("fill", function(d)//No I18N
                    {
                        var gradient = chart2.append("svg:defs")//No I18N
                                .append("svg:linearGradient")//No I18N
                                .attr("id", "gradient" + widgetId + "_" + d.count)//No I18N
                                .attr("x1", "0%")//No I18N
                                .attr("y1", "100%")//No I18N
                                .attr("x2", "100%")//No I18N
                                .attr("y2", "0%")//No I18N
                                .attr("spreadMethod", "pad");  //No I18N
                        if (d.value >= criticalVal)
                        {

                            gradient.append("svg:stop")//No I18N
                                    .attr("offset", "5%")//No I18N
                                    .attr("stop-color", "#960b0b")//No I18N
                                    .attr("stop-opacity", 1);//No I18N

                            gradient.append("svg:stop")//No I18N
                                    .attr("offset", "95%")//No I18N
                                    .attr("stop-color", "#e5201f")//No I18N
                                    .attr("stop-opacity", 1);//No I18N
                        }
                        else if (d.value >= attentionVal)
                        {
                            gradient.append("svg:stop")//No I18N
                                    .attr("offset", "0%")//No I18N
                                    .attr("stop-color", "#eebc20")//No I18N
                                    .attr("stop-opacity", 1);//No I18N

                            gradient.append("svg:stop")//No I18N
                                    .attr("offset", "100%")//No I18N
                                    .attr("stop-color", "#f3e50a")//No I18N
                                    .attr("stop-opacity", 1);//No I18N
                        }
                        else
                        {
                            gradient.append("svg:stop")//No I18N
                                    .attr("offset", "0%")//No I18N
                                    .attr("stop-color", "#609d0f")//No I18N
                                    .attr("stop-opacity", 1);//No I18N

                            gradient.append("svg:stop")//No I18N
                                    .attr("offset", "100%")//No I18N
                                    .attr("stop-color", "#7dc130")//No I18N
                                    .attr("stop-opacity", 1);//No I18N
                        }
                        return "url(#gradient" + widgetId + "_" + d.count + ")";//No I18N
                    });
                    chart2.selectAll("rect").on("click", function(d, i) { //No I18n
                        location.href = window.apiclientUrl + "IPAM/Group/AllSubnets/Subnet/" + d.deviceName + "/Summary";//No I18N
                        if(oputilstool === "SPM"){
                            location.href = window.apiclientUrl + "SPM/Switch/AllSwitches/" + d.deviceName + "/Summary";//No I18N
                        }
                        if(oputilstool === "SPM" && (Name === "opu.api.top10groupswithoccupiedport" || Name === "opu.api.top10groupswithoccupiedports")){
                            location.href = window.apiclientUrl + "SPM/Group/"+d.groupid;//No I18N
                        }else if(oputilstool === "IPAM" && (Name === "opu.api.top10groupswithoccupiedips" || Name ===  "opu.api.top10groupswithfreeips") ){//NO I18N
                            location.href = window.apiclientUrl + "IPAM/Group/"+d.groupid+"/SubnetList";//No I18N
                        }

                    });
                    if (Name === "opu.api.top10subnetswithoccupied" )
                    {
                        chart2.selectAll("rect").data(top10Data).call(d3.helper.tooltip(d3.select(widgetElement), function(d, i) //No I18N
                        {
                            return Ember.I18n.t('opu.views.SUBNET_ADDRESS', this) + ": " + d.deviceDispName + "<br>" + Ember.I18n.t('opu.views.SUBNET_USAGE', this) + ": " + d.value; //No I18N
                        }));
                    }
                    chart2.selectAll("text.score") //No I18N
                            .data(top10Data)
                            .enter().append("text") //No I18N
                            .attr("x", function(d, i) {//No I18N
                                return x(d.value) + captionWidth + 5;
                            }) //No I18N
                            .attr("y", function(d, i)  //No I18N
                            {
                                var yPos = y(d.count) + (y.rangeBand() / 2) + 5;
                                return yPos;
                            })
                            .attr("text-anchor", "start") //No I18N
                            .attr("class", "value blkText")	 //No I18N				
                            .attr("font-size", "10px") //No I18N
                            .text(function(d, i)
                            {
                                if (Name === "opu.api.top10subnetsinAd") //No I18N
                                {
                                    return d.value;  //No I18N
                                }
                                else
                                {
                                    return d.value + "%";  //No I18N
                                }
                            }); //No I18N

                    chart2.selectAll("text.name") //No I18N
                            .data(top10Data)
                            .enter().append("text") //No I18N
                            .attr("x", 0) //No I18N
                            .attr("y", function(d) {//No I18N
                                return y(d.count) + y.rangeBand() / 2;
                            }) //No I18N
                            .attr("dy", ".36em") //No I18N
                            .attr("text-anchor", "start") //No I18N
                            .attr('class', 'name pointer') //No I18N
                            .text(function(d, i) {
                                return d.trimmedDeviceName;
                            }) //No I18N
                            .on("click", function(d, i) //No I18n
                            {
                                location.href = window.apiclientUrl + "IPAM/Group/AllSubnets/Subnet/" + d.deviceName + "/Summary";//No I18N
                                if(oputilstool === "SPM"){
                                    location.href = window.apiclientUrl + "SPM/Switch/AllSwitches/" + d.deviceName + "/Summary";//No I18N
                                }
                                if(oputilstool === "SPM" && (Name === "opu.api.top10groupswithoccupiedport" || Name === "opu.api.top10groupswithoccupiedports")){
                                    location.href = window.apiclientUrl + "SPM/Group/"+d.groupid;//No I18N
                                }else if(oputilstool === "IPAM" && (Name === "opu.api.top10groupswithoccupiedips" || Name ===  "opu.api.top10groupswithfreeips") ){//NO I18N
                                    location.href = window.apiclientUrl + "IPAM/Group/"+d.groupid+"/SubnetList";//No I18N
                                }

                            });
                }
                else
                {
                    d3.select(tableElement).append("table").attr("class", "d3chart").attr("height", noDataHeight).attr("width", noDataWidth).append("tr").append("td").text(Ember.I18n.t('webclient.snapshot.testlinks.nodata', this));  //No I18N
                }
            }
        }
        else
        {
            d3.select(tableElement).append("table").attr("class", "d3chart").attr("height", noDataHeight).attr("width", noDataWidth).append("tr").append("td").text(Ember.I18n.t('webclient.snapshot.testlinks.nodata', this));  //No I18N
        }
    });
}

function displayAddSubnetFields(addType)
{
	$("#addbyManualDiv").css('display','none');
	$("#addbyImportDiv").css('display','none');
	$("#addbyDiscoverDiv").css('display','none');

	if(addType.id === "addbyManual")
	{
		$("#addbyManualDiv").css('display','block');
		$("#servername").focus();
	}
	else if(addType.id === "addbyImport" )
	{
		$("#addbyImportDiv").css('display','block');
	}

}

function showHideAdDomain(id)
{
    if($("#"+id).prop("checked")){
        $("#adDomain").css('display','block');
    }else{
        $("#adDomain").css('display','none');
    }
}
function showIPAMGroupFlied(grouptype)
{
    if(grouptype === "new"){
        $("#newIPAMGroup").css('display','block');
        $("#existingIPAMGroup").css('display','none');
    }else{
        $("#existingIPAMGroup").css('display','block');
        $("#newIPAMGroup").css('display','none');
    }
}

function addAdDomainPageDialog(){

		$("#IPAMAddAdDomainTitle").hide();
		$("#addCancelBotton").hide();
		$('#addAdDomainpopUp').dialog({
                dialogClass: "no-close", //No I18N
                 bgiframe: true,
                 title:Ember.I18n.t('opu.views.ADD_AD_DOMAIN',this), //No I18N
                 draggable: false,
                 position: 'Center', //No I18N
                 width:'500px', //No I18N
                 closeOnEscape:'true', //No I18N
                 modal:true,
                buttons: 
                    {
                    	'Add':function(){ //No I18N
                            addADDomain();
                    	},
                        'Cancel':function() { //No I18N
                            $( this ).dialog( "close" ); //No I18N
                        }
               }
            });
            
            
}

function getCIDRNotation(subnetmask)
{
    var cidr = "24";//No I18n
    var cidr1 = cidrNotation[subnetmask];
    if(cidr1 !== undefined ){
        cidr = cidr1;
    }
    return cidr;
}
function appendRowsInIPAMIPList(totalRowCount)
{
    if(OpUtilsClient.IPAMController.appendIPAddrInAllIPs === true)
    {
        $("#ipaddrdataloading").show();
        var numberOfNewRows = 500;
        $.ajax({
            url: getOpUtilsAPIURL() + "&operation=GET_ALL_IP_ADDRESSES&startIndex=" + totalRowCount + "&numOfObjects=" + numberOfNewRows, //NO I18N
            type: 'GET', //No I18N		
            dataType: 'json', //No I18N
            async: false, //No I18N
            success: function(subnetsummary)
            {
                if (subnetsummary.result === undefined) {
                    $("#ipaddrdataloading").hide();
                } else {
                    var g = $("#ipamSummaryList");
                    g.addRowData(totalRowCount+1, subnetsummary.result, 'last');//NO I18N
                    g[0].refreshIndex();
                    g.trigger("reloadGrid");//NO I18N
                    totalRowCount += numberOfNewRows;
                    setTimeout(function () {appendRowsInIPAMIPList(totalRowCount)}, 3000);
                }
            }
        })
    }
}

function ipamSubnetActions(jqgridid,colName,action,subnetid123)
{
    var selectedRows = ""
	if(subnetid123 !== undefined){
		selectedRows = subnetid123;
	}else{
		selectedRows = getEmberSelectedRows(jqgridid,colName);
	}

var actionKey = {};
var selectedIPAMGroup = "";

if(jqgridid === "ipamSummaryList" && action === "Delete"){
    actionKey = "DELETE_SUBNETS";//NO I18N
}else if(jqgridid === "ipamSummaryList" && action === "Scan"){//NO I18N
    actionKey = "SCAN_SUBNETS";//NO I18N
}else if(jqgridid === "ipamSummaryList" && action === "ScanAll"){//NO I18N
    actionKey = "SCAN_ALL_SUBNETS";//NO I18N
    selectedIPAMGroup = OpUtilsClient.IPAMController.selectedIPAMGroupID;
    if(selectedIPAMGroup === "AllSubnets"){
        selectedIPAMGroup = "0";//NO I18N
    }else{
        selectedIPAMGroup = selectedIPAMGroup.split("_")[1];//NO I18N
    }
}else if(jqgridid === "IPAMAllAlerts" && action === "Delete"){//NO I18N
    actionKey = "DELETE_ALERTS";//NO I18N
}else if(jqgridid === "IPAMAllAlerts" && action === "DeleteAll"){//NO I18N
    actionKey = "DELETE_ALL_ALERTS";//NO I18N
}

$.ajax({
        url: '/oputilsapi/ipam?key='+getOpUtilsAPIKey(), //No I18N
        type: 'POST', //No I18N
        data: {"v":"1","format":"json","operation":actionKey,"NETID":selectedRows,"treeNodeID":selectedIPAMGroup,"ALERTID":selectedRows},//No I18N
        success: function(response){
            if (response.status === "Failure")
            {
                document.getElementById('resDiv').style.backgroundColor = '#FF0000';//No I18N		
                document.getElementById('resDiv').style.display = 'block'; //No I18N
                document.getElementById('resDiv').innerHTML = response.message;
                $("#resDiv").fadeOut(2000);
            }else if (response.status === "Success")//NO I18N
            {
                window.location.reload();	
            }
        }
});
}

function ipamSubnetEditAndDelete(cellValue, options, rowdata, action)
{

	var editDiv = "<span style='float:left;' class='pointer ui-icon ui-icon-pencil' title='Edit' onclick='openEditSubnetPage(&#39;"+rowdata['subnet-address']+"&#39;)'></span>"; //No I18N
	var delDiv = "<span style='float:left;margin-left:5px;' class='pointer ui-icon ui-icon-trash' title='Delete' onclick='ipamSubnetActions(&#39;ipamSummaryList&#39;,&#39;subnetid&#39;,&#39;Delete&#39;,&#39;"+rowdata.subnetid+"&#39;)'></span>"; //No I18n
	return editDiv+delDiv;
}
function openEditSubnetPage(subnet){
 location.href = window.apiclientUrl + "IPAM/Group/"+OpUtilsClient.IPAMController.selectedIPAMGroupID+"/Subnet/"+subnet+"/Edit";//No I18N   
}
