
/* IPAM Models */

OpUtilsClient.NetworkMonitor = Ember.Object.extend({});
var nwmListHosts = OpUtilsClient.NetworkMonitor.create();
OpUtilsClient.NetworkMonitor.reopenClass({
    listNWMHosts: function()
    {
        var colNamesList = [Ember.I18n.t('opu.views.IP_ADDRESS',this), Ember.I18n.t('opu.views.DNS_NAME',this), Ember.I18n.t('opu.views.STATUS',this),Ember.I18n.t('opu.views.SYS_NAME',this), Ember.I18n.t('opu.views.LAST_UPDATED_TIME',this), Ember.I18n.t('opu.views.RESPONSE_TIME',this), Ember.I18n.t('opu.views.MONITORING_STATUS',this), Ember.I18n.t('opu.views.SYS_UPTIME',this)]; //No I18N
        var colModelList = [{name: 'ipaddress-in-long', index: 'ipaddress-in-long',width:ipaddress_width,sortable: true,sorttype:'long',formatter:convertLongToIPAddress}, //No I18N
            {name: 'ip-to-dns', index: 'ip-to-dns',width:width100, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'status', index: 'status',width: status_width, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'system-name', index: 'system-name', width: width100, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'last-updated-time', index: 'last-updated-time', sortable: true, sorttype: 'date'}, //No I18N
            {name: 'response-time', index: 'response-time', width: width100,sortable: true, sorttype: 'text'}, //No I18N
            {name: 'monitoring-status', index: 'system-uptime', sortable: true, sorttype: 'text'}, //No I18N
            {name: 'system-uptime', index: 'system-uptime', sortable: true, sorttype: 'date'}, //No I18N

        ];
        var nwmHostUrl = getOpUtilsNWMAPIURL() + "&operation=GET_NWM_DEVICES";//NO I18N
        var defaultOptions = {"sortName": "ip-address", "sortOrder": "asc"};//No I18N
        
        OpUtilsClient.NetworkMonitor.getNWMScanTime();
        
        $.getJSON(nwmHostUrl, function(resp) { //No I18N
            loadJQgridWithData("#NWMHostList", resp.result, colNamesList, colModelList, "", "#DevicePager", "NWMHostList", defaultOptions); //No I18N
        });
        return nwmListHosts;
    },
    listNWMAlerts: function()
    {
        var colNamesList = [Ember.I18n.t('opu.views.IP_ADDRESS',this), Ember.I18n.t('opu.views.DNS_NAME',this), Ember.I18n.t('opu.views.SEVERITY',this),Ember.I18n.t('opu.views.STATE_CHANGE_TIME',this), Ember.I18n.t('opu.views.RESPONSE_TIME',this), Ember.I18n.t('opu.views.THRESHOLD_TIME',this)]; //No I18N
        var colModelList = [{name: 'ipaddress-in-long', index: 'ipaddress-in-long',width:ipaddress_width,sortable: true,formatter:convertLongToIPAddress}, //No I18N
            {name: 'ip-to-dns', index: 'ip-to-dns',width:width100, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'severity', index: 'severity',width: width80, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'state-change-time', index: 'state-change-time',width: width100, sortable: true, sorttype: 'date'}, //No I18N
            {name: 'response-time', index: 'response-time', width: width100, sortable: true, sorttype: 'date'}, //No I18N
            {name: 'threshold', index: 'threshold', width: status_width, sortable: true, sorttype: 'text'} //No I18N
            
        ];
        var nwmHostUrl = getOpUtilsNWMAPIURL() + "&operation=GET_NWM_ALERTS";//NO I18N
        var defaultOptions = {"sortName": "ip-address", "sortOrder": "asc"};//No I18N
        $.getJSON(nwmHostUrl, function(resp) { //No I18N
            loadJQgridWithData("#NWMHostAlerts", resp.result, colNamesList, colModelList, "", "#DevicePager", "NWMHostAlerts", defaultOptions); //No I18N
        });
        return nwmListHosts;
    },
    getNWMDevicesCount: function()
    {
        $.ajax({		
                url: getOpUtilsNWMAPIURL() + "&operation=GET_NWM_HOST_COUNT",//NO I18N
                type: 'GET', //No I18N		
                dataType:'json', //No I18N
                async: false,//No I18N
                success: function(respose)		
                {
                    OpUtilsClient.NetworkMonitorController.devicesCount = respose.result.count[0].hostcount;
                    OpUtilsClient.NetworkMonitorController.alertsCount = respose.result.count[0].alertcount;
                }
            })
    },
    getNWMScanTime: function()
    {
        $.ajax({		
                url: getOpUtilsNWMAPIURL() + "&operation=GET_NWM_TIME_INTERVAL",//NO I18N
                type: 'GET', //No I18N		
                dataType:'json', //No I18N
                async: false,//No I18N
                success: function(respose)		
                {
                    OpUtilsClient.NetworkMonitorArrayController.set("scanPeriodLists",respose.result.timeMap);//No I18N
                }
            })
    },
    changeNWMScanTime: function(value)
    {
        OpUtilsAjaxPostMethod(getOpUtilsNWMAPIURL() + "&operation=NWM_CHANGE_INTERVAL&interval="+value);//No I18N

    }
});

function displayAddDeviceFields(addType)
{
	$("#addbyManualDiv").css('display','none');
	$("#addbyImportDiv").css('display','none');

	if(addType.id === "addbyManual")
	{
		$("#addbyManualDiv").css('display','block');
		$("#servername").focus();
	}
	else if(addType.id === "addbyImport" )
	{
		$("#addbyImportDiv").css('display','block');
	}

}

