
/* Reports Models */

OpUtilsClient.Reports = Ember.Object.extend({});
var ipamreports = OpUtilsClient.Reports.create();
var spmreports = OpUtilsClient.Reports.create();
OpUtilsClient.Reports.reopenClass({
    hideSecondTab: function()
    {
    },ipamReportsView: function(report,viewby,moreoptions){
        var urldetails = getIPAMReportDetails(report,viewby,moreoptions);

        $.getJSON(urldetails[0], function(resp) { //No I18N
            loadJQgridWithData("#IPAMReportsList", resp.result, urldetails[2], urldetails[3], "", "#DevicePager", "IPAMReportsList", urldetails[1]); //No I18N
        });

        return ipamreports;
        
    },listSubnetForFilter: function(view){
        var getsubnetURL ="";
        if(view === "UnUsed"){
            getsubnetURL = "&operation=GET_UNUSED_IP_SUBNET_LIST";//NO I18N
        }else if(view === "StaticIP"){//NO I18N
            getsubnetURL = "&operation=GET_RESERVED_IP_SUBNET_LIST";//NO I18N
        }else if(view === "UsageSummary"){//NO I18N
            getsubnetURL = "&operation=GET_UNUSED_IP_SUBNET_LIST";//NO I18N
        }
        $.ajax({		
                url: getOpUtilsAPIURL() + getsubnetURL,
                type: 'GET', //No I18N		
                dataType:'json', //No I18N
                async: false,//No I18N
                success: function(subnetsList)		
                {
                   var subnetArray1 = subnetsList.result.subnetArray;
                  var subnetArray = [];
                    for(i=0; i<subnetArray1.length; i++)
                    {
                        subnetArray.push({"subnet":subnetArray1[i]});
                    }
                    var jsonObj = {
                            "subnets": subnetArray, //No I18N
                    }
                    OpUtilsClient.ReportsArrayController.set("subnetLists", jsonObj); //No I18N
                }
            })
    },spmReportsView: function(report,viewby,moreoptions){
        var urldetails = getSPMReportDetails(report,viewby,moreoptions);

        $.getJSON(urldetails[0], function(resp) { //No I18N
            loadJQgridWithData("#SPMReportsList", resp.result, urldetails[2], urldetails[3], "", "#DevicePager", "SPMReportsList", urldetails[1]); //No I18N
        });

        return spmreports;

    }
});

function ipamReportView(byview){
    var selectedReport = OpUtilsClient.ReportsController.selectedReport;
    if(selectedReport === "UnUsed"){//NO I18N
        if(byview === "SubnetView"){//NO I18N
            location.href = window.apiclientUrl + "Reports/Reports.IPAM/UnUsedIPsViewBySubnet";//No I18N
        }else{
            location.href = window.apiclientUrl + "Reports/Reports.IPAM/UnUsedIPsViewByIP/All/All";//No I18N
        }
    }else if(selectedReport === "StaticIP"){//NO I18N
        if(byview === "SubnetView"){//NO I18N
            location.href = window.apiclientUrl + "Reports/Reports.IPAM/ReservedStaticIPBySubnet";//No I18N
        }else{
            location.href = window.apiclientUrl + "Reports/Reports.IPAM/ReservedStaticIPByIP/All/All";//No I18N
        }
    }else if(selectedReport === "UsageSummary"){//NO I18N
        if(byview === "SubnetView"){//NO I18N
            location.href = window.apiclientUrl + "Reports/Reports.IPAM/IPUsageSummay";//No I18N
        }else{
            location.href = window.apiclientUrl + "Reports/Reports.IPAM/IPUsageSummayByIP/All/All";//No I18N
        }
    }
}

function getIPAMReportDetails(report,viewby,morecriteria){
    var colNamesList="",colModelList="",defaultOptions="",url="";
    url = getOpUtilsAPIURL();
    if(report === "UnUsed" || report === "UsageSummary"){
        var isUnUsedIP = false;
        if(report === "UnUsed"){
            isUnUsedIP = true;
        }
        if(viewby === "SubnetView"){
            colNamesList = [Ember.I18n.t('opu.views.SUBNET_ADDRESS',this), Ember.I18n.t('opu.views.NAME',this),Ember.I18n.t('opu.views.SUBNET_MASK',this), Ember.I18n.t('opu.views.SIZE',this), Ember.I18n.t('opu.views.USED',this), Ember.I18n.t('opu.views.AVAILABLE',this), Ember.I18n.t('opu.views.TRANSIENT',this),  Ember.I18n.t('opu.views.LAST_SCAN_TIME',this)]; //No I18N
            colModelList = [
                {name: 'ipaddress-in-long', index: 'ipaddress-in-long', formatter: actionForSubnet1, classes: "pointer",sortable: true,sorttype:'text'}, //No I18N
                {name: 'subnet-name', index: 'subnet-name', width: width100,sortable: true,sorttype:'text'}, //No I18N
                {name: 'subnet-mask', index: 'subnet-mask', width: width100,sortable: true,sorttype:'int'}, //No I18N
                {name: 'subnet-size', index: 'subnet-size',width: width50,sortable: true,sorttype:'int'}, //No I18N 
                {name: 'usedCount', index: 'usedCount', width: width100, sortable: true, sorttype: 'int', hidden: isUnUsedIP,formatter:actionForUsedIPs}, //No I18N
                {name: 'availableCount', index: 'availableCount', width: width100, sortable: true, sorttype: 'int', hidden: false,formatter:actionForAvailableIPs}, //No I18N
                {name: 'transientCount', index: 'transientCount', width: width100, sortable: true, sorttype: 'int', hidden: false,formatter:actionForTransientIPs}, //No I18N
                {name: 'last-scan-time', index: 'last-scan-time', sortable: true}, //No I18N

            ];
            defaultOptions = {"sortName": "subnet-address", "sortOrder": "asc","multiselect": false};//No I18N
            url +="&operation=GET_ALL_SUBNETS_SUMMARY";//NO I18N
        }else{
            colNamesList = [Ember.I18n.t('opu.views.IP_ADDRESS',this), Ember.I18n.t('opu.views.DNS_NAME',this), Ember.I18n.t('opu.views.STATUS',this), Ember.I18n.t('opu.views.RESERVED_STATUS',this), Ember.I18n.t('opu.views.LAST_ALIVE_TIME',this), Ember.I18n.t('opu.views.LAST_UPDATED_TIME',this) ]; //No I18N
            colModelList = [{name: 'ipaddress-in-long', index: 'ipaddress-in-long',width:ipaddress_width,formatter:convertLongToIPAddress}, //No I18N
                {name: 'ip-to-dns', index: 'ip-to-dns', sortable: true, sorttype: 'text'}, //No I18N
                {name: 'status', index: 'status', width: status_width, sortable: true, sorttype: 'text'}, //No I18N
                {name: 'reserved-status', index: 'reserved-status', sortable: true, sorttype: 'text'}, //No I18N 
                {name: 'last-alive-time', index: 'last-alive-time', sortable: true, sorttype: 'date'}, //No I18N  
                {name: 'last-scan-time', index: 'last-scan-time', sortable: true, sorttype: 'date'}, //No I18N 
            ];
            defaultOptions = {"sortName": "ip-address", "sortOrder": "asc"};//No I18N
            url +="&operation=GET_UNUSED_IP";//NO I18N
        }
    }else if(report === "StaticIP"){//NO I18N
        if(viewby === "SubnetView"){
            colNamesList = [Ember.I18n.t('opu.views.SUBNET_ADDRESS',this), Ember.I18n.t('opu.views.NAME',this),Ember.I18n.t('opu.views.SUBNET_MASK',this), Ember.I18n.t('opu.views.SIZE',this), Ember.I18n.t('opu.views.USED',this), Ember.I18n.t('opu.views.AVAILABLE',this),  Ember.I18n.t('opu.views.TRANSIENT',this),Ember.I18n.t('opu.views.RESERVEDIP_COUNT',this)]; //No I18N
            colModelList = [
                {name: 'ipaddress-in-long', index: 'ipaddress-in-long', formatter: actionForSubnet1, classes: "pointer", sortable: true, sorttype: 'long',width: width100}, //No I18N
                {name: 'subnet-name', index: 'subnet-name', width: width100, sortable: true, sorttype: 'int'}, //No I18N
                {name: 'subnet-mask', index: 'subnet-mask', width: width100, sortable: true, sorttype: 'int'}, //No I18N
                {name: 'subnet-size', index: 'subnet-size',width: width50, sortable: true, sorttype: 'int'}, //No I18N 
                {name: 'reserved-used', index: 'reserved-used', width: width80, sortable: true, sorttype: 'int', hidden: false,formatter:actionForUsedIPs}, //No I18N
                {name: 'reserved-available', index: 'reserved-available', width: width80, sortable: true, sorttype: 'int', hidden: false,formatter:actionForAvailableIPs}, //No I18N
                {name: 'reserved-transient', index: 'reserved-transient', sortable: true, sorttype: 'int', width: width80,formatter:actionForTransientIPs}, //No I18N
                {name: 'reserved-count', index: 'reserved-count', sortable: true, sorttype: 'int'}, //No I18N

            ];
            defaultOptions = {"sortName": "subnet-address", "sortOrder": "asc","multiselect": false};//No I18N
            url +="&operation=GET_ALL_SUBNETS_SUMMARY";//NO I18N
        }else{
            colNamesList = [Ember.I18n.t('opu.views.IP_ADDRESS',this), Ember.I18n.t('opu.views.DNS_NAME',this), Ember.I18n.t('opu.views.STATUS',this), Ember.I18n.t('opu.views.RESERVED_STATUS',this), Ember.I18n.t('opu.views.LAST_ALIVE_TIME',this), Ember.I18n.t('opu.views.LAST_UPDATED_TIME',this) ]; //No I18N
            colModelList = [{name: 'ipaddress-in-long', index: 'ipaddress-in-long', formatter: actionForIPAddress,width:ipaddress_width, sortable: true, sorttype: 'long'}, //No I18N
                {name: 'ip-to-dns', index: 'ip-to-dns', sortable: true, sorttype: 'text'}, //No I18N
                {name: 'status', index: 'status', width: status_width, sortable: true, sorttype: 'text'}, //No I18N
                {name: 'reserved-status', index: 'reserved-status', sortable: true, sorttype: 'text'}, //No I18N 
                {name: 'last-alive-time', index: 'last-alive-time', sortable: true, sorttype: 'date'}, //No I18N  
                {name: 'last-scan-time', index: 'last-scan-time', sortable: true, sorttype: 'date'}, //No I18N 
            ];
            defaultOptions = {"sortName": "ip-address", "sortOrder": "asc"};//No I18N
            url +="&operation=GET_RESERVED_IP";//NO I18N
        }
    }
    if(morecriteria !== undefined || morecriteria === "")
    {
        url += morecriteria;
    }
    return [url,defaultOptions,colNamesList,colModelList]
}
function getSPMReportDetails(report,viewby,morecriteria){
    var colNamesList="",colModelList="",defaultOptions="",url="";
    url = getOpUtilsSPMAPIURL();
    
//    if(viewby === "SubnetView"){
            var colNamesList = [Ember.I18n.t('opu.views.SWITCH_NAME',this), Ember.I18n.t('opu.views.IP_ADDRESS',this), Ember.I18n.t('opu.views.DNS_NAME',this), Ember.I18n.t('opu.views.STATUS',this),Ember.I18n.t('opu.common.USAGE',this),Ember.I18n.t('opu.views.USED_PORTS',this),Ember.I18n.t('opu.views.AVAILABLE',this), Ember.I18n.t('opu.views.TRANSIENT',this), Ember.I18n.t('opu.views.TOTAL',this),  Ember.I18n.t('opu.views.SYS_NAME',this) ,Ember.I18n.t('opu.views.LAST_SCAN_TIME',this)]; //No I18N
            var colModelList = [
                {name: 'switch-name', index: 'switch-name',formatter: actionForSwitch,classes: "pointer",width:width100}, //No I18N
                {name: 'ipaddress-in-long', index: 'ipaddress-in-long', formatter: actionForIPAddress, width: width70, sortable: true, sorttype: 'long',hidden:true}, //No I18N
                {name: 'ip-to-dns', index: 'ip-to-dns',width: width80, sortable: true, sorttype: 'text'}, //No I18N
                {name: 'scan-status', index: 'scan-status',width: width50, sortable: true, sorttype: 'text',hidden:true}, //No I18N
                {name: 'port-usage', index: 'port-usage',width:width80, sortable: true, sorttype: 'int',formatter:addPercentageSymble}, //No I18N
                {name: 'used-count', index: 'used-count', width:width70, sortable: true, sorttype: 'int'}, //No I18N
                {name: 'available-count', index: 'available-count', width: width60, sortable: true, sorttype: 'int',hidden: false}, //No I18N
                {name: 'transient-count', index: 'transient-count', width: width60, sortable: true, sorttype: 'int', hidden: false}, //No I18N
                {name: 'total-count', index: 'total-count', width: width50, sortable: true, sorttype: 'int', hidden: false}, //No I18N
                {name: 'system-name', index: 'system-name',hidden:true, sortable: true, sorttype: 'text'}, //No I18N
                {name: 'last-scan-time', index: 'last-scan-time',hidden:true, sortable: true, sorttype: 'date'} //No I18N

            ];
            defaultOptions = {"sortName": "subnet-address", "sortOrder": "asc","multiselect": false};//No I18N
            url +="&operation=GET_ALL_SWITCHES_SUMMARY";//NO I18N
//    }
    if(morecriteria !== undefined || morecriteria === "")
    {
        url += morecriteria;
    }
    return [url,defaultOptions,colNamesList,colModelList]
}

function actionForSubnetReports(cellValue, options, rowdata, action)
{
	var ip = getIPAddressFrmLong(cellValue);
    if(OpUtilsClient.ReportsController.selectedReport === "UnUsed"){//NO I18N
        return "<a href='" +window.apiclientUrl+"Reports/Reports.IPAM/UnUsedIPsViewByIP/"+ip+"/All' >" + ip+"/"+getCIDRNotation(rowdata['subnet-size']) + "</a>"; //No I18N
    }else if(OpUtilsClient.ReportsController.selectedReport === "StaticIP"){//NO I18N
        return "<a href='" +window.apiclientUrl+"Reports/Reports.IPAM/ReservedStaticIPByIP/"+ip+"/All' >" + ip+"/"+getCIDRNotation(rowdata['subnet-size']) + "</a>"; //No I18N
    }else if(OpUtilsClient.ReportsController.selectedReport === "UsageSummary"){//NO I18N
        return "<a href='" +window.apiclientUrl+"Reports/Reports.IPAM/IPUsageSummayByIP/"+ip+"/All' >" + ip+"/"+getCIDRNotation(rowdata['subnet-size']) + "</a>"; //No I18N
    }
}
function actionForSubnetAvailability(cellValue,subnetStatus)
{
    if(OpUtilsClient.ReportsController.selectedReport === "UnUsed"){//NO I18N
        return "<a href='" +window.apiclientUrl+"Reports/Reports.IPAM/UnUsedIPsViewByIP/"+subnetStatus+"' >" + cellValue + "</a>"; //No I18N
    }else if(OpUtilsClient.ReportsController.selectedReport === "StaticIP"){//NO I18N
        return "<a href='" +window.apiclientUrl+"Reports/Reports.IPAM/ReservedStaticIPByIP/"+subnetStatus+"' >" + cellValue+ "</a>"; //No I18N
    }else if(OpUtilsClient.ReportsController.selectedReport === "UsageSummary"){//NO I18N
        return "<a href='" +window.apiclientUrl+"Reports/Reports.IPAM/IPUsageSummayByIP/"+subnetStatus+"' >" + cellValue+ "</a>"; //No I18N
    }
}
function actionForUsedIPs(cellValue, options, rowdata, action)
{
    return actionForSubnetAvailability(cellValue, rowdata['subnet-address']+"/Used");//NO I18N
}
function actionForAvailableIPs(cellValue, options, rowdata, action)
{
    return actionForSubnetAvailability(cellValue, rowdata['subnet-address']+"/Available");//NO I18N
}
function actionForTransientIPs(cellValue, options, rowdata, action)
{
    return actionForSubnetAvailability(cellValue, rowdata['subnet-address']+"/Transient");//NO I18N
}
function addCustomQueryReport()
{
     location.href = window.apiclientUrl + "Reports/AddCustomQuery";//No I18N
}
function addSchedulerReport()
{
     location.href = window.apiclientUrl + "Reports/AddSchedulerReport";//No I18N
}
function ShowHideScheduler(val){
    if(val === "Disabled"){
        $("#schedulePeriodPage").hide();
    }else{
        $("#schedulePeriodPage").show();
    }
}
function setCriteriaForIPAMReport(){
    var ipstatus = $("#IPStatus").val();
    var subnet = $("#SubnetAddr").val();
    var criteria = "";
    if(ipstatus !== "0"){
        criteria = "&status="+ipstatus;//NO I18N
    }
    if(subnet !== undefined && subnet !== "all"){
        criteria += "&subnetAddress="+subnet;//NO I18N
    }
    OpUtilsClient.Reports.ipamReportsView(OpUtilsClient.ReportsController.selectedReport,'IPsView',criteria);//NO I18N
}
function selectIPStatusFilter(){
    var status = OpUtilsClient.ReportsController.selectedIPStatus;
    if(status === "Used"){//NO I18N
        document.getElementById("IPStatus").value=1;
    }else if(status === "Available"){//NO I18N
        document.getElementById("IPStatus").value=3;
    }else if(status === "Transient"){//NO I18N
        document.getElementById("IPStatus").value=2;
    }
}
function getIPStatusScriteria(status){
    if(status === "Used"){//NO I18N
        return "&status=1";//NO I18N
    }else if(status === "Available"){//NO I18N
        return "&status=3";//NO I18N
    }else if(status === "Transient"){//NO I18N
        return "&status=2";//NO I18N
    }
    return "";
}
function getOputilsAvailableReport(){
    var settingsUrl = getOpUtilsReportsAPIURL()+"&operation=GET_ALL_REPORTS_LIST";//No I18N
    $.ajax(
    {
        url: settingsUrl,
        type: 'GET', //No I18N
        async :false,
        success: function(jsonData)
        {
            OpUtilsClient.ReportsArrayController.set("schedulerlists",jsonData.result);//NO I18N
        }
    });
}
function showHideOpUtilsSchedulerReports(report){
    $('#availableReport').empty();
    $('#selectedReport').empty();
    if(report === "Predefined"){
        var predefinedreports = OpUtilsClient.ReportsArrayController.schedulerlists.predefinedReport;
        var len = predefinedreports.length;
        for(i =0;i<len;i++) {
            $("#availableReport").append(new Option(predefinedreports[i]['reports-name'],predefinedreports[i]['reports-id']));//NO I18N
        }
        $("#showPreDefined").show();
        $("#showCustom").hide();
    }else{
        var customreports = OpUtilsClient.ReportsArrayController.schedulerlists.customReport;
        var len = customreports.length;
        for(i =0;i<len;i++) {
            $("#availableReport").append(new Option(customreports[i]['reports-name'],customreports[i]['reports-id']));//NO I18N
        }
        $("#showPreDefined").hide();
        $("#showCustom").show();
    }
}
function showAttachSizeBlock(val) {
    if(val == 'attachFile' || val == 'attachZip') {
        document.getElementById('showAtSizeBlock').style.display = 'block';//NO I18N
    } else {
        document.getElementById('showAtSizeBlock').style.display = 'none';//NO I18N
    }
}