
/* Rogue Models */

OpUtilsClient.ROGUE = Ember.Object.extend({});
var rogueTableView = OpUtilsClient.ROGUE.create();

OpUtilsClient.ROGUE.reopenClass({
    rogueTableView: function(rogueType){

        var colNamesList = [Ember.I18n.t('opu.views.MAC_ADDRESS',this), Ember.I18n.t('opu.views.IP_ADDRESS',this), Ember.I18n.t('opu.views.DNS_NAME',this),Ember.I18n.t('opu.views.DISCOVERED_AT',this), Ember.I18n.t('opu.views.TYPE',this), Ember.I18n.t('opu.views.CONNECTED_SWITCH',this), Ember.I18n.t('opu.views.CONNECTED_SWITCH_PORT',this),Ember.I18n.t('opu.views.IFINDEX',this),"ResourceID"]; //No I18N
        var colModelList = [{name: 'mac-address', index: 'mac-address',width:width100,sortable:true,sorttype:'text'}, //No I18N
            {name: 'ipaddress-in-long', index: 'ipaddress-in-long', width:ipaddress_width,formatter:convertLongToIPAddress,sortable:true,sorttype:'long'}, //No I18N
            {name: 'ip-to-dns', index: 'ip-to-dns',width:ipaddress_width,sortable:true,sorttype:'text'}, //No I18N
            {name: 'added-time', index: 'added-time', width: width100,sortable:true,sorttype:'date'}, //No I18N
            {name: 'nic-type', index: 'nic-type',sortable:true,sorttype:'text'}, //No I18N
            {name: 'connected-switch', index: 'connected-switch',sortable:true,sorttype:'text'}, //No I18N
            {name: 'connected-switch-port', index: 'connected-switch-port',sortable:true,sorttype:'int'}, //No I18N
            {name: 'connected-port-ifindex', index: 'connected-port-ifindex',hidden:true}, //No I18N
            {name: 'resource-id', index: 'resource-id',hidden:true}, //No I18N
        ];
        var rogueTitle= Ember.I18n.t('opu.common.DISCOVERED',this);//No I18N
        var rogueUrl = getOpUtilsRogueAPIURL();

    if(OpUtilsClient.RogueController.selectedSubnet !== undefined){
        rogueUrl = rogueUrl+"&subnetAddress="+OpUtilsClient.RogueController.selectedSubnet;//No I18N
    }
    if(OpUtilsClient.RogueController.rogueDiscoveredTime !==undefined && OpUtilsClient.RogueController.rogueDiscoveredTime !== "all" && OpUtilsClient.RogueController.rogueDiscoveredTimePriod !== undefined){
        rogueUrl = rogueUrl+"&deviceListType="+OpUtilsClient.RogueController.rogueDiscoveredTime+"&TimePeriod="+OpUtilsClient.RogueController.rogueDiscoveredTimePriod;//No I18N
    }
    
        if(rogueType === "Guest"){
            rogueTitle= Ember.I18n.t('opu.common.GUEST',this);//No I18N
            colNamesList = [Ember.I18n.t('opu.views.MAC_ADDRESS',this), Ember.I18n.t('opu.views.IP_ADDRESS',this), Ember.I18n.t('opu.views.DNS_NAME',this),Ember.I18n.t('opu.views.STATUS',this), Ember.I18n.t('opu.views.VALID_TILL',this), Ember.I18n.t('opu.views.ANNOTATION',this), Ember.I18n.t('opu.views.CONNECTED_SWITCH',this), Ember.I18n.t('opu.views.CONNECTED_SWITCH_PORT',this),Ember.I18n.t('opu.views.IFINDEX',this),"ResourceID"]; //No I18N
            colModelList = [{name: 'mac-address', index: 'mac-address',width:width120,sortable:true,sorttype:'text'}, //No I18N
            {name: 'ipaddress-in-long', index: 'ipaddress-in-long', width:ipaddress_width,sortable:true,sorttype:'text',formatter:convertLongToIPAddress}, //No I18N
            {name: 'ip-to-dns', index: 'ip-to-dns',width:ipaddress_width,sortable:true,sorttype:'text'}, //No I18N
            {name: 'status', index: 'status', width: width100,sortable:true,sorttype:'text'}, //No I18N
            {name: 'valid-time', index: 'valid-time',sortable:true,sorttype:'date'}, //No I18N
            {name: 'annotation', index: 'annotation',sortable:true,sorttype:'text'}, //No I18N
            {name: 'connected-switch', index: 'connected-switch',sortable:true,sorttype:'text'}, //No I18N
            {name: 'connected-switch-port', index: 'connected-switch-port',sortable:true,sorttype:'int'}, //No I18N
            {name: 'connected-port-ifindex', index: 'connected-port-ifindex',hidden:true}, //No I18N
            {name: 'resource-id', index: 'resource-id',hidden:true}, //No I18N
            ];
            rogueUrl  = rogueUrl + "&operation=GET_GUEST_DEVICES";//NO I18N
        }else if(rogueType === "Trusted" || rogueType === "Rogue"){//No I18N
            
            colNamesList = [Ember.I18n.t('opu.views.MAC_ADDRESS',this), Ember.I18n.t('opu.views.IP_ADDRESS',this), Ember.I18n.t('opu.views.DNS_NAME',this),Ember.I18n.t('opu.views.DISCOVERED_AT',this), Ember.I18n.t('opu.views.ADDED_ON',this), Ember.I18n.t('opu.views.TYPE',this), Ember.I18n.t('opu.views.CONNECTED_SWITCH',this), Ember.I18n.t('opu.views.CONNECTED_SWITCH_PORT',this),Ember.I18n.t('opu.views.IFINDEX',this),"ResourceID"]; //No I18N
            colModelList = [{name: 'mac-address', index: 'mac-address',width:width100,sortable:true,sorttype:'text'}, //No I18N
            {name: 'ipaddress-in-long', index: 'ipaddress-in-long', width:ipaddress_width,sortable:true,sorttype:'text',formatter:convertLongToIPAddress}, //No I18N
            {name: 'ip-to-dns', index: 'ip-to-dns',width:ipaddress_width,sortable:true,sorttype:'text'}, //No I18N
            {name: 'added-time', index: 'added-time', width: width100,sortable:true,sorttype:'date'}, //No I18N
            {name: 'managed-time', index: 'managed-time', width: width100,sortable:true,sorttype:'date'}, //No I18N
            {name: 'nic-type', index: 'nic-type',sortable:true,sorttype:'text'}, //No I18N
            {name: 'connected-switch', index: 'connected-switch',sortable:true,sorttype:'text'}, //No I18N
            {name: 'connected-switch-port', index: 'connected-switch-port',sortable:true,sorttype:'int'}, //No I18N
            {name: 'connected-port-ifindex', index: 'connected-port-ifindex',hidden:true}, //No I18N
            {name: 'resource-id', index: 'resource-id',hidden:true}, //No I18N
            ];
            if(rogueType === "Trusted"){
                rogueUrl  = rogueUrl + "&operation=GET_TRUSTED_DEVICES";//NO I18N
                rogueTitle= Ember.I18n.t('opu.common.TRUSTED',this);//No I18N
            }else{
                rogueUrl  = rogueUrl + "&operation=GET_ROGUE_DEVICES ";//NO I18N
                rogueTitle= Ember.I18n.t('opu.common.ROGUE',this);//No I18N
            }
        }
        else{
            rogueUrl  = rogueUrl + "&operation=GET_DISCOVERED_DEVICES";//NO I18N
        }
        var defaultOptions = {"sortName": "ip-address", "sortOrder": "asc","rowNumNeeded":true,"minRowsPerPage":100,"multiselect":true};//No I18N
        
        $.getJSON(rogueUrl, function(resp) { //No I18N
            loadJQgridWithData("#RogueTableView", resp.result, colNamesList, colModelList, "", "#DevicePager", "RogueTableView", defaultOptions); //No I18N
            //resetted the value
            OpUtilsClient.RogueController.selectedSubnet=undefined;
            OpUtilsClient.RogueController.rogueDiscoveredTime=undefined;
            OpUtilsClient.RogueController.rogueDiscoveredTimePriod=undefined;
        });

        var jsonObjRogueList = {"rogueCaption":rogueTitle}; //No I18N
        rogueTableView.setProperties(jsonObjRogueList);
        return rogueTableView;
    }
});

function rogueViewWithSubnet(subnet){
    OpUtilsClient.RogueController.selectedSubnet=subnet;
    OpUtilsClient.ROGUE.rogueTableView(OpUtilsClient.RogueController.rogueType);
}
function renderRogueDeviceListView(value,timepriod){
    OpUtilsClient.RogueController.rogueDiscoveredTime=value;
    OpUtilsClient.RogueController.rogueDiscoveredTimePriod=timepriod;
    OpUtilsClient.ROGUE.rogueTableView(OpUtilsClient.RogueController.rogueType);
}
function rogueActions(action,moreparams){
    var operationkey,selectedRows = "";
    
    
    var data = {"v":"1","format":"json"};//No I18N
    
    if(action === "MarkAsTrust"){
        operationkey = "MARK_AS_TRUSTED";//NO I18N
        if(!confirm(Ember.I18n.t("opu.views.DO_YOU_WANT_MARK_SYS_TRUSTED",this))){//NO I18N
            return false;
        }
    }else if(action === "MarkAsTrustAll"){//NO I18N
        if(!confirm(Ember.I18n.t("opu.views.DO_YOU_WANT_MARK_SYS_TRUSTED_ALL",this))){//NO I18N
            return false;
        }
        operationkey = "MARK_ALL_AS_TRUSTED";//NO I18N
    }
    else if(action === "MarkAsGuest"){
        data.validDate = moreparams.validtill;
        data.description = moreparams.desc;
        operationkey = "MARK_AS_GUEST";//NO I18N
    }
    else if(action === "Delete"){
        if(!confirm(Ember.I18n.t("opu.views.DO_YOU_WANT_DELETE_TO_DISCOVER_AGAIN",this))){//NO I18N
            return false;
        }
        operationkey = "DELETE_DISCOVERED_DEVICES";//NO I18N
    }
    else if(action === "MarkAsRogue"){
        if(!confirm(Ember.I18n.t("opu.views.DO_YOU_WANT_MARK_SYS_ROGUE",this))){//NO I18N
            return false;
        }
        operationkey = "MARK_AS_ROGUE";//NO I18N
    }
    else if(action === "DeleteAll"){
        if(!confirm(Ember.I18n.t("opu.views.DO_YOU_WANT_DELETE_TO_DISCOVER_AGAIN",this))){//NO I18N
            return false;
        }
        operationkey = "DELETE_DISCOVERED_DEVICES";//NO I18N
    }
    data.operation=operationkey;
    
    
    if(action !== "MarkAsTrustAll"){
        selectedRows = getEmberSelectedRows("RogueTableView","resource-id");//NO I18N
    }
    if(action === "MarkAsGuest"){
        data.ID=selectedRows;
    }else{
        data.RESOURCEID=selectedRows;
    }
    var url = '/oputilsapi/rogue?key='+getOpUtilsAPIKey();//No I18N
    
    $.ajax({
            url:url,
            type:'POST', //No I18N
            async:false,
            data:data,
            dataType:"json",//No I18N
            success: function(jsonData){
                if(jsonData.status === "Success"){
                    if(action === "MarkAsGuest"){
                        $('#MarkGuestPopUp').dialog("close")
                    }
                    location.reload();
                }else{
                    opu_showFailureResponseTextOnDiv(jsonData.message); //No I18N
                }
            }
    });
}

function openMarkAsGuestDialog()
{

        $('#MarkGuestPopUp').dialog({
        dialogClass: "no-close", //No I18N
         bgiframe: true,
         title:Ember.I18n.t('opu.common.CONFIGURE_GUEST_VALIDITY_PERIOD',this), //No I18N
         draggable: false,
         position: 'Center', //No I18N
         width:'500px', //No I18N
         closeOnEscape:'true', //No I18N
         modal:true,
        buttons: 
            {
            'Save':function(){ //No I18N
                var validtill = $("#validtill").val();
                if(validtill === "" || validtill === undefined){
                    alert(Ember.I18n.t("opu.common.ENTER_VALID_DATE",this));//NO I18N
                    return false;
                }
                var desc = $("#desc").val();
                rogueActions("MarkAsGuest",{"validtill":validtill,"desc":desc})//NO I18N
            },
            'Cancel':function() { //No I18N
                $( this ).dialog( "close" ); //No I18N
            }
       }
    });
           
}
function openBlockUnBlockPortDialog()
{
        var selRowIds = $("#RogueTableView").jqGrid('getGridParam','selarrrow');	//No I18N
        if(selRowIds.length === 0){
            opu_showFailureResponseTextOnDiv(getI18NwithParams("opu.common.select_atleast_one_row",[Ember.I18n.t("opu.views.BLOCK_UNBLOCK_SWITCH_PORT",this)])); //No I18N
            return false;
        }else if(selRowIds.length > 1){
            opu_showFailureResponseTextOnDiv(Ember.I18n.t("opu.rogue.MultiplePortsNotBlockedSimultaneous",this)); //No I18N
            return false;
        }
         var rowData = jQuery("#RogueTableView").getRowData(selRowIds);//NO I18N

        var switchname = rowData["connected-switch"];//NO I18N
        var ifindex = rowData["connected-port-ifindex"];//NO I18N
        var macaddress = rowData["mac-address"];//NO I18N
        $("#macaddress").html(macaddress);
        $("#ipaddresss").html(rowData["ip-address"]);//NO I18N
        $("#dnsname").html(rowData["ip-to-dns"]);//NO I18N
        if(switchname !== "" && switchname !== undefined){
            $("#switchname").val(switchname);
            $("#switchname").prop("disabled","disabled");
            $("#IFINDEX").val(ifindex);
            $("#IFINDEX").prop("disabled","disabled");
        }else{
            $("#switchname").val("");
            $("#switchname").prop("disabled",false);
            $("#IFINDEX").val("");
            $("#IFINDEX").prop("disabled",false);
            $("#NoneSwitchDetails").css("display","block");
        }
        
        $('#BlockUnBlockPort').dialog({
        dialogClass: "no-close", //No I18N
         bgiframe: true,
         title:Ember.I18n.t('opu.views.BLOCK_UNBLOCK_SWITCH_PORT',this), //No I18N
         draggable: false,
         position: 'Center', //No I18N
         width:'500px', //No I18N
         closeOnEscape:'true', //No I18N
         modal:true,
        buttons: 
        {
            'blockport':function(){ //No I18N
                if(confirm(Ember.I18n.t("opu.spm.CONFORMATION_TO_BLOCK_PORT",this))){//No I18N

                    BlockUnBlockSwitchPort("BLOCK_SWITCH_PORT",macaddress,Ember.I18n.t("opu.spm.BLOCKING_THE_PORT_PLEASE_WAIT",this));//No I18N
                }
            },
            'unblockport':function(){ //No I18N
                if(confirm(Ember.I18n.t("opu.spm.CONFORMATION_TO_UNBLOCK_PORT",this))){//No I18N
                    BlockUnBlockSwitchPort("UNBLOCK_SWITCH_PORT",macaddress,Ember.I18n.t("opu.spm.UNBLOCKING_THE_PORT_PLEASE_WAIT",this));//No I18N
                }
            },
            'Cancel':function() { //No I18N
                $( this ).dialog( "close" ); //No I18N
            }
       }
       
    });
    //changing popup button text..
    $('.ui-dialog-buttonpane button:contains(blockport)').attr("id", "BlockUnBlockPort_blockport-button");//NO I18N
    $('#BlockUnBlockPort_blockport-button').html("<span class='ui-button-text'>"+Ember.I18n.t("opu.spm.BLOCK_PORT",this)+"</span> ");//NO I18N
    $('.ui-dialog-buttonpane button:contains(unblockport)').attr("id", "BlockUnBlockPort_unblockport-button");//NO I18N
    $('#BlockUnBlockPort_unblockport-button').html("<span class='ui-button-text'>"+Ember.I18n.t("opu.spm.UNBLOCK_PORT",this)+"</span> ");//NO I18N
    $('.ui-dialog-buttonpane button:contains(Cancel)').attr("id", "BlockUnBlockPort_Cancel-button");//NO I18N
    $('#BlockUnBlockPort_Cancel-button').html("<span class='ui-button-text'>"+Ember.I18n.t("opu.common.CANCEL",this)+"</span> ");//NO I18N

}

function BlockUnBlockSwitchPort(operation,macaddress,loadingtext)
{
    var data = {"v":"1","format":"json","operation":operation,"macAddress":macaddress};//No I18N
    var switchname = $("#switchname").val();
    var ifindex = $("#IFINDEX").val();
    var writecommunity = $("#writecommunity").val();
    var snmpv3 = $("#snmpv3").css("display");
    if (switchname === undefined || switchname === "") {
        alert(Ember.I18n.t('opu.spm.SWITCH_NAME_CANNOT_BE_EMPTY', this));//No I18N
        $("#switchname").focus();
        return;
    }
    if(isSpecialCharacter(switchname))
    {
        alert(Ember.I18n.t('opu.common.PLEASE_ENTER_HOSTNAME_WITHOUT_SPL_CHARS',this));//No I18N
        $("#switchname").focus();
        return;
    }
    if (ifindex === undefined || ifindex === "" || !isNumber(ifindex)) 
    {
        alert(Ember.I18n.t('opu.spm.EnterValidIfIndex',this));//No I18N
        $("#IFINDEX").focus();
        return;
    }
    data.switchName=switchname;
    data.ifIndex=ifindex;
    if (snmpv3 === "block") 
    {
        data.setSnmpVersionID=1;
        var v3username = trimAll($('#v3username').val());
        var v3contextname = trimAll($('#v3contextname').val());
        var authprotocol = $('#authprotocol').val();
        var authpwd = trimAll($('#authpwd').val());
        var encrprotocol = $('#privprotocol').val();
        var encrpwd = trimAll($('#privpwd').val());

        if (v3username === undefined || v3username ==="") {
            alert(Ember.I18n.t('opu.common.PLEASE_ENTER_THE_USER_NAME', this));//No I18N
            $("#v3username").focus();
            return;
        }
        data.username=v3username;
        if (v3contextname !== undefined && v3contextname !=="") {
            data.coname=v3contextname;
        }
        if (authprotocol !== "None" && (authpwd === undefined || authpwd ==="")) {
            alert(Ember.I18n.t('opu.common.PLEASE_ENTER_THE_PASSWORD', this));//No I18N
            $("#authpwd").focus();
            return;
        }
        if (authprotocol !== "None" && (authpwd !== undefined && authpwd !=="")) {
            data.authID=authprotocol;
            data.authPassID=authpwd;
        }
        if (authprotocol !== "None" && authpwd !== undefined && encrprotocol !== "None") {

            if (encrpwd === undefined || encrpwd === "") {
                alert(Ember.I18n.t('opu.common.PLEASE_ENTER_THE_PASSWORD', this));//No I18N
                $("#privpwd").focus();
                return;
            }
            if (encrpwd !== undefined && encrpwd !== "") {
                data.privID=encrprotocol;
                data.privPassID=encrpwd;
            }
        }    
    }else{

        if (writecommunity === undefined || writecommunity === "") {
            alert(Ember.I18n.t('opu.spm.PLEASE_ENTER_WRITE_COMMUNITY', this));//No I18N
            $("#writecommunity").focus();
            return;
        }                     
        data.writeCommunity=writecommunity;
        data.setSnmpVersionID=0;
    }

    opu_showSuccessResponseTextOnDiv1(loadingtext,"blockUnblockPortResDiv");//NO I18N
var url = '/oputilsapi/rogue?key='+getOpUtilsAPIKey();//No I18N
    $.ajax({
    url:url,
    type:'POST', //No I18N
    async:false,
    data:data,
    dataType:"json",//No I18N
    success: function(jsonData){
        if(jsonData.status === "Success"){
            $("BlockUnBlockPort").dialog( "close" ); //No I18N
            location.reload();
        }else{
            opu_showFailureResponseTextOnDiv1(jsonData.message,"blockUnblockPortResDiv"); //No I18N
        }
    }
});
}

