
/* IPAM Models */

OpUtilsClient.SPM = Ember.Object.extend({});
var spmTreeGroups = OpUtilsClient.SPM.create();
var switchsummryview = OpUtilsClient.SPM.create();
var switchlistview = OpUtilsClient.SPM.create();
var switchhistoryview = OpUtilsClient.SPM.create();
var switchalertview = OpUtilsClient.SPM.create();
OpUtilsClient.SPM.reopenClass({
    spmGroupView: function()
    {
        $.ajax({		
                url: getOpUtilsSPMAPIURL() + "&operation=GET_SPM_GROUPS",//NO I18N
                type: 'GET', //No I18N		
                dataType:'json', //No I18N
                async: false,//No I18N
                success: function(spmGroups)		
                {
                   var menuLinkArray = spmGroups.result.spmNodes;
                   var totalswitchCount = menuLinkArray[0].SwitchCount;//Total Subneta count
                    var allSwitchGPCaption = Ember.I18n.t("opu.views.ALL_SWITCHES",this)+"("+totalswitchCount+")";//NO I18N
                    var allPortsCount = menuLinkArray[1].totalPorts;
                    var allAlertsCount = menuLinkArray[2].totalAlerts;
                    OpUtilsClient.SPMController.allAlertsCount = allAlertsCount;
                    OpUtilsClient.SPMController.allPortsCount = allPortsCount;
                    var allPortsGPCaption = Ember.I18n.t("opu.views.ALL_PORTS",this)+"("+allPortsCount+")";//NO I18N
                    var spmTreeGroupJsonObj = {"groups":{'AllSwitches':allSwitchGPCaption,'AllPorts':allPortsGPCaption,'AllAlerts':allAlertsCount}};//No I18N
                    menuLinkArray.splice(0,4);//removed "Total Switches" , "AllPorts" and "Discovered Switches" group from Array..
        
                    for(i=0; i<menuLinkArray.length; i++)
                    {
                        menuLinkArray[i].url=window.apiclientUrl+ "SPM/Group/"+menuLinkArray[i]["group-id"];//No I18N    
                        spmTreeGroupJsonObj.groups[menuLinkArray[i]["group-id"]] = menuLinkArray[i]["group-name"]+"("+menuLinkArray[i].SwitchCount+")";//No I18N
                    }
                    var jsonObj = {
                            "menuLinks": menuLinkArray, //No I18N
                            "TotalSwitch": totalswitchCount, //No I18N
                            "AllPorts": allPortsCount, //No I18N
                        }
                    spmTreeGroups.setProperties(jsonObj);                    
                    OpUtilsClient.SPMArrayController.set("spmGroupCapationObjects", OpUtilsClient.SPM.create().setProperties(spmTreeGroupJsonObj)); //No I18N
                }
            })
        return spmTreeGroups;
    },
    spmSwitchesView: function(groupid) {
        
        var colNamesList = [Ember.I18n.t('opu.views.SWITCH_NAME',this), Ember.I18n.t('opu.views.IP_ADDRESS',this), Ember.I18n.t('opu.views.DNS_NAME',this), Ember.I18n.t('opu.views.STATUS',this),Ember.I18n.t('opu.common.USAGE',this),Ember.I18n.t('opu.views.USED_PORTS',this),Ember.I18n.t('opu.views.AVAILABLE',this), Ember.I18n.t('opu.views.TRANSIENT',this), Ember.I18n.t('opu.views.TOTAL',this),  Ember.I18n.t('opu.views.SYS_NAME',this) ,Ember.I18n.t('opu.views.LAST_SCAN_TIME',this),Ember.I18n.t('opu.views.ACTIONS',this),'switchid']; //No I18N
        var colModelList = [
            {name: 'switch-name', index: 'switch-name',formatter: actionForSwitch,classes: "pointer",width:width120, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'ipaddress-in-long', index: 'ipaddress-in-long', width: width70, sortable: true, sorttype: 'text',hidden:true,formatter:convertLongToIPAddress}, //No I18N
            {name: 'ip-to-dns', index: 'ip-to-dns',width: width120, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'scan-status', index: 'scan-status',width: width50, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'usedPercentage', index: 'usedPercentage', formatter: subnetUsageImg,width:width100, sortable: true, sorttype: 'int'}, //No I18N
            {name: 'used-count', index: 'used-count', width:width70,sortable: true, sorttype: 'int'}, //No I18N
            {name: 'available-count', index: 'available-count', width: width60, sortable: true, sorttype: 'int',hidden: false}, //No I18N
            {name: 'transient-count', index: 'transient-count', width: width60, sortable: true, sorttype: 'int', hidden: false}, //No I18N
            {name: 'total-count', index: 'total-count', width: width50, sortable: true, sorttype: 'int', hidden: false}, //No I18N
            {name: 'system-name', index: 'system-name', sortable: true, sorttype: 'text'}, //No I18N
            {name: 'last-scan-time', index: 'last-scan-time',hidden:true, sortable: true, sorttype: 'date'}, //No I18N
            {name: 'Action', index: 'Action',formatter:spmSwitchEditAndDelete,width:width50,search:false,hidden:!(OpUtilsClient.ApplicationController.isAdminRole)}, //No I18N
            {name: 'config-id', index: 'config-id',hidden:true,} //No I18N

        ];
        setSPMSelectedGroup(groupid);
        var summaryAPIUrl = getOpUtilsSPMAPIURL() + "&operation=GET_ALL_SWITCHES_SUMMARY";//NO I18N
        
        if(groupid !== undefined && groupid !== "AllSwitches"){//NO I18N
            OpUtilsClient.IPAMController.selectedSPMGroupID=groupid
            summaryAPIUrl = summaryAPIUrl+"&groupId="+groupid;//NO I18N
        }
        var defaultOptions = {"sortName": "switch-name", "sortOrder": "asc","multiselect": true,"searchOption":true};//No I18N
        $.getJSON(summaryAPIUrl, function(resp) { //No I18N
            loadJQgridWithData("#spmSwitchesList", resp.result, colNamesList, colModelList, "", "#DevicePager", "spmSwitchesList", defaultOptions); //No I18N

        });
        return switchsummryview;
    },
    spmSwitchPortsView: function(switchname) {
        var isSwitchPort = true;
        var allportAPIUrl = getOpUtilsSPMAPIURL();
        if(switchname !== undefined){
            getSwitchTabLinks("Ports",switchname);//No I18N
            isSwitchPort = true;
            allportAPIUrl += "&operation=GET_PORT_DETAILS&switchIP="+switchname;//No I18N
        }else{
            isSwitchPort = false;
            allportAPIUrl += "&operation=GET_ALL_PORT_DETAILS";//No I18N
        }
        var colNamesList = [Ember.I18n.t('opu.views.SWITCH_NAME',this),Ember.I18n.t('opu.views.IFINDEX',this), Ember.I18n.t('opu.views.IFNAME',this),Ember.I18n.t('opu.views.PORT',this),Ember.I18n.t('opu.views.AVAILABILITY',this), Ember.I18n.t('opu.views.STATUS',this),Ember.I18n.t('opu.views.MAC_ADDRESS',this),Ember.I18n.t('opu.views.IP_ADDRESS',this), Ember.I18n.t('opu.views.DNS_NAME',this),Ember.I18n.t('opu.views.VLANID',this),Ember.I18n.t('opu.views.VLAN_NAME',this), Ember.I18n.t('opu.views.ADMIN_STATUS',this), Ember.I18n.t('opu.views.IF_SPEED',this),  Ember.I18n.t('opu.common.IF_ALIAS',this) ,Ember.I18n.t('opu.views.LAST_CHANGE_TIME',this)]; //No I18N
        var colModelList = [
            {name: 'switch-name', index: 'switch-name',formatter: actionForSwitch,classes: "pointer",width:width100, sortable: true, sorttype: 'text',hidden: isSwitchPort,fixed:true}, //No I18N
            {name: 'connected-port-ifindex', index: 'connected-port-ifindex', formatter:actionForSwitchPort,width: width50,sortable: true,fixed:true,sorttype: 'int'}, //No I18N
            {name: 'connected-port-ifname', index: 'connected-port-ifname',width: width70, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'connected-switch-port', index: 'connected-switch-port',formatter:actionForSwitchPort,width: width40,sortable: true,fixed:true,sorttype: 'int'}, //No I18N
            {name: 'scan-status', index: 'scan-status',width:width100, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'operational-status', index: 'operational-status', width:width50, sortable: true, sorttype: 'text',fixed:true}, //No I18N
            {name: 'connected-mac', index: 'connected-mac', width: width110, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'connected-ip', index: 'connected-ip', width: width100, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'connected-dns', index: 'connected-dns', width: width100, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'vlan', index: 'vlan',width: width80, sortable: true, sorttype: 'int'}, //No I18N
            {name: 'vlan-name', index: 'vlan-name',hidden:false,width: width100,fixed:true, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'admin-status', index: 'admin-status',hidden:false,width: width100, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'connected-port-speed', index: 'connected-port-speed',hidden:false,width:width70, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'connected-port-ifalias', index: 'connected-port-ifalias',hidden:true, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'status-change-time', index: 'status-change-time',hidden:true, sortable: true, sorttype: 'text'}, //No I18N

        ];
        var defaultOptions = {"sortName": "switch-name", "sortOrder": "asc","multiselect": isSwitchPort,"searchOption":true};//No I18N
        $.getJSON(allportAPIUrl, function(resp) { //No I18N
            loadJQgridWithData("#spmSwitchesPortList", resp.result, colNamesList, colModelList, "", "#DevicePager", "spmSwitchesPortList", defaultOptions); //No I18N

        });
        return switchsummryview;
    },
    SwitchDetailsSummary: function(switchname)
    {
        getSwitchTabLinks("Summary",switchname);//No I18N
        $.ajax({		
                url: getOpUtilsSPMAPIURL() + "&operation=GET_SWITCH_SUMMARY&switchIP="+switchname,//NO I18N
                type: 'GET', //No I18N		
                dataType:'json', //No I18N
                async: false,//No I18N
                success: function(switchsummary)
                {
                    OpUtilsClient.SPMArrayController.set("switchSummaryObj", switchsummary); //No I18N
                }
        })
        return switchsummryview;
    },
    SwitchDetailsAlerts: function(switchname,ifindexnumber)
    {
        var alertURL = getOpUtilsSPMAPIURL();
        var hideswitchCol = true;
        if(switchname !== undefined){
            alertURL += "&operation=GET_SPM_ALERTS&switchIP="+switchname;//No I18N
            hideswitchCol = true;
        }else{
            alertURL += "&operation=GET_ALL_SPM_ALERTS";//No I18N
            hideswitchCol = false;
        }
        if(ifindexnumber !== undefined){
            alertURL += "&switchifIndex="+ifindexnumber;//No I18N
        }
        
        if(switchname !== undefined && ifindexnumber !== undefined){
            getSwitchPortTabLinks("Alerts",switchname,ifindexnumber);//No I18N
        }else if(switchname !== undefined){
             getSwitchTabLinks("Alerts",switchname);//No I18N
        }
        var colNamesList = [Ember.I18n.t('opu.views.SWITCH_NAME',this), Ember.I18n.t('opu.views.IP_ADDRESS',this), Ember.I18n.t('opu.views.IFINDEX',this), Ember.I18n.t('opu.views.ALERT_GENERATED_TIME',this),Ember.I18n.t('opu.views.DESCRIPTION',this)]; //No I18N
        var colModelList = [
            {name: 'switch-name', index: 'switch-name',formatter: actionForSwitch,classes: "pointer",width:width80, sortable: true, sorttype: 'text',hidden:hideswitchCol}, //No I18N
            {name: 'ip-address', index: 'ip-address', width: width70, sortable: true, sorttype: 'text',hidden:false}, //No I18N
            {name: 'connected-port-ifindex', index: 'connected-port-ifindex', width: width40, sortable: true, sorttype: 'int'}, //No I18N
            {name: 'generated-time', index: 'generated-time', width: width80, sortable: true, sorttype: 'date'}, //No I18N
            {name: 'description', index: 'description', sortable: true, sorttype: 'text'}, //No I18N
        ];
        var defaultOptions = {"sortName": "switch-name", "sortOrder": "asc","multiselect": false};//No I18N
        $.getJSON(alertURL, function(resp) { //No I18N
            loadJQgridWithData("#spmSwitchesAlerts", resp.result, colNamesList, colModelList, "", "#DevicePager", "spmSwitchesAlerts", defaultOptions); //No I18N
        });
        
        return switchalertview;
    },
    SwitchDetailsHistory: function(switchname,ifindexnumber)
    {
        var spmporthistoryURL = getOpUtilsSPMAPIURL()+"&operation=GET_PORT_HISTORY&switchIP="+switchname;//No I18N
        if(ifindexnumber !== undefined ){
//            spmporthistoryURL += "&switchifIndex="+ifindexnumber;//No I18N
            getSwitchPortTabLinks("History",switchname,ifindexnumber);//No I18N
        }else{
            getSwitchTabLinks("History",switchname);//No I18N
        }
       var colNamesList = [Ember.I18n.t('opu.views.SWITCH_NAME',this),Ember.I18n.t('opu.views.IFINDEX',this), Ember.I18n.t('opu.views.IFNAME',this),Ember.I18n.t('opu.views.PORT',this),Ember.I18n.t('opu.views.DETECTED_TIME',this), Ember.I18n.t('opu.views.IP_ADDRESS',this),Ember.I18n.t('opu.views.MAC_ADDRESS',this),Ember.I18n.t('opu.views.DNS_NAME',this),Ember.I18n.t('opu.views.DETAILS_OF_CHANGES',this)]; //No I18N
        var colModelList = [
            {name: 'switch-name', index: 'switch-name',formatter: actionForSwitch,classes: "pointer",width:width100, sortable: true, sorttype: 'text',hidden: true}, //No I18N
            {name: 'connected-port-ifindex', index: 'connected-port-ifindex', width: width50, sortable: true, sorttype: 'int'}, //No I18N
            {name: 'connected-port-ifname', index: 'connected-port-ifname',width: width80, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'connected-switch-port', index: 'connected-switch-port',width: width50, sortable: true, sorttype: 'int'}, //No I18N
            {name: 'detected-time', index: 'detected-time',width:width80, sortable: true, sorttype: 'date'}, //No I18N
            {name: 'connected-ip', index: 'connected-ip', width:width80, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'connected-mac', index: 'connected-mac', width: width80, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'connected-dns', index: 'connected-dns', width: width80, sortable: true, sorttype: 'text'}, //No I18N
            {name: 'description', index: 'description', sortable: true, sorttype: 'text'}, //No I18N
        ];
        var defaultOptions = {"sortName": "switch-name", "sortOrder": "asc","multiselect": false};//No I18N
        $.getJSON(spmporthistoryURL, function(resp) { //No I18N
            loadJQgridWithData("#spmSwitchesHistory", resp.result, colNamesList, colModelList, "", "#DevicePager", "spmSwitchesHistory", defaultOptions); //No I18N

        });
        return switchhistoryview;
    },SwitchPortDetailsSummary: function(switchname,ifindexNo)
    {
        getSwitchPortTabLinks("Summary",switchname,ifindexNo);//No I18N
        $.ajax({		
                url: getOpUtilsSPMAPIURL() + "&operation=GET_PORT_DETAILS&switchIP="+switchname+"&switchifIndex="+ifindexNo,//NO I18N
                type: 'GET', //No I18N		
                dataType:'json', //No I18N
                async: false,//No I18N
                success: function(switchportsummary)
                {
                    OpUtilsClient.SPMArrayController.set("switchPortSummaryObj", {'result':switchportsummary.result[0]}); //No I18N
                }
        })
        return switchsummryview;
    },
});

function ShowOrHideSNMPVs(snmpversion){
    if(snmpversion === "v3"){
        $("#snmpv3").show();
        $("#snmpv1v2").hide();
    }else{
        $("#snmpv3").hide();
        $("#snmpv1v2").show();
    }
    
}

function setSPMSelectedGroup(groupid,switchname)
{
    if(groupid === null){
        groupid = "AllSwitches";//No I18N
    }
    OpUtilsClient.SPMController.selectedSPMGroupName=OpUtilsClient.SPMArrayController.spmGroupCapationObjects.groups[groupid];
    OpUtilsClient.SPMController.selectedSPMGroupURL=window.apiclientUrl+"SPM/Group/"+groupid;//No I18N
    if(switchname !== undefined){
        OpUtilsClient.SPMController.selectedSPMSwitchURL=window.apiclientUrl+"SPM/Switch/"+groupid+"/"+switchname+"/Summary";//No I18N
    }
}
function getSwitchTabLinks(selectedTab,switchname)
{
    var sumSelected = false;
    var alertSelected = false;
    var historySelected = false;
    var ports = false;

    if (selectedTab === "Summary") {
        sumSelected = true;
    }
    if (selectedTab === "Alerts") {
        alertSelected = true;
    }
    if (selectedTab === "History") {
        historySelected = true;
    }
    if (selectedTab === "Ports") {
        ports = true;
    }
    var baseurl = getSPMBaseURL()+"Switch/" +OpUtilsClient.SPMController.selectedSPMGroupID+"/"+ switchname+"/";//No I18N
    var menuLinkArray = [
        {"Name": Ember.I18n.t('opu.views.SUMMARY',this), "url": baseurl + "Summary", "title": Ember.I18n.t('opu.views.SUMMARY',this), "isSelected": sumSelected}, //No I18N
        {"Name": Ember.I18n.t('opu.spm.Ports',this), "url": baseurl + "Ports", "title": Ember.I18n.t('opu.spm.Ports',this), "isSelected": ports}, //No I18N
        {"Name": Ember.I18n.t('opu.views.HISTORY', this), "url": baseurl + "History", "title": Ember.I18n.t('opu.views.HISTORY', this), "isSelected": historySelected}, //No I18N
        {"Name": Ember.I18n.t('opu.common.ALERTS', this), "url": baseurl + "Alerts", "title": Ember.I18n.t('opu.common.ALERTS', this), "isSelected": alertSelected}, //No I18N
    ];
    var jsonObj = {
        "menuLinks": menuLinkArray //No I18N
    }
    OpUtilsClient.SPMArrayController.set("spmSwitchMenuLinks", jsonObj); //No I18N
}
function getSwitchPortTabLinks(selectedTab,switchname,ifindexNo)
{
    var sumSelected = false;
    var alertSelected = false;
    var historySelected = false;

    if (selectedTab === "Summary") {
        sumSelected = true;
    }
    if (selectedTab === "Alerts") {
        alertSelected = true;
    }
    if (selectedTab === "History") {
        historySelected = true;
    }
    var baseurl = getSPMBaseURL()+"Port/" +OpUtilsClient.SPMController.selectedSPMGroupID+"/"+ switchname+"/"+ifindexNo+"/";//No I18N
    var menuLinkArray = [
        {"Name": Ember.I18n.t('opu.views.SUMMARY',this), "url": baseurl + "Summary", "title": Ember.I18n.t('opu.views.SUMMARY',this), "isSelected": sumSelected}, //No I18N
        {"Name": Ember.I18n.t('opu.views.HISTORY', this), "url": baseurl + "History", "title": Ember.I18n.t('opu.views.HISTORY', this), "isSelected": historySelected}, //No I18N
        {"Name": Ember.I18n.t('opu.common.ALERTS', this), "url": baseurl + "Alerts", "title": Ember.I18n.t('opu.common.ALERTS', this), "isSelected": alertSelected}, //No I18N
    ];
    var jsonObj = {
        "menuLinks": menuLinkArray //No I18N
    }
    OpUtilsClient.SPMArrayController.set("spmSwitchPortMenuLinks", jsonObj); //No I18N
}

function actionForSwitch(cellValue, options, rowdata, action)
{
    return "<a href='" +getSPMBaseURL()+"Switch/" +OpUtilsClient.SPMController.selectedSPMGroupID+"/"+ cellValue + "/Summary' >" + cellValue+ "</a>"; //No I18N
}
function actionForSwitchPort(cellValue, options, rowdata, action)
{
    var ifIndexNo = rowdata['connected-port-ifindex'];//No I18N
    var switchname = OpUtilsClient.SPMController.selectedSwitch;
    var groupname = OpUtilsClient.SPMController.selectedSPMGroupID;
    if(OpUtilsClient.SPMController.isSPMAllPorts){
        switchname = rowdata['switch-name'];//No I18N
        groupname = "AllSwitches";//No I18N
    }
    return "<a href='" +getSPMBaseURL()+"Port/" +groupname+"/"+switchname+"/"+ ifIndexNo  + "/Summary' >" + cellValue+ "</a>"; //No I18N
}


function getSPMBaseURL(){
    return window.apiclientUrl + "SPM/";//No I18N
}

var addswitchlatestId = 0;
var addswitchtot = 0;

var addswitchgip ='0.0.0.0';//No I18N
var addswitchflag = false;
var addswitchmyArray = new Array();
var addswitchlen = addswitchmyArray.length-1;
function assignVal(ip){
    addswitchgip = ip.value;
    addswitchmyArray[addswitchtot] = addswitchgip;
    addswitchlen = addswitchmyArray.length-1;
}
function assignValue(ip,mask){
    assignVal(ip);  
    if(!isValidIPAddress(ip.value)){
        return;
    }
    nwClass = computeNetworkClass(ip.value);
    if(nwClass == "D" || nwClass == "E" || nwClass == 'None'){
        return;
    }
}   
function validateSweepInput(ip){
    var input = trimAll(ip);

    if(addswitchflag){return true;}
    if(input.length == 0){
        alert(Ember.I18n.t('opu.common.EnterValidIP',this));//No I18N
        return false;
    }
    if(!isValidIPAddress(input)){
        alert(Ember.I18n.t('opu.common.EnterValidIP',this));//No I18N
        return false;
    }
    nwClass = computeNetworkClass(input);

    if(nwClass == 'None'){
        alert(Ember.I18n.t('opu.common.EnterValidIP',this));//No I18N
        return false;
    }
    return true;
}
function addOption(sel, val, txt) {
    var o = document.createElement("OPTION");//No I18N
    var t = document.createTextNode(txt);
    o.setAttribute("value",val);
    o.appendChild(t);
    sel.appendChild(o);
}   
function removeDuplicate(){
     for(i=0;i<addswitchlen;i++){
        if(addswitchmyArray[i] == addswitchgip){
            alert(Ember.I18n.t('opu.common.SUBNET_ALREADY_ADDED',this));//No I18N
            return false;
        }
    }
    return true;
}
function addItem(){
    addswitchtot++; 
    appendElement("container", "element" + addswitchlatestId, addswitchlatestId,"<a href=\"javascript:removeItem(" + addswitchlatestId + ")\" class=\"linkTxt\"><img src=\"/images/delete_tool.png\"></a>"); //No I18n
    addswitchlatestId++;
}
function addNewItem1(subnetaddr){
    addswitchgip=subnetaddr;
    addNewItem();
}
function addNewItem(){
  var proceed = false;
  var check = true
  
  if(addswitchtot > 0 && check){
        if(removeDuplicate()){
        proceed = validateSweepInput(addswitchgip);
        addswitchgip ='0.0.0.0';//No I18N
       }
        if(proceed){
        addItem();}
        addswitchflag = false;
    }
    else if(addswitchtot ==0){
        addItem();
        addswitchflag = false;
    }
}
function removeItem(idNumber){
    removeElement("container", "element" + idNumber);//No I18N
    addswitchtot--;
    if(addswitchtot == 0){
        $("#subnetdetails").css('display','none');
        $("#enping").css('display','none');
        document.getElementById("snmpSweep").checked = false;
    }
     addswitchflag = true; addswitchlen--;
    
    
}
function removeElement(parentId, elementId){
    var parentElement = document.getElementById(parentId);
    var childElement = document.getElementById(elementId);
    parentElement.removeChild(childElement);
}
function appendElement(containerId, newElementId,latestId, newElementContent) {
    var oTable = document.createElement('table');
    oTable.width = '100%';//No I18N
    oTable.border='0';//No I18N
    var oTbody = document.createElement('tbody');
    var oRow = document.createElement('tr');
    
    var tdCell1 = document.createElement('td');
    tdCell1.width = "47%";//No I18N
    tdCell1.align = 'left';//No I18N
    var oTxt = document.createTextNode(Ember.I18n.t('opu.views.SUBNET_ADDRESS',this)+" : ");
    tdCell1.className="txt";//No I18N
    tdCell1.noWrap="NOWRAP";//No I18N
    tdCell1.appendChild(oTxt);

    var inputElement = document.createElement('input');
    inputElement.type = 'text';//No I18N
    inputElement.id = 'ipAddress'+latestId;//No I18N
    inputElement.name = 'ipAddress'+latestId;//No I18N
    inputElement.className = 'TextField';//No I18N
    inputElement.size = '15';//No I18N
    inputElement.selected;
    
    inputElement.onblur = function computeForm1(){
    assignValue(inputElement,selectElement);
    }

    tdCell1.appendChild(inputElement);
   

    var tdCell2 = document.createElement('td');
    tdCell2.width = "46%";//No I18N
    tdCell2.align = 'left';//No I18N
    var oTxt1 = document.createTextNode(Ember.I18n.t('opu.views.SUBNET_MASK',this)+" : ");
    tdCell2.className="txt";//No I18N
    tdCell2.noWrap="NOWRAP";//No I18N
    tdCell2.appendChild(oTxt1);
   
    var selectElement = document.createElement('select');
    selectElement.id= 'mask'+latestId;//No I18N
    selectElement.name = 'mask'+latestId;//No I18N
    selectElement.size = '1';//No I18N
    selectElement.value = '255.255.255.0';//No I18N
    selectElement.className = 'ComboTextfieldSmall';//No I18N
   
    addOption(selectElement, '255.255.255.0', '255.255.255.0');
    addOption(selectElement, '255.255.255.128', '255.255.255.128');
    addOption(selectElement, '255.255.255.192', '255.255.255.192');
    addOption(selectElement, '255.255.255.224', '255.255.255.224');
    addOption(selectElement, '255.255.255.240', '255.255.255.240');
    addOption(selectElement, '255.255.255.248', '255.255.255.248');
    addOption(selectElement, '255.255.255.252', '255.255.255.252');
    addOption(selectElement, '255.255.255.254', '255.255.255.254');
    addOption(selectElement, '255.255.255.255', '255.255.255.255');
    addOption(selectElement, '255.255.254.0', '255.255.254.0');
    addOption(selectElement, '255.255.252.0', '255.255.252.0');
    addOption(selectElement, '255.255.248.0', '255.255.248.0');
    addOption(selectElement, '255.255.240.0', '255.255.240.0');		

    tdCell2.appendChild(selectElement);
    
    var tdCell3 = document.createElement('td');
    tdCell3.width = "7%";//No I18N
    var anchorTag = document.createElement('div');
    anchorTag.setAttribute("id", newElementId);
    anchorTag.innerHTML=newElementContent;
    tdCell3.appendChild(anchorTag);
    
    oRow.appendChild(tdCell1);
    oRow.appendChild(tdCell2);
    oRow.appendChild(tdCell3);

    oTbody.appendChild(oRow);
    oTable.appendChild(oTbody);

    var newElement=document.createElement("div");
    newElement.setAttribute("id", newElementId);

    newElement.appendChild(oTable);
    var container = document.getElementById(containerId);
    container.appendChild(newElement, container);
}
function validateSwitchInput() {
    var ret = validateSwitch();
    if(ret) {
        document.getElementById("loadingImgID").style.display='block';
        document.getElementById("InImgID").innerHTML = '<img src="/images/loading_img.gif"/>';//No I18N
        document.getElementById("errorDiv").style.display='none';
    }
    return ret;
}
function validateSwitch(){
    var spmgroupid = document.getElementById("parentID").value
        var groupValidation = validateSPMParentNode("SPMG_"+spmgroupid);//No I18N
        if(groupValidation === false){
            return false;
        }
    var flag1 = validateSPMInput(document.subnetAddForm);
    var flag2 = false;
    if(document.getElementById("snmpSweep").checked){ 
            if(addswitchtot > 0 && flag1){
                
                if(removeDuplicate()){
        flag2 = validateSweepInput(addswitchgip);
      //  addswitchgip ='0.0.0.0';
       }
                
           //  flag2 = validateSweepInput(addswitchgip);
    }
        if(flag1 && flag2){
          return true;
       }else {return false;}
    }
    if(flag1 || flag2){
        return true;
    }
    return false;
}


function validateSPMInput(f)
{
    var version1 = f.snmpV1Id.checked;
    var version2 = f.snmpV2Id.checked;
    var version3 = f.snmpV3Id.checked;
    var multiSwitch="";
    if(f.actionFromMulti!=undefined){
        multiSwitch=f.actionFromMulti.value;
    }
    var switchComm = f.switchCommunityToModify;
    if(multiSwitch=="modifyMultiSwitch"){
        var multiEditSnmp=f.multiEditSnmp.checked;
        var multiEditGroup=f.multiGroupChange.checked;
        var multiEditScan=f.multiEditScan.checked;
        if(!multiEditGroup && !multiEditSnmp && !multiEditScan){
            alert(I18nUtil.getMsg('opu.common.NO_CHANGES_HAS_BEEN_MADE')); 
            return false;
        }
        if(multiEditSnmp){
            if((version1 || version2) && switchComm.value.length == 0)
            {
                alert(I18nUtil.getMsg('opu.common.PLEASE_ENTER_COMMUNITY_STRING'));
                switchComm.focus();
                return false;
            } else if (version3) {
                return snmpV3Validation(f);
            }
        }
        if(multiEditGroup){
            return true;
        }
        if(multiEditScanSpan){
            return true;
        }
    }

        var switchIP;
	
	//var routerIP;
	//var routerComm;
        var groupName;
        f.sysDetails.value = f.sysDetails.checked;
        if(f.actionFrom.value == 'modifySwitch')
	{

                switchIP = f.switchIPToModify;
		switchComm = f.switchCommunityToModify;
		//routerIP = f.routerIPToModify;
		//routerComm = f.routerCommunityToModify;

	}else if(f.actionFrom.value == 'csvModifySwitch' || f.actionFrom.value == 'modifySwitch')//No I18N
	{
		switchIP = f.switchIPToModify;
		switchComm = f.switchCommunityToModify;
		//routerIP = f.routerIPToModify;
		//routerComm = f.routerCommunityToModify;

	}
	else
	{
          	switchIP = f.switchIP;
		switchComm = f.switchCommunity;
		//routerIP = f.routerIP;
		//routerComm = f.routerCommunity;
	}

        switchIP.value = trimAll(switchIP.value);
	switchComm.value = trimAll(switchComm.value);
	//routerIP.value = trim(routerIP.value);
	//routerComm.value = trim(routerComm.value);

	if(switchIP.value.length == 0)
	{
		alert(I18nUtil.getMsg('opu.snmp.ENTER_VALID_HOST_OR_IP'));
		switchIP.focus();
		return false;
	}
	if((version1 || version2) && switchComm.value.length == 0)
	{
		alert(I18nUtil.getMsg('opu.common.PLEASE_ENTER_COMMUNITY_STRING'));
		switchComm.focus();
		return false;
	} else if (version3) {
           /* var userName = f.username.value;
            if(userName.length == 0) {
                alert("Please enter username.");
                return false;
            }

            var authField = document.getElementById("authID");
            var authPass = document.getElementById("authPassID").value;
                if(authField.value != 'none') {
                    if(authPass.length == 0) {
                        alert("Authentication password cannot be empty.");
                        return false;
                    }
                    var privField = document.getElementById("privID");
                    var privPass = document.getElementById("privPassID").value;
                    if(privField.value != 'none' && privPass.length == 0) {
                        alert("Encryption password cannot be empty.");
                        return false;
                    }
                }*/
                return snmpV3Validation(f);
        }

	var ip = switchIP.value;
	var parts = ip.split(".");

	if(parts[0].length == 0)
	{
		alert(I18nUtil.getMsg('opu.common.EnterValidIP'));
		switchIP.focus();
		return false;
	}

	if(isNumber(parts[0]))
	{
		if(!isValidIPAddress(switchIP.value))
		{
			alert(I18nUtil.getMsg('opu.common.EnterValidIP'));
			switchIP.focus();
			return false;
		}
	}
	else
	{
		if(!isSpecialCharacter(switchIP.value))
		{
			alert(I18nUtil.getMsg('opu.common.EnterValidIP'));
			switchIP.focus();
			return false;
		}
	}
	return true;
}

function enablePingSweep(){
    if($("#snmpSweep").prop("checked")){   
        $("#subnetdetails").css('display','block');
        if(addswitchtot === 0){
            addNewItem();
        }
    }
    else{
        $("#subnetdetails").css('display','none');
    }
}
function enablePingSweepForSwitch(){
    addswitchtot = 0;
    addswitchlatestId=0;   
    enablePingSweep();
}

function showSPMGroupFlied(grouptype)
{
    if(grouptype === "new"){
        $("#newSPMGroup").css('display','block');
        $("#existingSPMGroup").css('display','none');
    }else{
        $("#existingSPMGroup").css('display','block');
        $("#newSPMGroup").css('display','none');
    }
}
function changeAuthProto()
{
	var authprotoVal = $('#authprotocol').val();	
	if(authprotoVal !== "None")
	{
		$('#authpwd').attr("disabled",false);
		$('#privprotocol').attr("disabled",false);
		var encProtoVal = $('#privprotocol').val();
		if(encProtoVal === "None")
		{
			$('#privpwd').attr("disabled",true);
		}
		else
		{
			$('#privpwd').attr("disabled",false);
		}
	}
	else
	{
		$('#authprotocol').attr("value","None");
		$('#authpwd').attr("disabled",true);
		$('#privprotocol option[value=None]').prop('selected',true);
		$('#privprotocol').attr("disabled",true);
		$('#privpwd').attr("disabled",true);
	}
}
function changeEncProto()
{
	var encProtoVal = $('#authprotocol').val();
	if(encProtoVal !== "None")
	{
		$('#privpwd').attr("disabled",false);	
	}
	else
	{
		$('#privpwd').attr("disabled",true);
	}
}

function spmSwitchEditAndDelete(cellValue, options, rowdata, action)
{

	var editDiv = "<span style='float:left;' class='pointer ui-icon ui-icon-pencil' title='Edit' onclick='openEditSwitchPage(&#39;"+rowdata['switch-name']+"&#39;)'></span>"; //No I18N
	var delDiv = "<span style='float:left;margin-left:5px;' class='pointer ui-icon ui-icon-trash' title='Delete' onclick='spmSwitchActions(&#39;spmSwitchesList&#39;,&#39;config-id&#39;,&#39;Delete&#39;,&#39;"+rowdata["config-id"]+"&#39;)'></span>"; //No I18n
	return editDiv+delDiv;
}
function openEditSwitchPage(switchName){
 location.href = window.apiclientUrl + "SPM/Group/"+OpUtilsClient.SPMController.selectedSPMGroupID+"/EditSwitch/"+switchName;//No I18N   
}


function spmUpdateSwitch(updateOpt)
{
    
var dataObj = {"v":"1","format":"json"};//NO I18N
dataObj.operation="UPDATE_SPM_SWITCH";//No I18N
dataObj.actionFromFlag=updateOpt;
dataObj.switchIPToModify=switchname;
dataObj.CONFIG_ID=$('#CONFIG_ID').val();

    var switchname = $('#switchname').val();
        var readcommunity = $("#readcommunity").val();
        var systemdetails = $("#systemdetails").prop("checked");
        var arpmacip = $("#arpmacip").prop("checked");
        var snmpPingSweep = $("#snmpSweep").prop("checked");
        var snmpv3 = $("#snmpv3").css("display");
var previousSnmpVerV3 = $('#isV3Device').val();

        if (snmpv3 === "block") 
        {
            dataObj.setSnmpVersionID="snmpv3";//NO I18N
            var v3username = trimAll($('#v3username').val());
            var v3contextname = trimAll($('#v3contextname').val());
            var authprotocol = $('#authprotocol').val();
            var authpwd = trimAll($('#authpwd').val());
            var encrprotocol = $('#privprotocol').val();
            var encrpwd = trimAll($('#privpwd').val());

            if (v3username === undefined || v3username ==="") {
                alert(Ember.I18n.t('opu.common.PLEASE_ENTER_THE_USER_NAME', this));//No I18N
                $("#v3username").focus();
                return;
            }
            dataObj.username=v3username;//No I18N 
            if (v3contextname !== undefined && v3contextname !=="") {
                dataObj.coname=v3contextname;//No I18N
            }

            if (authprotocol !== "None" && previousSnmpVerV3 === "false" && (authpwd === undefined || authpwd ==="") ) {
                alert(Ember.I18n.t('opu.common.PLEASE_ENTER_THE_PASSWORD', this));//No I18N
                $("#authpwd").focus();
                return;
            }
            dataObj.authID=authprotocol;
            if (authprotocol !== "None" && (authpwd !== undefined && authpwd !=="")) {
                
                dataObj.authPassID=authpwd;
            }
            if(encrprotocol !== "None"){
                dataObj.privID=encrprotocol;
            }
            if (authprotocol !== "None" && authpwd !== undefined && encrprotocol !== "None" && previousSnmpVerV3 === "false") {
                
                if (encrpwd === undefined || encrpwd === "") {
                    alert(Ember.I18n.t('opu.common.PLEASE_ENTER_THE_PASSWORD', this));//No I18N
                    $("#privpwd").focus();
                    return;
                }
                
            }
            if (encrpwd !== undefined && encrpwd !== "") {
               dataObj.privPassID=encrpwd;
            }
            
        }else{
            if (previousSnmpVerV3 === "true" && (readcommunity === undefined || readcommunity === "")) {
                alert(Ember.I18n.t('opu.common.PLEASE_ENTER_COMMUNITY_STRING', this));//No I18N
                $("#readcommunity").focus();
                return;
            }           
            if(readcommunity !== undefined && readcommunity !== ""){
                dataObj.switchCommunityToModify=readcommunity;
            }
            
            var snmpver2 = $("#snmpver2").prop("checked");
            if(snmpver2 === true){
                dataObj.setSnmpVersionID="snmpV2";//No I18N
            }else{
                dataObj.setSnmpVersionID="snmpV1";//No I18N
            }
        }
        
        if (systemdetails === true) {
            dataObj.sysDetails=true;
        }else{
            dataObj.sysDetails=false;
        }
        if (arpmacip === true) {
            dataObj.arpDetails=true;
        }else{
            dataObj.arpDetails=false;
        }
        if (snmpPingSweep === true) {
            dataObj.snmpPingSweepEnable=true;
            $('#AddSwitchForm').find('input,select').each(function(i, field) {//NO I18N
                var fName = field.name;
                var fValue = field.value;
                if((fName.indexOf('ipAddress') !== -1 || fName.indexOf('mask') !== -1) && fValue !==""){
                    dataObj[fName]=fValue;
                }
            });
        }else{
            dataObj.snmpPingSweepEnable=false;
        }
        
        
        
$.ajax({
        url: '/oputilsapi/spm?key='+getOpUtilsAPIKey(), //No I18N
        type: 'POST', //No I18N
        data: dataObj,
        success: function(response){
            if (response.status === "Failure")
            {
                document.getElementById('resDiv').style.backgroundColor = '#FF0000';//No I18N		
                document.getElementById('resDiv').style.display = 'block'; //No I18N
                document.getElementById('resDiv').innerHTML = response.message;
                $("#resDiv").fadeOut(2000);
            }else if (response.status === "Success")//NO I18N
            {
                window.location.reload();	
            }
        }
});
}
function spmSwitchActions(jqgridid,colName,action,configid){
var selectedRows = ""
    if(configid !== undefined){
            selectedRows = configid;
    }else{
        if(colName !== undefined && colName !== ""){
            selectedRows = getEmberSelectedRows(jqgridid,colName);
        }
    }
var paramsData = {"v":"1","format":"json"};//NO I18N
if(jqgridid === "spmSwitchesList" && action === "Scan"){
    paramsData.operation="SCAN_SWITCHES";//NO I18N
    paramsData.CONFIG_ID=selectedRows;
}
else if(jqgridid === "spmSwitchesList" && action === "ScanAll"){//NO I18N
    var selectedSPMGroup = OpUtilsClient.SPMController.selectedSPMGroupID;
    if(selectedSPMGroup === "AllSwitches"){
        selectedSPMGroup = "0";//NO I18N
    }
    paramsData.operation="SCAN_ALL_SWITCHES";//NO I18N
    paramsData.treeGID=OpUtilsClient.SPMController.selectedSPMGroupID;
}
else if(jqgridid === "spmSwitchesList" && action === "Delete"){//NO I18N
    paramsData.operation="DELETE_SWITCHES";//NO I18N
    paramsData.configID=selectedRows;
}

$.ajax({
        url: '/oputilsapi/spm?key='+getOpUtilsAPIKey(), //No I18N
        type: 'POST', //No I18N
        data: paramsData,//No I18N
        success: function(response){
            if (response.status === "Failure")
            {
                document.getElementById('resDiv').style.backgroundColor = '#FF0000';//No I18N		
                document.getElementById('resDiv').style.display = 'block'; //No I18N
                document.getElementById('resDiv').innerHTML = response.message;
                $("#resDiv").fadeOut(2000);
            }else if (response.status === "Success")//NO I18N
            {
                window.location.reload();	
            }
        }
});
}


function blockSwitchPort(title, buttonName, blocktype) {

    var selectedRows = getEmberSelectedRows("spmSwitchesPortList", "connected-port-ifindex");//NO I18N
    if (selectedRows === "" && (blocktype === "Disable" || blocktype === "Enable")) {
        alert(Ember.I18n.t("opu.spm.SELECT_PORT_TO_BLOCK", this));//NO I18N
        return;
    } else if (selectedRows === "" && blocktype === "ifAlias") {
        alert(Ember.I18n.t("opu.spm.SELECT_SELECT_PORT_TO_MODIFY_IFALIAS_NAME", this));//NO I18N
        return;

    }
    var allIfIdex = selectedRows.split(",");
    var selectedIndex = "";
    var arr = new Array();
    for (i = 0; i < allIfIdex.length; i++) {
        arr.push(parseInt((allIfIdex[i].split("</a>")[0]).split(">")[1]));
    }
    arr.sort();
    selectedIndex = arr.toString();
    var snmpversion = 1;
    var switchid = "";
    $.ajax({
        url: getOpUtilsSPMAPIURL() + "&operation=GET_SWITCH_SUMMARY&switchIP=" + OpUtilsClient.SPMController.selectedSwitch, //NO I18N
        type: 'GET', //No I18N		
        dataType: 'json', //No I18N
        async: false, //No I18N
        success: function(resultObj)
        {
            snmpversion = resultObj.result['snmp-version'];//NO I18N
            switchid = resultObj.result['switch-id'];//NO I18N
        }
    });

    $('#BlockUnBlockPortPopUp').dialog({
        dialogClass: "no-close", //No I18N
        bgiframe: true,
        title: Ember.I18n.t(title, this), //No I18N
        draggable: false,
        position: 'Center', //No I18N
        width: '500px', //No I18N
        closeOnEscape: 'true', //No I18N
        modal: true,
        buttons:
                {
                    'blockPort': function() { //No I18N

                        blockUnBlockSwitchPort(snmpversion, blocktype, selectedIndex, switchid);
                    },
                    'Cancel': function() { //No I18N
                        $(this).dialog("close"); //No I18N
                    }
                }
    });

    var ifnames = "<table align='left' border='0' cellpadding='5' cellspacing='0' class='apiClientDefaultFont' width='100%' ><tr><td align='left' width='23%'>" + Ember.I18n.t("opu.views.IFINDEX", this) + "</td><td align='center' width='5px'>:</td><td align='left' id='ifindex'>" + selectedIndex + "</td></tr></table>"
    if (blocktype === "ifAlias") {

        ifnames = "<table align='left' border='0' cellpadding='5' cellspacing='0' class='apiClientDefaultFont' width='100%' ><tr><td align='left' width='23%' >" + Ember.I18n.t("opu.views.PORT_DETAILS", this) + " </td><td align='center' width='5px'>:</td><td align='center' width='80px' nowrap class=txtbold>" + Ember.I18n.t("opu.views.IFINDEX", this) + "</td><td align='left' class=txtbold>" + Ember.I18n.t("opu.common.IF_ALIAS", this) + "</td></tr>";//NO I18N
        var totalifindex = selectedIndex.split(",");

        for (i = 0; i < totalifindex.length; i++) {
            ifnames += "<tr><td align='left'> </td><td align='center' width='5px'></td><td align='center' width='50px' nowrap>" + totalifindex[i] + "</td><td align='left'><input type=text id='ifIndexAlias_" + totalifindex[i] + "' style='width: 120px' ></td></tr>";//NO I18N
        }
        ifnames += "</table>";//NO I18N

    }
    $("#ifindexField").html(ifnames);
    if (snmpversion === 3 || snmpversion === "3") {
        $("#snmpv3").css("display", "block");
        $("#snmpwriteCommunity").hide();
    }
    $('.ui-dialog-buttonpane button:contains(blockPort)').attr("id", "BlockUnBlockPortPopUp_blockport-button");//NO I18N
    $('#BlockUnBlockPortPopUp_blockport-button').html("<span class='ui-button-text'>" + Ember.I18n.t(buttonName, this) + "</span> ");//NO I18N
}

function blockUnBlockSwitchPort(snmpversion, blocktype, selectedIfIdex, switchid, configid) {


    var paramsData = {"v": "1", "format": "json"};//NO I18N
    if (blocktype === "Disable") {
        paramsData.operation = "ADMIN_DISABLE_INTERFACES";//NO I18N

    } else if (blocktype === "Enable") {//NO I18N
        paramsData.operation = "ADMIN_ENABLE_INTERFACES";//NO I18N
    } else if (blocktype === "ifAlias") {//NO I18N
        paramsData.operation = "UPDATE_BULK_IFALIAS_NAME";//NO I18N
        var totalifindex = selectedIfIdex.split(",");
        var arr = new Array();
        for (i = 0; i < totalifindex.length; i++) {
            arr.push($("#ifIndexAlias_" + totalifindex[i]).val());//NO I18N
        }
        paramsData.ifAliasList = arr.toString();
    } else if (blocktype === "excludeport") {//NO I18N
        paramsData.operation = "SPM_EXCLUDE_OR_INCLUDE_PORTS";//NO I18N
        paramsData.actionFrom = "excludePort";//NO I18N
        paramsData.status = 1;
        paramsData.configID = configid;

    } else if (blocktype === "includeport") {//NO I18N
        paramsData.operation = "SPM_EXCLUDE_OR_INCLUDE_PORTS";//NO I18N
        paramsData.actionFrom = "includePort";//NO I18N
        paramsData.status = 0;
        paramsData.configID = configid;

    }
    paramsData.ifIndex = selectedIfIdex;
    paramsData.switchID = switchid;
    paramsData.switchName = OpUtilsClient.SPMController.selectedSwitch;
    if (blocktype !== "excludeport" && blocktype !== "includeport")
    {
        if (snmpversion === 3 || snmpversion === "3")
        {
            paramsData.setSnmpVersionID = 1;
            var v3username = trimAll($('#v3username').val());
            var v3contextname = trimAll($('#v3contextname').val());
            var authprotocol = $('#authprotocol').val();
            var authpwd = trimAll($('#authpwd').val());
            var encrprotocol = $('#privprotocol').val();
            var encrpwd = trimAll($('#privpwd').val());

            if (v3username === undefined || v3username === "") {
                alert(Ember.I18n.t('opu.common.PLEASE_ENTER_THE_USER_NAME', this));//No I18N
                $("#v3username").focus();
                return;
            }
            paramsData.username = v3username;
            if (v3contextname !== undefined && v3contextname !== "") {
                paramsData.coname = v3contextname;
            }

            if (authprotocol !== "None" && (authpwd === undefined || authpwd === "")) {
                alert(Ember.I18n.t('opu.common.PLEASE_ENTER_THE_PASSWORD', this));//No I18N
                $("#authpwd").focus();
                return;
            }
            if (authprotocol !== "None" && (authpwd !== undefined && authpwd !== "")) {
                paramsData.authID = authprotocol;
                paramsData.authPassID = authpwd;
            }
            if (authprotocol !== "None" && authpwd !== undefined && encrprotocol !== "None") {
                if (encrpwd === undefined || encrpwd === "") {
                    alert(Ember.I18n.t('opu.common.PLEASE_ENTER_THE_PASSWORD', this));//No I18N
                    $("#privpwd").focus();
                    return;
                }
                if (encrpwd !== undefined && encrpwd !== "") {
                    paramsData.privID = encrprotocol;
                    paramsData.privPassID = encrpwd;
                }
            }


        } else {
            var writecommunity = trimAll($('#writeCommunity').val());
            if (writecommunity === undefined || writecommunity === "") {
                alert(Ember.I18n.t('opu.common.PLEASE_ENTER_COMMUNITY_STRING', this));//No I18N
                $("#readcommunity").focus();
                return;
            }
            paramsData.setSnmpVersionID = 0;
            paramsData.writeCommunity = writecommunity;
        }
    }
    $.ajax({
        url: '/oputilsapi/spm?key=' + getOpUtilsAPIKey(), //No I18N
        type: 'POST', //No I18N
        data: paramsData,
        success: function(response) {
            if (response.status === "Failure")
            {
                document.getElementById('resDiv').style.backgroundColor = '#FF0000';//No I18N		
                document.getElementById('resDiv').style.display = 'block'; //No I18N
                document.getElementById('resDiv').innerHTML = response.message;
                $("#resDiv").fadeOut(2000);
            } else if (response.status === "Success")//NO I18N
            {
                window.location.reload();
            }
        }
    });
}
function excludeIncludePort(exclOrIncl) {
    var selectedRows = getEmberSelectedRows("spmSwitchesPortList", "connected-port-ifindex");//NO I18N
    if (selectedRows === "" && (exclOrIncl === "excludeport")) {
        alert(Ember.I18n.t("opu.spm.SELECT_PORT_TO_EXCLUDE", this));//NO I18N
        return;
    } else if (selectedRows === "" && (exclOrIncl === "includeport")) {
        alert(Ember.I18n.t("opu.spm.SELECT_PORT_TO_INCLUDE", this));//NO I18N
        return;

    }
    var allIfIdex = selectedRows.split(",");
    var arr = new Array();
    for (i = 0; i < allIfIdex.length; i++) {
        arr.push(parseInt((allIfIdex[i].split("</a>")[0]).split(">")[1]));
    }
    arr.sort();
    var switchid, configid = "";

    $.ajax({
        url: getOpUtilsSPMAPIURL() + "&operation=GET_SWITCH_SUMMARY&switchIP=" + OpUtilsClient.SPMController.selectedSwitch, //NO I18N
        type: 'GET', //No I18N		
        dataType: 'json', //No I18N
        async: false, //No I18N
        success: function(resultObj)
        {
            switchid = resultObj.result['switch-id'];//NO I18N
            configid = resultObj.result['config-id'];//NO I18N
        }
    });

    blockUnBlockSwitchPort("", exclOrIncl, arr.toString(), switchid, configid);
}
    
