
/* Settings Models */

OpUtilsClient.Settings = Ember.Object.extend({});
var gstitle = OpUtilsClient.Settings.create();
var routerlists = OpUtilsClient.Settings.create();
var addomainlists = OpUtilsClient.Settings.create();
OpUtilsClient.Settings.reopenClass({
    hideSecondTab: function()
    {
        //try to hide second tabs.....
    },listRouters:function(){
         var colNamesList = [Ember.I18n.t('opu.views.ROUTER_NAME',this), Ember.I18n.t('opu.views.IP_ADDRESS',this), Ember.I18n.t('opu.views.LAST_SCAN_TIME',this), Ember.I18n.t('opu.views.MODIFIED_BY',this),Ember.I18n.t('opu.views.STATUS',this),Ember.I18n.t('opu.views.ACTIONS',this),Ember.I18n.t('opu.views.REMARKS',this),"Router Id"]; //No I18N
        var colModelList = [
            {name: 'router-name', index: 'router-name',width:width100,sortable: true}, //No I18N
            {name: 'ip-address', index: 'ip-address', width: width100,sortable: true}, //No I18N
            {name: 'last-scan-time', index: 'last-scan-time',width: width100}, //No I18N
            {name: 'modified-by', index: 'modified-by',width: width80,sortable: true}, //No I18N
            {name: 'status', index: 'status',width: width50,sortable: true}, //No I18N
            {name: 'Action', index: 'Action', sortable: false,formatter:routerEditAndDelete,width:width50,hidden:!(OpUtilsClient.ApplicationController.isAdminRole)}, //No I18N
            {name: 'remarks', index: 'remarks', sortable: true}, //No I18N
            {name: 'router-id', index: 'router-id', hidden:true}, //No I18N
        ];
        var defaultOptions = {"sortName": "router-name", "sortOrder": "asc","multiselect": true};//No I18N
        var routerlist = getOpUtilsRogueAPIURL()+"&operation=GET_ROUTER_DETAILS";//No I18N
        $.getJSON(routerlist, function(resp) { //No I18N
            loadJQgridWithData("#routerListpage", resp.result, colNamesList, colModelList, "", "", "routerListpage", defaultOptions); //No I18N

        });
        return routerlists;
    },listOpUtilsUsers:function(){
         var colNamesList = [Ember.I18n.t('opu.views.USER_NAME',this), Ember.I18n.t('opu.views.ROLE',this), Ember.I18n.t('opu.views.ACCOUNT_CREATED_DATE',this), Ember.I18n.t('opu.views.EMAIL',this),Ember.I18n.t('opu.views.PHONE_NUMBER',this),Ember.I18n.t('opu.views.DESCRIPTION',this),Ember.I18n.t('opu.views.AD_DOMAIN_NAME',this),Ember.I18n.t('opu.views.ACTIONS',this)]; //No I18N
        var colModelList = [
            {name: 'user-name', index: 'user-name',width:width100,sortable: true}, //No I18N
            {name: 'user-role', index: 'user-role', width: width100,sortable: true}, //No I18N
            {name: 'account-created-time', index: 'account-created-time',width: width100}, //No I18N
            {name: 'user-email', index: 'user-email',width: width100,sortable: true}, //No I18N
            {name: 'user-phone-number', index: 'user-phone-number',width: width80,sortable: true}, //No I18N
            {name: 'user-description', index: 'user-description', sortable: true}, //No I18N
            {name: 'ad-domain-name', index: 'ad-domain-name',width:width100, sortable: true}, //No I18N
            {name: 'Action', index: 'Action',width:width50,formatter:OpUtilsUsersActions,hidden:!(window.isAdminUser)}, //No I18N
        ];
        var defaultOptions = {"sortName": "user-name", "sortOrder": "asc","multiselect": true};//No I18N
        var routerlist = getOpUtilsSettingsAPIURL()+"&operation=GET_USER_DETAILS";//No I18N
        
        $.getJSON(routerlist, function(resp) { //No I18N
            loadJQgridWithData("#usersListpage", resp.result, colNamesList, colModelList, "", "", "usersListpage", defaultOptions); //No I18N

        });
        return routerlists;
    }
    ,listAdDomains:function(){
         var colNamesList = [Ember.I18n.t('opu.views.ADMIN_USER_NAME',this), Ember.I18n.t('opu.views.DOMAIN',this), Ember.I18n.t('opu.views.DOMAIN_CONTROLLER_NAME',this), Ember.I18n.t('opu.views.LAST_SUCCESSFUL_SCAN',this),Ember.I18n.t('opu.views.LAST_SCAN_STATUS',this),Ember.I18n.t('opu.views.REMARKS',this),Ember.I18n.t('opu.views.ACTIONS',this)]; //No I18N
        var colModelList = [
            {name: 'user-name', index: 'user-name',width:width100,sortable: true}, //No I18N
            {name: 'ad-domain-name', index: 'ad-domain-name', width: width100,sortable: true}, //No I18N
            {name: 'domain-controller-name', index: 'domain-controller-name',width: width100}, //No I18N
            {name: 'last-scan-time', index: 'last-scan-time',width: width100,sortable: true}, //No I18N
            {name: 'scan-status', index: 'scan-status',width: width80,sortable: true}, //No I18N
            {name: 'remarks', index: 'remarks', sortable: true}, //No I18N
            {name: 'Action', index: 'Action', sortable: true,formatter:adDomainEditAndDelete,width:width50,hidden:!(OpUtilsClient.ApplicationController.isAdminRole)}, //No I18N
        ];
        var defaultOptions = {"sortName": "user-name", "sortOrder": "asc","multiselect": false};//No I18N
        var addomainlist = getOpUtilsAPIURL()+"&operation=GET_AD_DOMAIN_DETAILS";//No I18N
        $.getJSON(addomainlist, function(resp) { //No I18N
            loadJQgridWithData("#adDomainsListpage", resp.result, colNamesList, colModelList, "", "", "adDomainsListpage", defaultOptions); //No I18N

        });
        return addomainlists;
    },listSchedulerReports:function(tool){
        var defaultOptions,schedulerlist,colNamesList,colModelList;
        if( tool === "IPAM"){
            colNamesList = [Ember.I18n.t('opu.views.TASK_NAME',this), Ember.I18n.t('opu.views.TYPE',this), Ember.I18n.t('opu.views.SUBNET_COUNT',this), Ember.I18n.t('opu.views.CREATED_TIME',this),Ember.I18n.t('opu.views.LAST_SCAN_TIME',this),Ember.I18n.t('opu.views.OWNER',this)]; //No I18N
            colModelList = [
               {name: 'task_name', index: 'task_name',sortable: true}, //No I18N
               {name: 'feature_id', index: 'feature_id', width: width100,sortable: true}, //No I18N
               {name: 'count', index: 'count',width: width100}, //No I18N
               {name: 'creationtime', index: 'creationtime',width: width100,sortable: true}, //No I18N
               {name: 'last_scan_time', index: 'last_scan_time',width: width100,sortable: true}, //No I18N
               {name: 'owner', index: 'owner', sortable: true}, //No I18N
           ];
           defaultOptions = {"sortName": "task_name", "sortOrder": "asc","multiselect": true};//No I18N
           schedulerlist = getOpUtilsSettingsAPIURL()+"&operation=GET_IPAM_SCHEDULED_TASKS";//No I18N
        }else{
            colNamesList = [Ember.I18n.t('opu.views.TASK_NAME',this), Ember.I18n.t('opu.views.SWITCH_COUNT',this), Ember.I18n.t('opu.views.CREATED_TIME',this),Ember.I18n.t('opu.views.LAST_SCAN_TIME',this),Ember.I18n.t('opu.views.NEXT_SCAN_TIME',this), Ember.I18n.t('opu.views.OWNER',this)]; //No I18N
            colModelList = [
               {name: 'task_name', index: 'task_name',sortable: true}, //No I18N
               {name: 'count', index: 'count',width: width100}, //No I18N
               {name: 'creationtime', index: 'creationtime',width: width100,sortable: true}, //No I18N
               {name: 'last_scan_time', index: 'last_scan_time',width: width100,sortable: true}, //No I18N
               {name: 'nextscantime', index: 'nextscantime',width: width100,sortable: true}, //No I18N
               {name: 'owner', index: 'owner', sortable: true}, //No I18N
           ];
           defaultOptions = {"sortName": "task_name", "sortOrder": "asc","multiselect": true};//No I18N
           schedulerlist = getOpUtilsSettingsAPIURL()+"&operation=GET_SPM_SCHEDULED_TASKS";//No I18N
        }
        
        $.getJSON(schedulerlist, function(resp) { //No I18N
            loadJQgridWithData("#SchedulerListpage", resp.result, colNamesList, colModelList, "", "", "SchedulerListpage", defaultOptions); //No I18N
        });
        return addomainlists;
    },listCustomColumns:function(tool){
         var colNamesList = [Ember.I18n.t('opu.views.COLUMN_NAME',this), Ember.I18n.t('opu.views.DATA_TYPE',this), Ember.I18n.t('opu.views.SIZE',this), Ember.I18n.t('opu.views.DEFAULT_VALUE',this),Ember.I18n.t('opu.views.DESCRIPTION',this),Ember.I18n.t('opu.views.COLUMN_AT',this)]; //No I18N
        var colModelList = [
            {name: 'columnname', index: 'columnname',width:width100,sortable: true,sorttype:'text'}, //No I18N
            {name: 'datatypename', index: 'datatypename',width:width100,sortable: true,sorttype:'text'}, //No I18N
            {name: 'size', index: 'size',width:width80,sortable: false}, //No I18N
            {name: 'defaultvalue', index: 'defaultvalue',width:width100,sortable: false}, //No I18N
            {name: 'columndesc', index: 'columndesc',width:width100,sortable: true,sorttype:'text'}, //No I18N
            {name: 'fieldleveldisplayname', index: 'fieldleveldisplayname',width:width100,sortable: true,sorttype:'text'}, //No I18N
        ];
        var defaultOptions = {"sortName": "columnname", "sortOrder": "asc","multiselect": false};//No I18N
        var cusColUrl = getOpUtilsSettingsAPIURL()+"&operation=GET_CUSTOM_COLUMN_DETAILS&tool="+tool;//No I18N
        $.getJSON(cusColUrl, function(resp) { //No I18N
            loadJQgridWithData("#customColumnList", resp.result, colNamesList, colModelList, "", "", "customColumnList", defaultOptions); //No I18N
        });
        return addomainlists;
    }
});

function setGeneralSettingsTabLinks(selectedTab)
{
    var general = false,snmp = false ,smtp = false,icmp = false,syslog = false,graph = false,linux = false;

    if (selectedTab === "General") {//No I18N
        general = true;
    }else if (selectedTab === "SMTP") {//No I18N
        smtp = true;
    }else if (selectedTab === "SNMP") {//No I18N
        snmp = true;
    }else if (selectedTab === "ICMP") {//No I18N
        icmp = true;
    }else if (selectedTab === "Syslog") {//No I18N
        syslog = true;
    }else if (selectedTab === "Graph") {//No I18N
        graph = true;
    }else if (selectedTab === "Linux") {//No I18N
        linux = true;
    }
    var baseurl = window.apiclientUrl+"Settings/Settings.BasicSettings/";//No I18N
    var menuLinkArray = [
        {"Name": Ember.I18n.t('opu.common.GENERAL',this), "url": baseurl + "General", "title": Ember.I18n.t('opu.common.GENERAL',this), "isSelected": general}, //No I18N
        {"Name": Ember.I18n.t('opu.common.SNMP',this), "url": baseurl + "SNMP", "title": Ember.I18n.t('opu.common.SNMP',this), "isSelected": snmp}, //No I18N
        {"Name": Ember.I18n.t('opu.common.SMTP', this), "url": baseurl + "SMTP", "title": Ember.I18n.t('opu.common.SMTP', this), "isSelected": smtp}, //No I18N
        {"Name": Ember.I18n.t('opu.common.ICMP', this), "url": baseurl + "ICMP", "title": Ember.I18n.t('opu.common.ICMP', this), "isSelected": icmp}, //No I18N
        {"Name": Ember.I18n.t('opu.common.SYSLOG', this), "url": baseurl + "Syslog", "title": Ember.I18n.t('opu.common.SYSLOG', this), "isSelected": syslog}, //No I18N
        {"Name": Ember.I18n.t('opu.common.GRAPH', this), "url": baseurl + "Graph", "title": Ember.I18n.t('opu.common.GRAPH', this), "isSelected": graph}, //No I18N
        {"Name": Ember.I18n.t('opu.common.LINUX', this), "url": baseurl + "Linux", "title": Ember.I18n.t('opu.common.LINUX', this), "isSelected": linux}, //No I18N
    ];
    var jsonObj = {
        "menuLinks": menuLinkArray //No I18N
    }
    OpUtilsClient.SettingsArrayController.set("GenralSettingsMenuLinks", jsonObj); //No I18N
}
function setSPMSettingsTabLinks(selectedTab)
{
    var general = false,scheduler = false ,alert = false,customCol = false,publish = false;
    if (selectedTab === "General") {//No I18N
        general = true;
    }else if(selectedTab === "Scheduler"){//NO I18N
        scheduler = true;
    }else if(selectedTab === "Alerts"){//NO I18N
        alert = true;
    }else if(selectedTab === "CustomColumn"){//NO I18N
        customCol = true;
    }else if(selectedTab === "Publish"){//NO I18N
        publish = true;
    }
    var baseurl = window.apiclientUrl+"Settings/Settings.SPM/";//No I18N
    var menuLinkArray = [
        {"Name": Ember.I18n.t('opu.common.GENERAL',this), "url": baseurl + "General", "title": Ember.I18n.t('opu.common.GENERAL',this), "isSelected": general}, //No I18N
        {"Name": Ember.I18n.t('opu.common.SCHEDULER',this), "url": baseurl + "Scheduler", "title": Ember.I18n.t('opu.common.SCHEDULER',this), "isSelected": scheduler}, //No I18N
        {"Name": Ember.I18n.t('opu.common.CONFIGURE_ALERTS', this), "url": baseurl + "ConfigAlerts", "title": Ember.I18n.t('opu.common.CONFIGURE_ALERTS', this), "isSelected": alert}, //No I18N
        {"Name": Ember.I18n.t('opu.common.CUSTOM_COLUMNS', this), "url": baseurl + "CustomColumn", "title": Ember.I18n.t('opu.common.CUSTOM_COLUMNS', this), "isSelected": customCol}, //No I18N
        {"Name": Ember.I18n.t('opu.common.PUBLISH', this), "url": baseurl + "Publish", "title": Ember.I18n.t('opu.common.PUBLISH', this), "isSelected": publish}, //No I18N
        ];
    var jsonObj = {
        "menuLinks": menuLinkArray //No I18N
    }
    OpUtilsClient.SettingsArrayController.set("spmSettingsMenuLinks", jsonObj); //No I18N
}
function getCharacterEncodingValues()
{
    var charEncodUrl = getOpUtilsSettingsAPIURL()+"&operation=GET_ALL_ADMIN_VALUES";//No I18N
    $.ajax(
    {
        url: charEncodUrl,
        type: 'GET', //No I18N
        async :false,
        success: function(charEncodData)
        {
            OpUtilsClient.SettingsArrayController.set("loggerCharEncodingVal", charEncodData.result.encodingValueAll); //No I18N
            OpUtilsClient.SettingsArrayController.set("syslogSeverity", charEncodData.result.syslogSeverityAll); //No I18N
            OpUtilsClient.SettingsArrayController.set("syslogFacility", charEncodData.result.syslogFacilityAll); //No I18N
        }
    });
}
function setIPAMSettingsTabLinks(selectedTab)
{
    var general = false,scheduler = false ,alertsConfig = false,cupolicy = false,publish = false,customCol=false,api;

    if (selectedTab === "General") {//No I18N
        general = true;
    }else if (selectedTab === "Scheduler") {//No I18N
        scheduler = true;
    }else if (selectedTab === "Alerts") {//No I18N
        alertsConfig = true;
    }else if (selectedTab === "CleanUpPolicy") {//No I18N
        cupolicy = true;
    }else if (selectedTab === "CustomColumn") {//No I18N
        customCol = true;
    }else if (selectedTab === "Publish") {//No I18N
        publish = true;
    }else if (selectedTab === "API") {//No I18N
        api = true;
    }
    var baseurl = window.apiclientUrl+"Settings/Settings.IPAM/";//No I18N
    var menuLinkArray = [
        {"Name": Ember.I18n.t('opu.common.GENERAL',this), "url": baseurl + "General", "title": Ember.I18n.t('opu.common.GENERAL',this), "isSelected": general}, //No I18N
        {"Name": Ember.I18n.t('opu.common.SCHEDULER',this), "url": baseurl + "Scheduler", "title": Ember.I18n.t('opu.common.SCHEDULER',this), "isSelected": scheduler}, //No I18N
        {"Name": Ember.I18n.t('opu.common.CONFIGURE_ALERTS', this), "url": baseurl + "ConfigAlerts", "title": Ember.I18n.t('opu.common.CONFIGURE_ALERTS', this), "isSelected": alertsConfig}, //No I18N
        {"Name": Ember.I18n.t('opu.common.CLEAN_UP_POLICY', this), "url": baseurl + "CleanUpPolicy", "title": Ember.I18n.t('opu.common.CLEAN_UP_POLICY', this), "isSelected": cupolicy}, //No I18N
        {"Name": Ember.I18n.t('opu.common.CUSTOM_COLUMNS', this), "url": baseurl + "CustomColumn", "title": Ember.I18n.t('opu.common.CUSTOM_COLUMNS', this), "isSelected": customCol}, //No I18N
        {"Name": Ember.I18n.t('opu.common.PUBLISH', this), "url": baseurl + "Publish", "title": Ember.I18n.t('opu.common.PUBLISH', this), "isSelected": publish}, //No I18N
        {"Name": Ember.I18n.t('opu.common.API', this), "url": baseurl + "API", "title": Ember.I18n.t('opu.common.API', this), "isSelected": api}, //No I18N
    ];
    var jsonObj = {
        "menuLinks": menuLinkArray //No I18N
    }
    OpUtilsClient.SettingsArrayController.set("ipamSettingsMenuLinks", jsonObj); //No I18N
}
function setNWMSettingsTabLinks(selectedTab)
{
    var alertsrule = false,emailtemp=false,cleanUpPolicy=false;

    if (selectedTab === "AlertRule") {//No I18N
        alertsrule = true;
    }
    else if (selectedTab === "EmailTemp") {//No I18N
        emailtemp = true;
    }
    else if (selectedTab === "CleanUpPolicy") {//No I18N
        cleanUpPolicy = true;
    }
    var baseurl = window.apiclientUrl+"Settings/Settings.NWM/";//No I18N
    var menuLinkArray = [
        {"Name": Ember.I18n.t('opu.general.ALERT_RULE',this), "url": baseurl + "AlertRule", "title": Ember.I18n.t('opu.general.ALERT_RULE',this), "isSelected": alertsrule}, //No I18N
        {"Name": Ember.I18n.t('opu.general.EMAIL_TEMPLATE',this), "url": baseurl + "EmailTemp", "title": Ember.I18n.t('opu.general.EMAIL_TEMPLATE',this), "isSelected": emailtemp}, //No I18N
        {"Name": Ember.I18n.t('opu.common.CLEAN_UP_POLICY',this), "url": baseurl + "CleanUpPolicy", "title": Ember.I18n.t('opu.common.CLEAN_UP_POLICY',this), "isSelected": cleanUpPolicy}, //No I18N
    ];
    var jsonObj = {
        "menuLinks": menuLinkArray //No I18N
    }
    OpUtilsClient.SettingsArrayController.set("nwmSettingsMenuLinks", jsonObj); //No I18N
}
function setBWMSettingsTabLinks(selectedTab)
{
    var alertsrule = false,cleanUpPolicy=false;

    if (selectedTab === "AlertRule") {//No I18N
        alertsrule = true;
    }
    else if (selectedTab === "CleanUpPolicy") {//No I18N
        cleanUpPolicy = true;
    }
    var baseurl = window.apiclientUrl+"Settings/Settings.BWM/";//No I18N
    var menuLinkArray = [
        {"Name": Ember.I18n.t('opu.general.ALERT_RULE',this), "url": baseurl + "AlertRule", "title": Ember.I18n.t('opu.general.ALERT_RULE',this), "isSelected": alertsrule}, //No I18N
        {"Name": Ember.I18n.t('opu.common.CLEAN_UP_POLICY',this), "url": baseurl + "CleanUpPolicy", "title": Ember.I18n.t('opu.common.CLEAN_UP_POLICY',this), "isSelected": cleanUpPolicy}, //No I18N
    ];
    var jsonObj = {
        "menuLinks": menuLinkArray //No I18N
    }
    OpUtilsClient.SettingsArrayController.set("bwmSettingsMenuLinks", jsonObj); //No I18N
}
function disableEnableSMTPUserPwd(){
    if($("#gssmtpauthreq").prop("checked") === false){
        $('#gsmailusername').attr("disabled",true);
        $('#gsmailpassword').attr("disabled",true);
    }else{
        $('#gsmailusername').attr("disabled",false);
        $('#gsmailpassword').attr("disabled",false);
    }
}
function showHideActiveDomain(addType)
{
	if(addType.id === "addbyLocalAuth")
	{
            $("#passwordRow").css('display','block');
            $("#addomainRow").css('display','none');
	}
	else
	{
            $("#passwordRow").css('display','none');
            $("#addomainRow").css('display','block');
	}

}

function oputilsChangeLanguage(language){
    var langUrl = getOpUtilsSettingsAPIURL()+"&operation=CHANGE_USER_LANGUAGE&chooseLang="+language.value;//No I18N
    $.ajax(
    {
        url: langUrl,
        type: 'GET', //No I18N
        async :false,
        success: function(charEncodData)
        {
        }
    });
    location.reload();
    
}
function getIPAMSettingsObj(settingsTab){
    var settingsUrl = getOpUtilsSettingsAPIURL()+"&operation=GET_IPAM_SETTINGS";//No I18N
    var response = [];
    if(ipamSettingsValues === null){
        $.ajax(
        {
            url: settingsUrl,
            type: 'GET', //No I18N
            async :false,
            success: function(jsonData)
            {
                response = jsonData;
                ipamSettingsValues =jsonData
            }
        });
    }else{
        response = ipamSettingsValues;
    }
    if(settingsTab === "General"){
        return response.result.generalSettings;
    }else if(settingsTab === "CleanUpPolicy"){//NO I18N
        return response.result.cleanUpSettings;   
    }else if(settingsTab === "PublishColumn"){//NO I18N
        return response.result.publishSettings;   
    }else if(settingsTab === "Alerts"){//NO I18N
        return response.result.alertSettings;   
    }
}
function getSPMSettingsObj(settingsTab){
    var settingsUrl = getOpUtilsSettingsAPIURL()+"&operation=GET_SPM_SETTINGS";//No I18N
    var response = [];
    if(spmSettingsValues === null){
        $.ajax(
        {
            url: settingsUrl,
            type: 'GET', //No I18N
            async :false,
            success: function(jsonData)
            {
                response = jsonData;
                spmSettingsValues =jsonData
            }
        });
    }else{
        response = spmSettingsValues;
    }
    if(settingsTab === "General"){
        return response.result.generalSettings;
    }else if(settingsTab === "CleanUpPolicy"){//NO I18N
        return response.result.cleanUpSettings;   
    }else if(settingsTab === "PublishColumn"){//NO I18N
        return response.result.publishSettings;   
    }else if(settingsTab === "Alerts"){//NO I18N
        return response.result.alertSettings;   
    }
}
function getRogueSettingsObj(settingsTab){
    var settingsUrl = getOpUtilsSettingsAPIURL()+"&operation=GET_ROGUE_SETTINGS";//No I18N
    var response = [];
    if(rogueSettingsValues === null){
        $.ajax(
        {
            url: settingsUrl,
            type: 'GET', //No I18N
            async :false,
            success: function(jsonData)
            {
                response = jsonData;
                rogueSettingsValues =jsonData
            }
        });
    }else{
        response = rogueSettingsValues;
    }
    if(settingsTab === "General"){
        return response.result.generalSettings;
    }
}
function getNWMSettingsObj(settingsTab){
    var settingsUrl = getOpUtilsSettingsAPIURL()+"&operation=GET_NWM_SETTINGS";//No I18N
    var response = [];
    if(nwmSettingsValues === null){
        $.ajax(
        {
            url: settingsUrl,
            type: 'GET', //No I18N
            async :false,
            success: function(jsonData)
            {
                response = jsonData;
                nwmSettingsValues =jsonData
            }
        });
    }else{
        response = nwmSettingsValues;
    }
    if(settingsTab === "EmailTemplate"){
        return response.result.emailTemplateSettings;
    }else if(settingsTab === "CleanUp"){//NO I18N
        return response.result.cleanUpSettings;
    }else if(settingsTab === "AlertRule"){//NO I18N
        return response.result.generalSettings;
    }
}
function getBWMSettingsObj(settingsTab){
    var settingsUrl = getOpUtilsSettingsAPIURL()+"&operation=GET_BWM_SETTINGS";//No I18N
    var response = [];
    if(bwmSettingsValues === null){
        $.ajax(
        {
            url: settingsUrl,
            type: 'GET', //No I18N
            async :false,
            success: function(jsonData)
            {
                response = jsonData;
                bwmSettingsValues =jsonData
            }
        });
    }else{
        response = bwmSettingsValues;
    }
    if(settingsTab === "CleanUp"){
        return response.result.cleanUpSettings;
    }else if(settingsTab === "AlertRule"){//NO I18N
        return response.result.generalSettings;
    }
}
function enableDisableIPAMPublish(){
    
    var isDisabled = $("#backupHistory").prop("checked");
        if(isDisabled === false){
            $("#availableReport").prop("disabled", true);   
            $("#selectedReport").prop("disabled", true);   
            $("#maintainLastScan").prop("disabled", true);   
            $("#maintainMax").prop("disabled", true);   
            $("#publishHTML").prop("disabled", true);   
            $("#publishCsv").prop("disabled", true);   
            $("#DefaultLocation").prop("disabled", true);   
            $("#SpecifyLocation").prop("disabled", true);   
            $("#moveRightSide").prop("disabled", true);   
            $("#moveLeftSide").prop("disabled", true);   
        }else{
            $("#availableReport").prop("disabled", false);   
            $("#selectedReport").prop("disabled", false);   
            $("#maintainLastScan").prop("disabled", false);   
            $("#maintainMax").prop("disabled", false);   
            $("#publishHTML").prop("disabled", false);   
            $("#publishCsv").prop("disabled", false);   
            $("#DefaultLocation").prop("disabled", false);   
            $("#SpecifyLocation").prop("disabled", false);   
            $("#moveRightSide").prop("disabled", false);   
            $("#moveLeftSide").prop("disabled", false);   
        }
}
function getOpUtilsAlertsConfig(tool,alertData){

        var wholealerts = "";
        var len = alertData.length
        for(i=0;i<len;i++){
            var alertdetasils = alertData[i];
            if(i%2 === 0){
                wholealerts += "<tr  bgcolor='#FFFFFF'>";//NO I18N
            }else{
                wholealerts += "<tr  bgcolor='#f5f5f5'>";//NO I18N
            }
            wholealerts += "<td width='63%' >"+alertdetasils.description+"</td>";//NO I18N
            var isEnabledEmail="";
            var isEnabledSyslog="";
            if(alertdetasils.isEmailEnabled === "true"){ isEnabledEmail = "checked" }//NO I18N
            if(alertdetasils.isSysLogEnabled === "true"){ isEnabledSyslog = "checked" }//NO I18N
            
            wholealerts += "<td align='center' width='18%' class=txt > <p><input id='MAIL_"+alertdetasils.alertName+"' name='MAIL_"+alertdetasils.alertName+"' type=checkbox "+ isEnabledEmail +" onclick='chkChange(this)' ><label for='MAIL_"+alertdetasils.alertName+"'></label></p></td>";//NO I18N
            wholealerts += "<td align='center' class=txt > <p><input id='SYS_"+alertdetasils.alertName+"' name='SYS_"+alertdetasils.alertName+"' type=checkbox "+ isEnabledSyslog +" onclick='chkChange(this)' ><label for='SYS_"+alertdetasils.alertName+"'></label></p></td>";//NO I18N
            wholealerts += "</tr>";//NO I18N
        }
        document.getElementById("alertslisttableid").innerHTML=wholealerts;
}

function openAddSchedulerTask(view)
{
    if(view === "show"){
        $("#AddSchedulerView").show();
        $("#SchedulerListView").hide();
        
    }else{
        $("#AddSchedulerView").hide();
        $("#SchedulerListView").show();
    }
}
function openAddCustomColumn(view)
{
    if(view === "show"){
        $("#ListCustomColDiv").hide();
        $("#AddcustomColDiv").show();
        
    }else{
        $("#ListCustomColDiv").show();
        $("#AddcustomColDiv").hide();
    }
}
function checkNWMEmailTemplate()
{
    var status = 0 ;
   if(document.getElementById('normalid').checked)
   {
        document.getElementById('norTxt').className="txtbold" 
        document.getElementById('warTxt').className="txt" 
        document.getElementById('criTxt').className="txt" 
        
        status =0;
   }
   else if(document.getElementById('warningid').checked)
   {
        status =1;
        document.getElementById('norTxt').className="txt" 
        document.getElementById('warTxt').className="txtbold" 
        document.getElementById('criTxt').className="txt" 
        
   }else if(document.getElementById('criticalid').checked)
   {
        status =2;
        document.getElementById('norTxt').className="txt" 
        document.getElementById('warTxt').className="txt" 
        document.getElementById('criTxt').className="txtbold" 
        
   }
  var getemailTemurl = getOpUtilsSettingsAPIURL()+"&operation=GET_NWM_EMAIL_TEMPLATE&status="+status;//No I18N
  
    $.ajax(
    {
        url: getemailTemurl,
        type: 'GET', //No I18N
        async :false,
        success: function(jsonData)
        {
            $("#mailSubject").val(jsonData.result.emailTemplateSettings.mailSubject);
            $("#mailDescription").val(jsonData.result.emailTemplateSettings.mailDescription);
        }
    });
}
function updateNWMAlertRule(value)
{
  var getnwmAlertRuleurl = getOpUtilsSettingsAPIURL()+"&operation=GET_NWM_SETTINGS_FOR_DEVICE&alertHostName="+value;//No I18N
  if(value === "Global"){
      getnwmAlertRuleurl = getOpUtilsSettingsAPIURL()+"&operation=GET_NWM_SETTINGS";//No I18N
  }
    $.ajax(
    {
        url: getnwmAlertRuleurl,
        type: 'GET', //No I18N
        async :false,
        success: function(jsonData)
        {
            var nwmAlertRuleSettingsVal = jsonData.result.generalSettings;
            $("#warningRTThreshold").val(nwmAlertRuleSettingsVal.warningRTThreshold);
            $("#specifyPoll").val(nwmAlertRuleSettingsVal.pollMissedCount);
            $("#mailID").val(nwmAlertRuleSettingsVal.toAdd);
            $("#EscaltoAdd").val(nwmAlertRuleSettingsVal.alertEsMailID);
            $("#polExceedWarning").val(nwmAlertRuleSettingsVal.pollCriticalCount);
            if(nwmAlertRuleSettingsVal.emailAlertEnabled === "true")
            {
                $("#checkClickStatus").prop("checked",true);
            }else
            {
                $("#checkClickStatus").prop("checked",false);   
            }
            if(nwmAlertRuleSettingsVal.esacalationEnabled === "true")
            {
                $("#EnaEscalID").prop("checked",true);
            }else{
                $("#EnaEscalID").prop("checked",false);
            }
            if(nwmAlertRuleSettingsVal.notifyOnWarning === "1")
            {
                $("#warningAlert").prop("checked",true);
            }else{
                $("#warningAlert").prop("checked",false);
            }
            if(nwmAlertRuleSettingsVal.notifyOnNormal === "1")
            {
                $("#normalAlert").prop("checked",true);
            }else{
                $("#normalAlert").prop("checked",false);
            }
            if(nwmAlertRuleSettingsVal.notifyOnDown === "1")
            {
                $("#criticalAlert").prop("checked",true);
            }else{
                $("#criticalAlert").prop("checked",false);
            }
            checkEnableField();
            checkEscalationEnabled();
        }
    });
}
function updateBWMAlertRule(value)
{
  var getbwmAlertRuleurl = getOpUtilsSettingsAPIURL()+"&operation=GET_BWM_SETTINGS&alertHostName="+value;//No I18N
    $.ajax(
    {
        url: getbwmAlertRuleurl,
        type: 'GET', //No I18N
        async :false,
        success: function(jsonData)
        {
            var nwmAlertRuleSettingsVal = jsonData.result.generalSettings;
            if(nwmAlertRuleSettingsVal.mailOption === "1")
            {
                $("#checkClickStatus").prop("checked",true);
            }else{
                $("#checkClickStatus").prop("checked",false);
            }
            $("#warningThreshold").val(nwmAlertRuleSettingsVal.warningThreshold);
            $("#majorThreshold").val(nwmAlertRuleSettingsVal.majorThreshold);
            $("#criticalThreshold").val(nwmAlertRuleSettingsVal.criticalThreshold);
            $("#mailID").val(nwmAlertRuleSettingsVal.toAdd);
            showMailField("mailID","checkClickStatus");//NO I18N
            $("#alertType"+nwmAlertRuleSettingsVal.alertType).prop("checked",true);
        }
    });
}
function showMailField(divId,checkboxid) {
    if($("#"+checkboxid).prop("checked") === true) {
        $("#"+divId).removeAttr("disabled")
    }else {
       $("#"+divId).attr("disabled","disabled")
    }
}
function updateSettingsPage(url) {
        opu_showLoadingTextOnReq(true);
      $.ajax(
      {
          url: url,
          type: 'POST', //No I18N
          async :false,
          success: function(jsonData)
          {
              var status = jsonData.status;
              if ((status !== undefined && status === "Failure") && (jsonData.message !== undefined))
              {
                  opu_showFailureResponseTextOnDiv(jsonData.message);
              } else {
                  opu_showSuccessResponseTextOnDiv("opu.common.YOUR_CHANGES_HAVE_BEEN_SAVED");//NO I18N
              }
          }
      });
}
function getSelectedEmailAlerts(type) {
    var selectedAlerts = "";
    var inputs = document.getElementsByTagName("input");
       for(var i = 0; i < inputs.length; i++) {
        if(inputs[i].type == "checkbox" && inputs[i].name.indexOf(type+"_") == 0 && inputs[i].checked) {
            selectedAlerts += "&"+inputs[i].name+"=on";//NO I18N
        }
    }
    return selectedAlerts;
}
function validateCustomColulmn(type) {
     var dataType = trimAll($('#dataType').val());
         if(dataType == 'FILE,4')
         {
            $("#size").val(100)
         }
         var columnName = $("#columnName").val() ;
         var size = trimAll($("#size").val());
//         if(buttonValue == I18nUtil.getMsg("opu.common.ADD_COLUMN"))
//         {
            if(columnName.length == 0)
            {
                alert(Ember.I18n.t("opu.common.SPECIFY_A_NAME_FOR_THIS_COLUMN",this));//NO I18N
                $("#columnName").focus();
                return false;
            }  
            else 
            {
                for (var i = 0; i <  columnName.length; i++)
                {
                    if(sChars.indexOf(columnName.charAt(i)) != -1)
                    {
                        alert(getI18NwithParams("opu.common.ENTER_VALUE_WITHOUT_SPL_CHARS", [sChars]));//NO I18N
                        $("#columnName").focus();
                        return false;
                    }
                    else
                    {
	                var colNameChar = columnName.charCodeAt(i);
                        if ((colNameChar >= 0 && colNameChar < 34) || (colNameChar > 122 && colNameChar < 128))
                        {
                            alert(getI18NwithParams("opu.common.ENTER_VALUE_WITHOUT_SPL_CHARS", [sChars]));//NO I18N
                            $("#columnName").focus();
                            return false;
                        }
                    }
                } 
            }
            
            if(size.length == 0)
            {
                alert(Ember.I18n.t("opu.common.EnterAnInt"));//NO I18N
                $("#size").focus();
                return false;
            }            
//         }
         /*else if(buttonValue == I18nUtil.getMsg("opu.common.MODIFY_COLUMN"))
         {
            if(size.length == 0)
            {
                alert(I18nUtil.getMsg("opu.common.EnterAnInt"));
                return false;
            }          
            else if(size < <%=size%>)
            {
                alert(I18nUtil.getMsg("opu.common.SIZE_CANNOT_BE_REDUCED_IN_CUS_COLUMN"))
              return false;
            }
         }
         if(isNaN(size))
         {
             alert(I18nUtil.getMsg("opu.common.EnterAnInt"));
                return false;         
         }
         else if(size<=0)
         {
             alert(I18nUtil.getMsg("opu.common.EnterAnInt"));
              return false;           
         }
            
         var defaultValue = document.getElementById('defaultValue').value.trim();
         for (var i = 0; i <  defaultValue.length; i++)
         {
              if(valueSpChars.indexOf(defaultValue.charAt(i)) != -1)
              {
                  alert (I18nUtil.getMsg("opu.common.ENTER_DEFAULT_VALUE_WITHOUT_SPL_CHARS", new Array(valueSpChars)));
                  return false;
              }
         } 
         
         if(dataType == 'STRING,1' && defaultValue.length > size)
        {
            alert(I18nUtil.getMsg("opu.common.DEFAULT_VAULE_SHOULD_NOT_EXCEED_COLUMN_SIZE"));
           return false;
        }
        
        if(dataType == 'INTEGER,2')
        {
	        if(isNaN(defaultValue))
	        {
                    alert(I18nUtil.getMsg("opu.common.EnterAnInt"));
		        return false;
	        }
        }
        
        if(document.getElementById('desc').value.length > 1000)
        {
           alert(I18nUtil.getMsg("opu.common.DESCRIPTION_LENGTH_EXCEEDED",new Array('1000')));
	        return false;
        }
        
        var level = document.getElementById('columnFor');
        var optObj = level.options[level.selectedIndex];
        document.getElementById('tableName').value = optObj.getAttribute('tableName');
        
        if(document.getElementById('tableID').value == 'null')
        {
	        document.getElementById('tableID').value = document.getElementById('columnFor').value;
    	}
              */
             return true;
}

function adDomainEditAndDelete(cellValue, options, rowdata, action)
{
    var editDiv = "<span style='float:left;' class='pointer ui-icon ui-icon-pencil' title='Edit' onclick='openEditADDomainPage(&#39;"+rowdata['ad-domain-id']+"&#39;)'></span>"; //No I18N
    var delDiv = "<span style='float:left;margin-left:5px;' class='pointer ui-icon ui-icon-trash' title='Delete' onclick='deleteADDomain(&#39;"+rowdata['ad-domain-id']+"&#39;,&#39;"+rowdata['ad-domain-name']+"&#39;,&#39;"+options.rowId+"&#39;)'></span>"; //No I18n
    return editDiv+delDiv;
}
function openEditADDomainPage(domainID){
    location.href = window.apiclientUrl + "Settings/EditADDomain/"+domainID ;//No I18N
}
function deleteADDomain(domainID,domainName,rowid){
    if(confirm(getI18NwithParams("opu.addomain.DELETE_DOMAIN_CONFIRMATION_DIALOG",[domainName]))){
        $.ajax({
            url: '/oputilsapi/ipam?key='+getOpUtilsAPIKey(), //No I18N
            type: 'POST', //No I18N
            data: {"v":"1","format":"json","operation":"DELETE_AD_DOMAIN","domainID":domainID,"domainName":domainName},//No I18N
            success: function(response){
                if (response.status === "Failure")
                {
                   opu_showFailureResponseTextOnDiv(response.message);
                }else if (response.status === "Success")//NO I18N
                {
                    $('#adDomainsListpage').jqGrid('delRowData',rowid);
                }
            }
    });
    }
}
function scanADDomain(){
        $.ajax({
            url: '/oputilsapi/ipam?key='+getOpUtilsAPIKey(), //No I18N
            type: 'POST', //No I18N
            data: {"v":"1","format":"json","operation":"SCAN_ALL_ACTIVE_DIRECTORY"},//No I18N
            success: function(response){
                if (response.status === "Failure")
                {
                    opu_showFailureResponseTextOnDiv(response.message);
                }else if (response.status === "Success")//NO I18N
                {
                    opu_showSuccessResponseTextOnDiv("opu.spm.SCAN_STARTED_SUCCESSFULLY");//No I18N
                }
            }
    });
}
function routerActions(actions,selectedRouter)
{
    var operation;
    if(actions === "Scan"){
        operation = "SCAN_ROUTERS";//NO I18N
    }else if(actions === "ScanAll"){//NO I18N
        operation = "SCAN_ALL_ROUTERS";//NO I18N
        selectedRouter = "";
    }else if(actions === "delete"){//NO I18N
        operation = "DELETE_ROUTERS";//NO I18N
    }
    if(selectedRouter === undefined){
        selectedRouter = getEmberSelectedRows("routerListpage","router-id");//NO I18N
    }
    
    executeActionURLinPost("/oputilsapi/rogue?key="+getOpUtilsAPIKey(),{"v":"1","format":"json","operation":operation,"ID":selectedRouter}); //No I18N
}
function routerEditAndDelete(cellValue, options, rowdata, action)
{
    var editDiv = "<span style='float:left;' class='pointer ui-icon ui-icon-pencil' title='Edit' onclick='openEditRouterPage(&#39;"+rowdata['router-name']+"&#39;,&#39;"+rowdata['router-id']+"&#39;)'></span>"; //No I18N
    var delDiv = "<span style='float:left;margin-left:5px;' class='pointer ui-icon ui-icon-trash' title='Delete' onclick='routerActions(&#39;delete&#39;,&#39;"+rowdata['router-id']+"&#39;)'></span>"; //No I18n
    return editDiv+delDiv;
}
function openEditRouterPage(router,routerid)
{
    location.href = window.apiclientUrl + "Settings/EditRouter/"+router+"/"+routerid;//No I18N   
}
function openAddRouterPage()
{
    location.href = window.apiclientUrl + "Settings/AddRouter";//No I18N   
}

function OpUtilsUsersActions(cellValue, options, rowdata, action)
{
    var editDiv = "<span style='float:left;' class='pointer ui-icon ui-icon-pencil' title='Edit' onclick='openModifyUserPage(&#39;"+rowdata['user-name']+"&#39;,&#39;"+rowdata['user-id']+"&#39;)'></span>"; //No I18N
    var delDiv = "";
    if(rowdata['user-name'] !== "admin"){
         delDiv = "<span style='float:left;margin-left:5px;' class='pointer ui-icon ui-icon-trash' title='Delete' onclick='deleteUser(&#39;"+rowdata['user-name']+"&#39;,&#39;"+rowdata['ad-domain-name']+"&#39;)'></span>"; //No I18n
    }
    return editDiv+delDiv;
}
function openModifyUserPage(username,userid)
{
    location.href = window.apiclientUrl + "Settings/EditUser/"+username+"/"+userid;//No I18N   
}

function deleteUser(username,domainName)
{
    if(confirm(getI18NwithParams("opu.general.CONFIRMATION_DO_YOU_WANT_DELETE_USER",[username]))){
        var dataParams = {"v":"1","format":"json","operation":"DELETE_OR_MODIFY_USER","action1":"DELETE_USER","userInAction":username};//NO I18N
        if(domainName !== ""){
            dataParams.domainName=domainName;
        }
        executeActionURLinPost("/oputilsapi/admin?key="+getOpUtilsAPIKey(),dataParams);//No I18N
    }
}