
/* IPAM Routes */
OpUtilsClient.IPAMRoute = Ember.Route.extend({
    setupController: function(controller) {
        controller.set('content', OpUtilsClient.IPAM.listIPAMTab());  //No I18N

    },
    renderTemplate: function() {
        this.render({into: 'application', outlet: 'list'});//No I18N
    } 
});

OpUtilsClient.IPAMAllIPsRoute = Ember.Route.extend({
     setupController: function(controller) {
        OpUtilsClient.IPAM.IPV4ListAllIps();//No I18N
        setIPAMSelectedGroup("AllIPs");//No I18N
        
    },
    renderTemplate: function() {
        this.render({into: 'application', outlet: 'details'});//No I18N
    },exit: function()
	{
                OpUtilsClient.IPAMController.appendIPAddrInAllIPs = false;
	}
});
OpUtilsClient.IPAMAllAlertsRoute = Ember.Route.extend({
    setupController: function(controller) {
        OpUtilsClient.IPAM.IPAMAllAlerts();
    },
    renderTemplate: function() {
        this.render({into: 'application', outlet: 'details'});//No I18N
    }
});
OpUtilsClient.IPAMIPAddressRoute = Ember.Route.extend({
  
    model: function(params) {
        return {ipaddress: params.ipaddr};
    },
    renderTemplate: function() {
        this.render({into: 'application', outlet: 'details'});//No I18N
    }
});
OpUtilsClient.IPAMIPAddressSummaryRoute = Ember.Route.extend({
    model: function(params) {
        return this.modelFor("IPAM.IPAddress"); //No I18N
    },
     setupController: function(controller, model) {
         
         OpUtilsClient.IPAM.IPV4IPAddressSummary(model.ipaddress);
    },
    renderTemplate: function() {
        this.render({outlet: 'ipsnapshot'});//No I18N
    }
});
OpUtilsClient.IPAMIPAddressHistoryRoute = Ember.Route.extend({
    model: function(params) {
        return this.modelFor("IPAM.IPAddress"); //No I18N
    },
     setupController: function(controller, model) {
         
         OpUtilsClient.IPAM.IPV4IPAddressHistory(model.ipaddress);
    },
    renderTemplate: function() {
        this.render({outlet: 'ipsnapshot'});//No I18N
    }
});
OpUtilsClient.IPAMIPAddressAlertsRoute = Ember.Route.extend({
    model: function(params) {
        return this.modelFor("IPAM.IPAddress"); //No I18N
    },
     setupController: function(controller, model) {
         OpUtilsClient.IPAM.IPV4IPAddressAlerts(model.ipaddress);
    },
    renderTemplate: function() {
        this.render({outlet: 'ipsnapshot'});//No I18N
    }
});
OpUtilsClient.IPAMSubnetIPAddressRoute = Ember.Route.extend({
    model: function(params) {
        return {subnetaddr: params.subnetName};
    },
    renderTemplate: function() {
        this.render({into: 'application', outlet: 'details'});//No I18N
    }
});
OpUtilsClient.IPAMGroupSubnetRoute = Ember.Route.extend({
    model: function(params) {
        return {subnetaddr: params.subnetName, ipamgroup: OpUtilsClient.IPAMController.selectedIPAMGroupID};
    },
    renderTemplate: function() {
        this.render({into: 'application', outlet: 'details'});//No I18N
    }
});
OpUtilsClient.IPAMGroupSubnetSummaryRoute = Ember.Route.extend({
    model: function(params) {

        return this.modelFor("IPAM.Group.Subnet"); //No I18N
    },
    setupController: function(controller, model) {
        setIPAMGroupURL(model.subnetaddr);
        OpUtilsClient.IPAM.IPV4SubnetSummary(model.subnetaddr)//No I18N
    },
    renderTemplate: function() {
        this.render({outlet: 'subnetsnapshot'});//No I18N
    }
});
OpUtilsClient.IPAMGroupSubnetIPsRoute = Ember.Route.extend({
    model: function(params) {

        return this.modelFor("IPAM.Group.Subnet"); //No I18N
    },
    setupController: function(controller, model) {
        setIPAMGroupURL(model.subnetaddr);
        OpUtilsClient.IPAM.IPV4IPAddressOfSubnet(model.subnetaddr)//No I18N
    },
    renderTemplate: function() {
        this.render({outlet: 'subnetsnapshot'});//No I18N
    }
});
OpUtilsClient.IPAMGroupSubnetHistoryRoute = Ember.Route.extend({
    model: function(params) {

        return this.modelFor("IPAM.Group.Subnet"); //No I18N
    },
    setupController: function(controller, model) {
        setIPAMGroupURL(model.subnetaddr);
        OpUtilsClient.IPAM.IPV4HistoryOfSubnet(model.subnetaddr)//No I18N
    },
    renderTemplate: function() {
        this.render({outlet: 'subnetsnapshot'});//No I18N
    }
});
OpUtilsClient.IPAMGroupSubnetAlertsRoute = Ember.Route.extend({
    model: function(params) {

        return this.modelFor("IPAM.Group.Subnet"); //No I18N
    },
    setupController: function(controller, model) {
        setIPAMGroupURL(model.subnetaddr);
        OpUtilsClient.IPAM.IPV4AlertsOfSubnet(model.subnetaddr)//No I18N
    },
    renderTemplate: function() {
        this.render({outlet: 'subnetsnapshot'});//No I18N
    }
});
OpUtilsClient.IPAMGroupSubnetEditRoute = Ember.Route.extend({
    model: function(params) {

        return this.modelFor("IPAM.Group.Subnet"); //No I18N
    },
    setupController: function(controller, model) {
        OpUtilsClient.IPAMController.SelectedSubnetForEdit=model.subnetaddr;
    },
    renderTemplate: function() {
this.render({into: 'application', outlet: 'details'});//No I18N
    }
});
OpUtilsClient.IPAMGroupRoute = Ember.Route.extend({
    model: function(params) {
        OpUtilsClient.IPAMController.selectedIPAMGroupID = params.groupName;
        if (params.groupName === "AllSubnets") {
            params.groupName = null;
        }
        return {ipamgroup: params.groupName};
    }
});
OpUtilsClient.IPAMGroupSubnetListRoute = Ember.Route.extend({
    model: function(params) {
        return this.modelFor("IPAM.Group"); //No I18N
    },
    setupController: function(controller, model) {
//        controller.set('content', OpUtilsClient.IPAM.IPV4SubnetList(model.ipamgroup));  //No I18N
        OpUtilsClient.IPAM.IPV4SubnetList(model.ipamgroup);
        setIPAMSelectedGroup(model.ipamgroup);
    },
    renderTemplate: function() {
        this.render({into: 'application',outlet: 'details'});//No I18N
    }
});


OpUtilsClient.IPAMDashboardRoute = Ember.Route.extend({
	model: function(params) {
           
		return {dashName: params.dashName};
	},
	setupController: function(controller,model) {	
		var dash_model = OpUtilsClient.IPAM.getDashboardDetails("IPAM",model.dashName,model.dashName);	//No I18N
		controller.set('content', dash_model); //No I18N
	},
	serialize: function(model) {
        	return {dashName: Em.get(model, 'dashName')} //No I18N
	},	
	renderTemplate: function() {this.render({into: 'application',outlet: 'details'});}, //No I18N
	exit: function()
	{
		unloader();
	}
});
OpUtilsClient.IPAMAddSubnetRoute = Ember.Route.extend({
     setupController: function(controller) {
    },
    renderTemplate: function() {
        this.render({into: 'application', outlet: 'details'});//No I18N
    }
});
OpUtilsClient.IPAMAddAdDomainRoute = Ember.Route.extend({
     setupController: function(controller) {
    },
    renderTemplate: function() {
        this.render({into: 'application', outlet: 'details'});//No I18N
    }
});