	


d3.helper = {};

d3.helper.tooltip = function(widgetElement,accessor){
                    return function(selection)
                    {	  
                            var tooltipDiv;
                            selection.on("mouseover", function(d, i) //No I18N
                            {
                                    widgetElement.selectAll('div.tooltip').remove(); //No I18N
                                    tooltipDiv = widgetElement.append('div').attr('class', 'tooltip'); //No I18N
                                    tooltipDiv.style('left', (d3.event.pageX -200)+'px').style('top', (d3.event.pageY - 50)+'px').style('position', 'absolute').style('z-index', 1001).style('font-size',10+'pt').style('color','white').style('background-color','#000000').style('padding','5px'); //No I18N
                                    var tooltipText = accessor(d, i) || '';
                                    tooltipDiv.style('width', function(d, i){return (tooltipText.length > 80) ? '300px' : null;}).html(tooltipText); //No I18N
                            })
                            .on('mousemove', function(d, i)  //No I18N
                            {
                                    tooltipDiv.style('left', (d3.event.pageX -200)+'px').style('top', (d3.event.pageY - 50)+'px'); //No I18N
                                    var tooltipText = accessor(d, i) || '';
                                    tooltipDiv.html(tooltipText);
                            })
                            .on("mouseout", function(d, i){tooltipDiv.remove();}); //No I18N
                    };
            };

OpUtilsClient.IPAMView = Ember.View.extend({
    templateName: 'IPAM', //No I18N
    didInsertElement: function() {
        this.$("#ipamList").accordion({ collapsible: true, heightStyle: "content", header: ".myaccordionhead", content: ".myaccordioncontent" }); //No I18N
    }
});		//No I18N

OpUtilsClient.IPAMGroupSubnetView = Ember.View.extend({
    templateName: 'IPAMSubnetSnapshot', //No I18N
    didInsertElement: function() {
       
    }
});
OpUtilsClient.IPAMGroupSubnetSummaryView = Ember.View.extend({
    templateName: 'IPAMSummary', //No I18N
    didInsertElement: function() {
    }
});
OpUtilsClient.IPAMGroupSubnetIPsView = Ember.View.extend({
    templateName: 'IPAMIPAddrDetails', //No I18N
    didInsertElement: function() {
    }
});
OpUtilsClient.IPAMGroupSubnetHistoryView = Ember.View.extend({
    templateName: 'SubnetHistory', //No I18N
    didInsertElement: function() {
    }
});
OpUtilsClient.IPAMGroupSubnetAlertsView = Ember.View.extend({
    templateName: 'IPAMSubnetAlerts', //No I18N
    didInsertElement: function() {
    }
});
OpUtilsClient.IPAMGroupSubnetEditView = Ember.View.extend({
    templateName: 'IPAMAddSubnet', //No I18N
    didInsertElement: function() {
        $("#ipamAddSubnetOption").hide();
        $("#existingIPAMGroup").hide();
        $("#showipamgroup").hide();
        $("#newIPAMGroup").show();
        $("#updatesubnetAction").show();
        $("#addsubnetAction").hide();
        $("#titleDiv").html(Ember.I18n.t("opu.views.MODIFY_SUBNET",this));//NO I18N

        var subnetmask = "";
        var scandetails ="";
        var addomain ="";

        $.ajax(
                {
                    url: getOpUtilsAPIURL() + "&operation=GET_SUBNET_SUMMARY&subnetAddress="+OpUtilsClient.IPAMController.SelectedSubnetForEdit, //No I18N
                    type: 'GET', //No I18N
                    async: false,
                    success: function(jsonData)
                    {
                        $("#subnetaddr").val(jsonData.result['subnet-address']);
                        $("#newgroup").val(jsonData.result['group-name']);
                        $("#subnetvlan").val(jsonData.result['vlan-name']);
                        $("#subnetdesc").val(jsonData.result['subnet-description']);
                        $("#subnetlocation").val(jsonData.result.location);
                        $("#subnetname").val(jsonData.result['subnet-name']);
                        $("#subnetid").val(jsonData.result.subnetid);
                        subnetmask = jsonData.result['subnet-mask'];//NO I18N
                        scandetails = jsonData.result.scandetails;
                        if(scandetails.charAt(0) === "1"){
                            $("#pingICMP").prop("checked",true);
                        }
                        if(scandetails.charAt(1) === "1"){
                            $("#pingSNMP").prop("checked",true);
                        }
                        if(scandetails.charAt(2) === "1"){
                            $("#dnsresolve").prop("checked",true);
                        }
                        addomain = jsonData.result['ad-domain-name'];//NO I18N
                    }
                });
        
            if(scandetails.charAt(3) === "1" && OpUtilsClient.ApplicationController.isWindowsOS){
            
            $.ajax({
                url: getOpUtilsAPIURL() + "&operation=GET_AD_DOMAIN_LIST", //No I18N
                type: 'GET', //No I18N
                async: false,
                success: function(jsonData)
                {
                    if(jsonData.result === undefined){
                        OpUtilsClient.IPAMController.isAddedADDomain = false;
                    }else{
                        OpUtilsClient.IPAMController.isAddedADDomain = true;
                    }
                    if (Object.keys(jsonData).length > 0)
                    {
                        if(jsonData.status !== "Failure"){
                        var jsonObj =[];
                        var totalAD = jsonData.result.domainDetails.length;
                        for(i=0;i<totalAD;i++){
                            var domainname = jsonData.result.domainDetails[i]["ad-domain-name"];
                            if(addomain === domainname){
                                jsonObj[i] = {"ad-domain-name":domainname,"ad-domain-id":jsonData.result.domainDetails[i]["ad-domain-id"],"isSelected":true}//NO I18N
                            }else{
                            jsonObj[i] = {"ad-domain-name":domainname,"ad-domain-id":jsonData.result.domainDetails[i]["ad-domain-id"],"isSelected":false}//NO I18N
                            }
                        }
                        OpUtilsClient.IPAMSubnetController.set("adDomainForAddSubnet", {"domainDetails":jsonObj}); //No I18N
                    }
                    }
                }
            });
            $("#wmiScan").prop("checked",true); 
            showHideAdDomain('wmiScan');//NO I18N
                    
        }
        $("#newgroup").prop("disabled","disabled");
        $("#subnetaddr").prop("disabled","disabled");
        $("#subnetmsk").prop("disabled","disabled");
        
        $("#subnetmsk  option").each(function(i) {
            if(subnetmask ===this.value ){
                $("#subnetmsk").prop("selectedIndex",i);
                return;
            }
        });
    },
    updateIPAMSubnet: function()
    {
        updateIPAMSubnet("updateonly");//NO I18N
       
    }
    ,
    updateIPAMSubnetAndScan: function()
    {
        updateIPAMSubnet("updateAndScan");//NO I18N
       
    }
    ,cancelEditSubnetPage:function(){
        location.href = window.apiclientUrl + "IPAM/Group/"+OpUtilsClient.IPAMController.selectedIPAMGroupID+"/SubnetList";//No I18N 
    }
});

OpUtilsClient.IPAMAllIPsView = Ember.View.extend({
    templateName: 'IPAMSubnetList', //No I18N
    didInsertElement: function() {
        $("#settingsicon").hide();
    }
});
OpUtilsClient.IPAMAllAlertsView = Ember.View.extend({
    templateName: 'IPAMAllAlerts', //No I18N
    didInsertElement: function() {
    }
});
OpUtilsClient.IPAMGroupSubnetListView = Ember.View.extend({
    templateName: 'IPAMSubnetList', //No I18N
    didInsertElement: function() {
    }
});

OpUtilsClient.IPAMIPAddressView = Ember.View.extend({
    templateName: 'IPAMIPSnapshot', //No I18N
    didInsertElement: function() {
    }
});
OpUtilsClient.IPAMIPAddressSummaryView = Ember.View.extend({
    templateName: 'IPAddressSummary', //No I18N
    didInsertElement: function() {
    }
});
OpUtilsClient.IPAMIPAddressHistoryView = Ember.View.extend({
    templateName: 'SubnetHistory', //No I18N
    didInsertElement: function() {
    }
});
OpUtilsClient.IPAMIPAddressAlertsView = Ember.View.extend({
    templateName: 'IPAMSubnetAlerts', //No I18N
    didInsertElement: function() {
    }
});

//OPMClient.SettingsCredentialsAddView = Ember.View.extend({templateName: 'SettingsCredentialsAdd'}); //No I18N
OpUtilsClient.IPAMAddAdDomainView = Ember.View.extend({
    templateName: 'IPAMAddAdDomain', //No I18N
    didInsertElement: function() {
    }
});
OpUtilsClient.IPAMAddSubnetView = Ember.View.extend({
    templateName: 'IPAMAddSubnet', //No I18N
    didInsertElement: function() {

        var groupresponse = [];
        $.ajax(
                {
                    url: getOpUtilsAPIURL() + "&operation=GET_GROUP_LIST", //No I18N
                    type: 'GET', //No I18N
                    async: false,
                    success: function(jsonData)
                    {
                        if (Object.keys(jsonData).length > 0)
                        {
                            groupresponse = jsonData;
                            OpUtilsClient.IPAMSubnetController.set("ipamGroupsForAddSubnet", groupresponse.result); //No I18N
                        }
                    }
                });
        $.ajax(
                {
                    url: getOpUtilsAPIURL() + "&operation=GET_AD_DOMAIN_LIST", //No I18N
                    type: 'GET', //No I18N
                    async: false,
                    success: function(jsonData)
                    {
                        if(jsonData.result === undefined){
                            OpUtilsClient.IPAMController.isAddedADDomain = false;
                        }else{
                            OpUtilsClient.IPAMController.isAddedADDomain = true;
                        }
                        if (Object.keys(jsonData).length > 0)
                        {
                            if(jsonData.status !== "Failure"){
                            groupresponse = jsonData;
                            var jsonObj =[];
                            var totalAD = jsonData.result.domainDetails.length;
                            for(i=0;i<totalAD;i++){
                                jsonObj[i] = {"ad-domain-name":jsonData.result.domainDetails[i]["ad-domain-name"],"ad-domain-id":jsonData.result.domainDetails[i]["ad-domain-id"],"isSelected":false}//NO I18N
                            }
                            OpUtilsClient.IPAMSubnetController.set("adDomainForAddSubnet", {"domainDetails":jsonObj}); //No I18N
                        }
                        }
                    }
                });
        $("#pingICMP").prop("checked", true);
        $("#pingSNMP").prop("checked", true);
        $("#dnsresolve").prop("checked", true);
        if (!OpUtilsClient.ApplicationController.isWindowsOS)
        {
            $("#wmiScan").prop("disabled", true);
        }
    },
    addSubnetSubmit: function()
    {
        var subnetAddress = this.get('subnetaddr');

        var subnetMask = $("#subnetmsk").val();
        var ipamgroup = $("#ipamtreegroup").val();
        var subnetName = this.get('subnetname');
        var newGroupName = this.get('newgroup');
        var subnetDesc = this.get('subnetdesc');
        var subnetVlan = this.get('subnetvlan');
        var subnetLocation = this.get('subnetlocation');
        var icmp = $("#pingICMP").prop("checked");
        var snmp = $("#pingSNMP").prop("checked");
        var dnsresolve = $("#dnsresolve").prop("checked");
        var wmiScan = $("#wmiScan").prop("checked");
        var isnewgroup = $("#newIPAMGroup").css("display");

        var addsubnetURL = getOpUtilsAPIURL() + "&operation=ADD_SUBNET&addType=manual&subnetAddress=" + subnetAddress + "&subnetMask=" + subnetMask;//No I18N

        if (isnewgroup !== undefined && isnewgroup === "block" && newGroupName === undefined) {
            alert(Ember.I18n.t('opu.common.PLEASE_ENTER_A_VALUE', this));//No I18N
            $("#newgroup").focus();
            return;
        }

        if (subnetAddress === undefined || !isValidIPAddress(subnetAddress)) {
            alert(Ember.I18n.t('opu.common.EnterSubnet', this));//No I18N
            $("#subnetaddr").focus();
            return;
        }
        if (isnewgroup !== undefined && isnewgroup === "block" && newGroupName !== undefined) {
            addsubnetURL += "&newgroupname=" + trimAll(newGroupName);//No I18N 
        } else {
            addsubnetURL += "&groupId=" + ipamgroup;//No I18N 
        }
        if (subnetName !== undefined) {
            addsubnetURL += "&subnetName=" + trimAll(subnetName);//No I18N 
        }
        if (subnetDesc !== undefined) {
            addsubnetURL += "&desc=" + trimAll(subnetDesc);//No I18N 
        }
        if (subnetVlan !== undefined) {
            addsubnetURL += "&vlanName=" + subnetVlan;//No I18N 
        }
        if (subnetLocation !== undefined) {
            addsubnetURL += "&location=" + trimAll(subnetLocation);//No I18N 
        }
        if (icmp) {
            addsubnetURL += "&ping=1";//No I18N 
        }
        if (snmp) {
            addsubnetURL += "&snmpping=1";//No I18N 
        }
        if (dnsresolve) {
            addsubnetURL += "&dnsresolve=1";//No I18N 
        }
        if (wmiScan) {
            var addomain = $("#addomainlists").val();
            if(addomain === "-1"){
                alert(Ember.I18n.t("opu.common.PLEASE_CHOOSE_AD_DOMAIN",this));//No I18N
                return;
            }
            addsubnetURL += "&wmi=1&adDomain="+addomain;//No I18N 
        }
        opu_showLoadingTextOnReq(true);
        $.ajax({
            url: addsubnetURL,
            type: 'POST', //No I18N
            success: function(response) {
                var obj = response;
                var status = obj.status;
                if ((status !== undefined && status === "Failure") && (obj.message !== undefined))
                {
                    opu_showFailureResponseTextOnDiv(obj.message);
                } else {
                    opu_showSuccessResponseTextOnDiv("opu.ipam.SUBNET_ADDED_SUCCESSFULLY");//NO I18N
                }
            }
        })
    },
    validateCSVImport: function()
    {
        var formdata = new FormData();
        var path = document.getElementById("csvPath");
        formdata.append('csvPath',path.files[0]); //No I18N	
        var filename = $("#csvPath").val();
        if(filename.length == 0)
        {
               alert(Ember.I18n.t("opu.common.InputProperCSV", this));//No I18N
               return;
        }else
        {
           var splitFile = filename.split(".");
            var fileType = splitFile[splitFile.length - 1];
            fileType = fileType.toLowerCase();
            if( fileType !== 'csv')
            { 
               alert(Ember.I18n.t("opu.common.InputProperCSV", this));//No I18N
               return;
            } 
        }
        var addsubnetbycsv = getOpUtilsAPIURL() + "&operation=ADD_SUBNET&addType=import&isScanning=on";//No I18N
        opu_ajaxMultiPostRequest(addsubnetbycsv,formdata,true);
        $("#resDiv").fadeOut(10000);
    },
    resetAddSubnetPage: function()
    {
        location.href = window.apiclientUrl + 'IPAM/Dashboard/top10';//No I18N 
    }
    
});

var gaugeTimers = new Array();
OpUtilsClient.IPAMSubnetSummaryDialView = Ember.View.extend({
	didInsertElement: function(){ 
                    var dialGaugeElement = (this.$().children())[0];
                    var dialDivName = dialGaugeElement.id;
                    var pollId = document.getElementById(dialDivName).getAttribute("data-pollid");
                    var pollPeriod = document.getElementById(dialDivName).getAttribute("data-pollPeriod");
                    var dialValue = document.getElementById(dialDivName).getAttribute("data-dialValue");
                    var dialUnit = document.getElementById(dialDivName).getAttribute("data-dialUnit");
                    var dialEndValue = document.getElementById(dialDivName).getAttribute("data-dialEnd");
                    var deviceName = document.getElementById(dialDivName).getAttribute("data-deviceName");	
                    var gaugeElement = new loadD3Gauge(dialDivName,dialValue,dialEndValue,dialUnit,pollId);
                    var param = "pollId";//No I18N
                    if(pollId !== null && pollPeriod !== null)
                    {				
                            if(pollId === "availability" || pollId === "packetLoss" || pollId === "responseTime")
                            {
                                    pollPeriod = pollPeriod*60;
                                    param = "instance";//No I18N
                            }
                            gaugeTimers.push(setInterval(function(){reloadD3Gauge(gaugeElement,pollId,param,deviceName)},pollPeriod*1000));
                    }
	},
	willDestroyElement: function(){
		for(i=0;i<gaugeTimers.length;i++)		    
		{
			clearTimeout(gaugeTimers[i]);
		}
	}
});

var flipCounters = new Array();
OpUtilsClient.IPAMSubnetSummaryCounterView = Ember.View.extend({
	didInsertElement: function(){ 
                    var counterElement = (this.$().children())[0];
                    var counterDivName = counterElement.id;
                    var deviceName = document.getElementById(counterDivName).getAttribute("data-deviceName");		
                    var counterValue = document.getElementById(counterDivName).getAttribute("data-counterValue");
                    var pollId = document.getElementById(counterDivName).getAttribute("data-pollid");
                    var pollPeriod = document.getElementById(counterDivName).getAttribute("data-pollPeriod");

                    if(counterValue !== "NA" && counterValue !== null)
                    {
                            if(counterValue.indexOf("ms") !== -1)
                            {
                                    var pollVal = parseInt(counterValue.substring(0,counterValue.indexOf("ms")));

                            }
                            else
                            {
                                    var pollVal = parseInt(counterValue);
                            }
                            var flipCounterElement = new flipCounter(counterDivName, {inc:0, value: pollVal});
                            var param = "pollId";//No I18N
                            if(pollId !== null && pollPeriod !== null)
                            {
                                    if(pollId === "availability" || pollId === "packetLoss" || pollId === "responseTime")
                                    {
                                            pollPeriod = pollPeriod*60;
                                            param = "instance";//No I18N
                                    }
                                    flipCounters.push(setInterval(function(){reloadCounter(flipCounterElement,deviceName,pollId,param)},pollPeriod*1000));
                            }
                    }
                    else
                    {
                            $("#"+counterDivName).html("<img src='images/na.png' />");//No I18N
                    }
	},
	willDestroyElement: function(){
		for(i=0;i<flipCounters.length;i++)		    
		{
			clearTimeout(flipCounters[i]);
		}
	}
});


OpUtilsClient.IPAMDashboardView = Ember.View.extend({
    templateName: 'IPAMDashboard',didInsertElement:function(){//No I18N
            $.ajax({		
                url: getOpUtilsAPIURL() + "&operation=GET_IPAM_GROUPS",//NO I18N
                type: 'GET', //No I18N		
                dataType:'json', //No I18N
                async: false,//No I18N
                success: function(ipamTreeGroups)		
                {
                   var menuLinkArray = ipamTreeGroups.result.ipv4Nodes;
                   var totalSubnetCount = menuLinkArray[0]["subnet-count"];//Total Subneta count
                   if(totalSubnetCount === 0){
                        location.href = window.apiclientUrl + "IPAM/AddSubnet";//No I18N
                        $( "#ipamList" ).accordion({ active: 1 });
                   }
                }
            })
            
    }

});	//No I18N


OpUtilsClient.IPAMDashWidgetView = Ember.View.extend(
{
	didInsertElement: function()
	{
		var widgetElement = (this.$().children())[1]; 
		var tableElement = (this.$().children())[2]; 
		var tableId = tableElement.getAttribute("id");

		var widgetId = widgetElement.getAttribute("data-widgetId"); //No I18N
		var widgetName = widgetElement.getAttribute("data-widgetName");   //No I18N
		var widgetUniqueId = widgetElement.getAttribute("id");   //No I18N
		var oputilstool = widgetElement.getAttribute("oputilstool");   //No I18N
		loadWidgets(widgetElement,tableElement,tableId,widgetId,widgetName,widgetUniqueId,oputilstool);
		if(true)//if(window.isAuthorized)
		{
			$('.dashboardCol').sortable({//No I18N
			connectWith: '.dashboardCol',//No I18N
			handle: 'header',//No I18N
			cursor: 'move',//No I18N
			placeholder: 'placeholder',//No I18N
			forcePlaceholderSize: true,
		//	opacity: 0.4,	
			stop: function(event, ui)
				{
					$(ui.item).find('header').click();
					var sortorder='';
					var hgtArr = new Array();
					$('.dashboardCol').each(function(){ 
						var itemorder=$(this).sortable('toArray');
						var columnId=$(this).attr('id');
						hgtArr.push($(this).height());
						sortorder+=columnId+'='+itemorder.toString()+'&';
					});

					sortorder = sortorder.substring(0, sortorder.length - 1);
					hgtArr.sort(function(a, b){return a-b});
					var positionArray = new Array();

					var classCount = $("#dashBoardDiv .dashboardCol").length;

					var sfr = new Array();

					for (var i = 0; i<classCount; i++)
					{
						var coun = "col_"+(i+1);//No I18N
						$("#"+coun).css("height",hgtArr[hgtArr.length-1]+"px");//No I18N
						sfr = $("#"+coun+" .dragWidgets");//No I18N
						newloc = i;			//location of the first widget is same as columns index
						for (var j = 0; j < sfr.length; j++)
						{
							if(sfr[j].className === 'dragWidgets')
							{
								var widget_id = (sfr[j].getAttribute("id")).split("_");
								positionArray.push(widget_id[1]+"_"+newloc);
								newloc+=classCount;
							}
						}
					}

				}
			}).disableSelection();
		}
	}
});

function addADDomain(){
    
    var data = validateADDomain();
    if(!data){
        return;
    }
    document.getElementById("resDiv_popup1").style.display = 'block'; //No I18N
    document.getElementById('resDiv_popup1').style.backgroundColor = '#FFFFFF';//No I18N 
    document.getElementById("resDiv_popup1").innerHTML = Ember.I18n.t('opu.common.PROCESSING_PL_WAIT',this);//No I18N
    
    var url = getOpUtilsAPIURL() + "&operation=ADD_DOMAIN";//No I18N
//        var data = {'domainName':addomain,'controllerName':adcontroller,'loginName':aduser,'password':adpwd}; //No I18N
        $.ajax({
                url:url,
                type:'POST', //No I18N
                async:false,
                data:data,
                success: function(jsonData){
                    if(jsonData.status === "Success"){
                        $('#addAdDomainpopUp').dialog("close"); //No I18N
                        var adlists = document.getElementById('addomainlists');
                        var option = document.createElement('option');//No I18N
                        option.innerText = addomain;
                        option.setAttribute('selected', true);//No I18N
                        adlists.appendChild(option);
                    }else{
                        opu_showFailureResponseTextOnDiv(jsonData.message,'resDiv_popup1'); //No I18N
                    }
                }
        });
}
function updateIPAMSubnet(updateFor){
     var subnetAddress = $("#subnetaddr").val();
        var subnetMask = $("#subnetmsk").val();
        var subnetName = $("#subnetname").val();
        var groupName = $("#newgroup").val();
        var subnetDesc = $("#subnetdesc").val();
        var subnetVlan = $("#subnetvlan").val();
        var subnetLocation = $("#subnetlocation").val();
        var icmp = $("#pingICMP").prop("checked");
        var snmp = $("#pingSNMP").prop("checked");
        var dnsresolve = $("#dnsresolve").prop("checked");
        var wmiScan = $("#wmiScan").prop("checked");
        
        if (icmp) {
            icmp = "on";//NO I18N
        }else{
            icmp = "off";//NO I18N
        }
        if (snmp) {
            snmp = "on";//NO I18N
        }else{
            snmp = "off";//NO I18N
        }
        if (dnsresolve) {
            dnsresolve = "on";//NO I18N
        }else{
            dnsresolve = "off";//NO I18N
        }
        if (wmiScan) {
            wmiScan = "on";//NO I18N
        }else{
            wmiScan = "off";//NO I18N
        }
        opu_showLoadingTextOnReq(true);
        var subnetid =$("#subnetid").val();
        $.ajax({
            url: '/oputilsapi/ipam?key='+getOpUtilsAPIKey(),//NO I18N
            type: 'POST', //No I18N
            data: {"v":"1","format":"json","operation":"UPDATE_SUBNET_DETAILS","callFor":updateFor,"parentPath":groupName,"NETWORKADDRESS":subnetAddress,"subnetName":subnetName,"location":subnetLocation,"desc":subnetDesc,"vlanName":subnetVlan,"ping":icmp,"snmpping":snmp,"dnsresolve":dnsresolve,"wmi":wmiScan,"mask":subnetMask,"NETID":subnetid},//No I18N
            success: function(response) {
                var obj = response;
                var status = obj.status;
                if ((status !== undefined && status === "Failure") && (obj.message !== undefined))
                {
                    opu_showFailureResponseTextOnDiv(obj.message);
                } else {
                    location.href = window.apiclientUrl + "IPAM/Group/"+OpUtilsClient.IPAMController.selectedIPAMGroupID+"/SubnetList";//No I18N    
                }
            }
        })
}



